package displayPack;

import java.util.Vector;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import utilPack.Util;

/**
 * 
 * to send an XML form of the menu structure to the web client
 *
 */

public class MenuElement {
	
	private String itemName;
	
	private Vector<MenuElement> childElements = new Vector<MenuElement>();
	
	public boolean isMenu() {return (childElements.size() == 0);}
	
	private int depth = 0;
	public void setDepth(int depth) {this.depth = depth;}
	
	//-----------------------------------------------------------------------------
	//                              Constructor
	//-----------------------------------------------------------------------------
	
	public MenuElement(String name)
	{
		itemName = name;
	}
	
	public void addChild(MenuElement child) 
	{
		child.setDepth(depth + 1);
		childElements.add(child);
	}
	
	//-----------------------------------------------------------------------------
	//                      XML form for web client
	//-----------------------------------------------------------------------------
	
	
	/**
	 * xml form of this MenuElement and its descendants
	 * @param doc
	 * @return
	 */
	public Element xmlForm(Document doc)
	{
		String tagName = "menuItem_" + depth;
		Element top = doc.createElement(tagName);
		top.setAttribute("name", itemName);
		
		for (MenuElement child: childElements) top.appendChild(child.xmlForm(doc));
		
		return top;
	}
	
	//-----------------------------------------------------------------------------
	//                        diagnostic write            
	//-----------------------------------------------------------------------------
	
	/**
	 * 
	 * @param indent
	 */
	public void write(String indent)
	{
		Util.message(indent + itemName);
		String nextIndent = "   " + indent;
		
		for (MenuElement child:childElements) child.write(nextIndent);
	}
	

}
