package generatorPack;

/**
 * a part of a learning example -
 * some contiguous sequence of words arising from a Category
 *
 */

public class ExamplePart {
	
	private ExGenerator generator;
	
	private Category cat;
	
	private Production prod;
	
	private String word = null;
	
	
	
	
	//--------------------------------------------------------------------------
	//	                        Constructor
	//--------------------------------------------------------------------------
	
	public ExamplePart(ExGenerator generator, Category cat) throws Exception
	{
		this.generator = generator;
		this.cat = cat;
		
		// get a random production from the category
		prod = cat.getRandomProduction();
		
		if (prod == null) throw new Exception("Could not make a production for category " + cat.getName());
		
	}
	
	//--------------------------------------------------------------------------
	//	                        Methods
	//--------------------------------------------------------------------------
	
	
	/**
	 * 
	 * @return the string or words
	 * @throws Exception
	 */
	public String getWords() throws Exception
	{
		String words = "";
		if (prod.isLeaf()) words = prod.getRandomWord();
		else
		{
			for (Category c: prod.getCategories())
			{
				ExamplePart part = new ExamplePart(generator,c);
				words = words + part.getWords();
				if (!words.endsWith(" ")) words = words + " ";
			}
		}
		if (words.length() == 0) throw new Exception("Example part for category " + cat.getName() + " gives no words");
		if (words.startsWith(" ")) throw new Exception("Example part for category " + cat.getName() + " gives words '" + words + "'");
		return words;	
	}

}
