package learnerPack;

import java.util.Vector;

import modelPack.FSNode;

public class ParseResult{
	
	// words unified with the sounds-only example, in order of unification
	private Vector<LearntWord> wordsApplied; 
	public Vector<LearntWord> getWordsApplied() {return wordsApplied;} 
	
	public boolean someUnify() {return wordsApplied.size() > 0;}
	
	
	/**
	 *  first element is the sounds-only learning example. 
	 *  Later elements are the results of unification, i.e:
	 *  - they have used nodes in them
	 *  - they do not have the inferred meaning as a final scene
	 *  - they have result meanings interspersed with the sounds
	 */
	private Vector<FSNode> results;
	public Vector<FSNode> getResults() {return results;}
	
	double score;
	
	//---------------------------------------------------------------------
	//                          constructors
	//---------------------------------------------------------------------
	
	public ParseResult(FSNode starter)
	{
		wordsApplied = new Vector<LearntWord>();
		results = new Vector<FSNode>();
		results.add(starter);
		score = 0.0;		
	}
	
	
	public ParseResult(Vector<LearntWord> wordsApplied, Vector<FSNode> results, double score)
	{
		this.wordsApplied = wordsApplied;
		this.results = results;
		this.score = score;
	}
}

