package mainPack;

import displayPack.VFrame;
import generatorPack.ExGenerator;
import modelPack.LanguageModel;
import utilPack.Util;

public class MainClass {
	
	private VFrame frame;
	public VFrame getFrame() {return frame;}

	private LanguageModel model;
	
	private ExGenerator generator;
		
	// if this location does not work, allow the user to choose a language model file
	String modelFileLocation = "C:\\Language\\langFiles.txt";
	
	/**
	 * 
	 */
	public MainClass()
	{
		try
		{
		    // make the user window (initially large size). true = show it
			frame = new VFrame(true);
		    
		    // read the language model data
	    	model = new LanguageModel(frame,modelFileLocation);

	    	// in the workbench, false means read data from files, not the data class
	    	model.readModel(false);		
		    
		    // tell the user window the model, so it can set up menus
			frame.setModel(model);
		    
		    // show the initial user guide topic
			frame.getAct().showInitialTopic();
			
			// if necessary, overwrite this with validation errors detected in the language model
			model.writeValidationErrors();
		    
		    // show the updated frame
			frame.validate();
			
			// start the learning example generator, and tell the frame about it
			boolean forWeb = false;
			generator = new ExGenerator(model,forWeb);
			frame.setExGenerator(generator);
			
			// test of server init()
			// generator.setupLearningCycles();
		    
		}
		catch (Exception ex) {Util.message("Exception starting: " + ex.getMessage()); ex.printStackTrace();}
	}

	
	
	  //------------------------------------------------------------------------------------------------
	  //                              main method
	  //------------------------------------------------------------------------------------------------

	  public static void main(String[] args) {
	    new MainClass();
	  }

	  public void frameMessage(String s) {getFrame().frameMessage(s);}
	  

}
