package utilPack;

import java.util.Vector;


public class GenerateLearntDataClass {
	
	String learnXML;
	String explainXML;
	String menuXML;
	
	public GenerateLearntDataClass(String learnXML,String explainXML,String menuXML) 
	{
		this.learnXML = learnXML;
		this.explainXML = explainXML;
		this.menuXML = menuXML;
	}
	
	
	/**
	 * 
	 * @return
	 */
	public Vector<String> generateDataLines()
	{
		Vector<String> lines = new Vector<String>();
		
		lines.add("package utilPack;");
		lines.add("");
		lines.add("import java.io.ByteArrayInputStream;");
		lines.add("import java.io.InputStream;");
		lines.add("");
		lines.add("/**");
		lines.add(" * this class is generated, to hold XML files created by a run of automatic learning as strings,");
		lines.add(" * so that the language demonstrator with automatic learning can run as a Java servlet,");
		lines.add(" * using no data files.");
		lines.add(" *");
		lines.add("*/");
		lines.add("");
		lines.add("public class LearntDataClass {");
		lines.add("	");
		lines.add("	private static String learningData = " + "\"" + learnXML + "\";");
		lines.add("	private static String explainData = " + "\"" + explainXML + "\";");
		lines.add("	private static String menuData = " + "\"" + menuXML + "\";");
		lines.add("	");
		lines.add("// true if this class can return real data");	
		lines.add("  public boolean isLoaded() {return loaded;}");
		lines.add("  private boolean loaded = false;");
		lines.add("  public void setLoaded(boolean loaded) {this.loaded = loaded;}");
		lines.add("");	
		lines.add("	public static InputStream getDataStream(int type) throws Exception");
		lines.add("	{");
		lines.add("		String data = getData(type);");
		lines.add("		byte[] bytes = data.getBytes();");
		lines.add("		return new ByteArrayInputStream(bytes);");
		lines.add("	}");
		lines.add("");	
		lines.add("	private static String getData(int type)");
		lines.add("	{");
		lines.add("		if (type == 0) return learningData;");
		lines.add("		if (type == 1) return explainData;");
		lines.add("		if (type == 2) return menuData;");
		lines.add("		return \"\";");
		lines.add("	}");
		lines.add("");
		lines.add("}");
		
		return lines;
	}

	
	
}

