package utilPack;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

/**
 * this class is generated , to hold all the model XML files as strings,
 * so that the language demonstrator can run as a Java servlet,
 * using no data files.
 *
*/

public class DataClass {
	
	private static String guideData = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?><model><guide><topic name=\"Getting Started\"><topic name=\"How to Use this Model\"><p>This demonstration has two parts:</p><p>(A) An automated [bLanguage Learner[, which learns about 40 words from a standing start, using generated learning examples.</p><p>(B) A demonstration of the capabilities used by the learner.</p><p>To see the automatic learning (A), keep pressing the [bAuto-Learn[ button, and use the [bLearning[ menu to inspect the words learnt, as learning proceeds.</p><p>Words are shown as tree-like [bFeature Structures[, containing the sounds, meaning and syntax of each word.</p><p>The learning model is described in papers you can [ldownloads.html&amp;download[ from this site.</p><p>------</p><p>For the demonstration (B) of language capabilities, you can:</p><p>(1) Use the [bLearning[ menu to display a word, then use the [bLearn[ button to see how a child can learn that word from examples.</p><p>(2) Use the [bSentences[ menu to display a sentence or phrase. Then use the [bUnderstand[ button to see how we understand it when we hear it.</p><p>(3) For any sentence, use the [bGenerate[ button to see how we generate words from its meaning, in order to to speak it.</p><p>(4) Use the [bCompose[ button to make up a new sentence (using words in the model), and the model will try to understand it.</p><p>You can also:</p><p>(5) Use the [bWords[ menu to select any word and look at its feature structure.</p><p>(6) Use the [bHelp[ menu to find out how the model works.</p><p>(7) Use the [bModel[ menu to explore the nodes and slots used in feature structures.</p><p>Make your browser window as large as you can.</p></topic><topic name=\"The Automatic Learner\"><p>The  learning program learns the feature structures for about 40 words from 800 learning examples, with no manual supervision. The feature structure for each word contains its sound, its meaning and its syntax (how it can unify with other feature structures to make complex meanings). At the start, the learner knows no words.</p><p>Words are learnt from a sequence of  generated  [bLearning Examples[. Each learning example is a feature structure containing the sounds of an utterance (as heard by the learner), and a meaning, which the learner infers that the speaker intends in the context. For some of the learning examples, the learner infers an incorrect meaning; for the other examples, the learner infers the correct meaning (with some extra parts of meaning observed by the learner, that the speaker did not express).</p><p>Learning examples are sentences or phrases randomly generated from a set of about 44 words, which are in a few grammatical categories such as noun, adjective, transitive verb and intransitive verb. The categories are not known to the learner. Meanings of the learning examples are made by unifying the word feature structures, which is the process used by the speaker to produce the words, or by an adult listener to understand them. </p><p>When you first press the Auto-Learn button, the demonstration will show the words used to generate the learning examples - which are the words that the learner can learn. The words are grouped by their [bProductivity[, which has four values depending on the number of constructions required before each word and after it. These productivities are: (0,0) for nouns, which require no constructions before them or after them; (0,1) for adjectives and possessives, which require a construction describing a thing to follow them; (1,0) for intransitive verbs, which require an agent before them; and (1,1) for transitive verbs, which require both an agent and a patient.</p><p>Each subsequent press of the Auto-Learn button replays a [bCycle[ of 100 learning examples. Learning is done by [bgeneralisation[ of the learnng examples. The learner selects pairs of learning examples which both contain the same word sound, and generalises them together. Generalisation is mathematically defined, and it projects out (at least) the word sound and meaning - possibly with extra coincidentally matching sounds and meanings in the two examples, which will be removed by later generalisations.</p><p>After each cycle, the demonstration shows the 100 learning examples in the cycle, and shows the sounds and the productivities of all the words learnt so far. The learnt word feature structures can be inspected using the '[bLearning[ menu. You can compare each learnt word feature structure with the word feature structure which was used to make the learning examples. Usually the two are identical, or very similar; learning is accurate. You can see how the word was learnt, by generalising a small set of the learning examples containing it.</p><p>Any word is initially learnt in its unproductive (0,0) form, because this learning does not require any knowledge of any other words. Later, when some other words are known, each word is [bpromoted[ to its most productive form, using the same generalisation process.</p><p>Because learning is a statistical process, it makes a few errors, which we assume will be  ironed out over time. After 800 learning examples, the learner typicslly learns about 40 of the 44 words used to make the learning examples - most words in their fully productive form. A child could use the learnt words to understand and produce sentences, as shown in the general demonstration.</p><p>You can download the learning application to see other runs of the learner - possibly editing the language model to add more words, more parts of speech, more learning examples, and so on.</p></topic><topic name=\"Looking at Feature Structures\"><p>This model of language is built using [bfeature structures[, and you will see many of them in the model. You can become familiar with the ideas of feature structures, by looking at some of them. Use the menu option [bWords &gt; B &gt; Boy[ to show the feature structure for the word 'boy':</p><p>centre.600.300.boyWord.jpg</p><p>A feature structure is a tree-like structure, with information held in named [bslots[ on the nodes of the tree. The root 'script' node of the tree is shown on the left, and the tree  branches out to the right of it.</p><p>At the top are the sounds of the word 'boy' - yellow 'sound' boxes with the sound (of each phoneme-like unit of sound) shown after the box. These are to be read top to bottom, in time order.</p><p>At the bottom is a subtree branching from the orange  'scene' box, which denotes the meaning of 'boy' - in this case, a young, male, person</p><p>Nodes are the  boxes in feature structures. There is a small number of allowed node types, indicated by the text in the node box.</p><p>Slots carry the information in nodes. Each slot has a [bslot name[ and a set of possible [bvalues[. Slot names and values are shown as text below the node boxes. To see the meaning and possible values for any slot, or to see the type of any node, hover the mouse over it:</p><p>centre.900.330.hover.jpg</p><p>The feature structures for verbs and other non-nouns have links across the branches of the trees, shown in the model as curved lines. This is shown below for the verb 'eats' :</p><p>centre.600.600.verb.jpg</p><p>These links are called [bsubsumption links[, and they play a key role in the productivity of language. They are like pipes to move meanings from one part of a feature structure  to another. They allow us to pull apart a complex meaning, to express it in words with smaller meanings; or to assemble a complex meaning from the simpler meanings of words, to understand what we hear. </p><p>'Eats' is a transitive verb and has two subsumption links - one for the agent who is eating, and one for the patient which is being eaten. These links enable it to assemble the agent, verb and patient into a single meaning scene. You can see how subsumption links  work in many  examples in the model.</p><p>The 'scene' and 'sound' nodes are again to be read from top to bottom, in time order. First there is a meaning scene representing the person who is eating; then there are the sounds for 'eats'; then there is a meaning scene representing the thing being eaten. Finally, at the bottom (outside the time order) there is a scene representing the whole act - eater, eaten thing, and the act of eating. In its vertical time ordering, this feature structure embodies the English subject-verb-object order for 'eats'.</p></topic><topic name=\"First Example of Learning\"><p>To see a first example of language learning, use the menu option: [bLearn &gt; One word stage &gt; B &gt; boy[; then press the [bStep[ button repeatedly. This shows the steps in learning the word 'boy'. Each step uses the operation of [bGeneralisation[, which combines two feature structures to make a more general one, which only has the information content they share - where they match each other.</p><p>The model assumes that on some occasions when a child hears a word spoken in a sentence or phrase, the child understands what the speaker is referring to. Then the child makes a feature structure which includes both the sounds she hears, and the speaker's meaning that she infers. These are called [blearning examples[, and they are the first two feature structures in the demo.</p><p>These two feature structures describe the sounds the child hears, which are 'small boy' and 'boy runs', and the meaning structures that the child observes on each occasion. These meanings contain the speaker's meaning, and other (possibly irrelevant) meanings, observed by the child.</p><p>The operation used for learning is generalisation.To form the generalisation of two feature structures, you retain all  the parts where they match - and throw away the other parts.</p><p>In this case, from the sounds, generalisation retains only the sounds of the word boy; and from the meanings, it retains only the slots describing a young male person. Everything else does not match, and is thrown away. This is shown below:</p><p>centre.1200.400.boylearn.jpg</p><p>The resulting feature structure is shown next, after the two learning examples (on the right of the picture ). It contains only the sound 'boy' and the meaning of a boy; so it pairs the sound with its meaning. This is the feature structure for the word boy; it is what the child needs to learn, in order to understand the sound boy when she hears it again</p><p>For other parts of speech such as verbs, the child needs to learn how a verb ties together the meanings of various part of a sentence (such as noun phrases) to make a meaning for the whole sentence. A child needs to learn [bsubsumption links[, for productive language use. This learning also uses the operation of generalisation, in a more powerful way, to learn subsumption links. This is shown in learning verbs and other words.</p></topic><topic name=\"First Example of Productive Language\"><p>A central mystery of language is how it is so productive - how we can combine words in novel ways to express countless new meanings, including things that have never been said before.This model demonstrates how language is so productive.</p><p>A simple example of productivity is to combine an intransitive verb (like 'sleeps', 'sits', or 'runs') with a noun phrase (like 'Anna', 'the boy',or 'Mummy'). If you know some number V of intransitive verbs, and know some number N of nouns, the number of meanings you can express is the product V*N.  As the number of words in a sentence grows, the number of possible meanings grows exponentially.</p><p>Meanings in feature structures are productive. One 'scene' subtree of a feature structure can describe many different actors, doing many different things (acts).The scene node can have a subtree of other nodes, each with slot  values, carrying information.To express this in words, your brain needs to split apart this meaning scene and its subtree, into a separate 'actor' part and an 'act' part. Then each part can be expressed by a word or phrase.</p><p>Your brain splits the meaning apart by unifying feature structures. To see a simple example, first show the feature structure for the sentence 'the boy runs', by using the menu action [bSentences &gt; T &gt; 'the boy runs'[.</p><p>You will see a feature structure showing  both the sounds and the meaning of the sentence. Then use the [bGenerate[ button to see how a speaker creates the sounds from the meaning; or use the [bUnderstand[ button to see how a listener builds the meaning from hearing the sounds. Each of these buttons should be followed by repeated presses of the [bStep[ button, to go through the unification steps of generating or understanding a sentence. One of the steps in generating 'boy runs' is shown below:</p><p>centre.1400.400.boyruns.jpg</p><p>Stepping through the model process shows how a speaker pulls apart a sentence meaning into separate word meanings - or how a listener reassembles those word meanings into a single sentence meaning scene. The single operation of unification does both of these; it can work both ways, turning meanings into sounds, or sounds into meanings. How it does so is explained later in these help pages, and in the paper.</p></topic></topic><topic name=\"Menus\"><topic name=\"Help\"><p>The Help menu has a series of topics, which explain the model of language learning and the demonstrations.</p><p>Select any topic to see it displayed in the explanation area.</p></topic><topic name=\"Words\"><p>This menu shows all the feature structures for words which are used to understand sentences, or to generate (speak) sentences, or used when learning other words.</p><p>Words are grouped alphabetically. If you select the menu item for a word, the feature structure for the word is shown in the central main area, as in the example below, showing the word 'fell':</p><p>centre.500.400.fell.jpg</p><p>This feature structure shows the sounds of the word (roughly, like phonemes), and shows its meaning scene at the bottom. In the concise notation, shown here, the sounds are written horizontally, as in one word. Use the [bShow[ button to show the separate phonemes, which when we hear them are not grouped into words.</p><p>For verbs, adjectives and most parts of speech except nouns, there are other input meaning parts, which contribute to the meaning of the word in a sentence. For instance, verbs have an agent, and they may have a patient and other roles. These are all represented as meaning scenes.</p><p>The curved arcs in the feature structures for many words are [bSubsumption Links[ . These are the key to the productivity of language, and they act as 'pipes' conveying meaning from one part of a feature structure to another. When generating speech, they pull meanings apart to be expressed by separate words. In understanding, they reassemble the meanings of words into one final meaning scene.</p></topic><topic name=\"Sentences\"><p>This menu shows some sample sentences or fragments of sentences, grouped alphabetically. A fragment is some sequence of sounds that can be understood as one meaning scene. So 'green apple' is a fragment, but 'green hot' or 'apple green'  are not.</p><p>If you select any sentence or fragment, it will be displayed as a feature structure. This feature structure is a sound-meaning structure (called SMS), which shows both the sounds of the sentence (from the top down) and its meaning (the tree at the bottom). An example is shown below, for the sentence 'Ben gave Anna the shoes'.</p><p>centre.800.600.BenGave.jpg</p><p>The bottom meaning scene shows a complex meaning in which Ben (the agent) caused the shoes to move along a path to a 'place' which is in the possession of Anna. In the model, you can hover the mouse over any slot to see what it means.</p><p>(you need not worry about the fine details of the meaning representations. These representations are probably simpler than those used in the brain, and are somewhat arbitrary, The feature structure model of language will work with a wide range of choices of node types and slots.)</p><p>The sounds above are grouped into words, for ease of reading. As we hear them, sounds are not divided into words, but are a stream of phonemes, which you can see by using the '[bShow/Hide[ button.</p><p>After selecting any sentence, the two buttons [bUnderstand[ and [bGenerate[ are both enabled. Use these buttons followed by the [bStep[ button to step through the sequence of unifications by which the sentence sounds are converted to meanings (to understand it), or by which a meaning is converted to a sequence of sounds (to generate and speak the sentence). </p><p>The division between 'words' and 'sentences' is somewhat arbitrary. They are really just ends of a continuum of language [bconstructs[, of varying complexity and productivity. The feature structure model works across the whole continuum.</p></topic><topic name=\"Learning\"><p>The Learning menu has one appearance when the automatic learner has been run, a different appearance when it has not.</p><p>If the learner has been run through some learning cycles, the Learning menu shows those words it has learnt in the cycles so far, grouped by their productivity (which is the number of meaning scenes required before and after the word sounds):</p><p>- Productivity (0,0) words are nouns and pronouns</p><p>- Productivity (0,1) words are adjectives and possessives</p><p>- Productivity (1,0) words are intransitive verbs</p><p>- Productivity (1,1) words are transitive verbs.</p><p>By selecting a word, you can see its feature structure as it has been learnt up to that cycle. If you inspect a word after only 1 - 4 learning cycles, there may be errors  in its feature structure (differences from the feature structure of the word used to make learning examples). After running all 8 learning cycles, the words will be more accurate.</p><p>By pressing the 'Learn' button followed by the 'Step' button, you can then see some of the learning examples that were generalised to learn the word, and the results of the generalisation. This shows only a small sample of the examples used to learn the word, and generalising only those examples may not give a very accurate version of the word. It gives an impression of the learning process.</p><p>-------</p><p>If the automatic learner has not been run, the Learn menu shows hand-crafted examples of language learning, grouped in overlapping stages in chronological order of learning stage.</p><p>In the 'One Word' stage, there are examples of learning single words or non-producting 'canned phrases' - to associate the word or phrase sound with its meaning, without learning any syntax.</p><p>In the 'Two-three word' stage, the examples show learning of the syntax of verbs and adjectives. These are sufficient to understand and speak two- and three-word sentences.</p><p>The 'Small word' stage learns words which are useful in assembling larger phrases and clauses, to move on to essentially the full productivity of language.</p><p>In the 'Regular grammar' stage, examples show how the child moves from learning specific words to learning the regular general constructs of a language.</p><p>These examples cover the early stages of language learning.  The same principles  (of feature structure generalisation) apply to all stages of language learning.</p><p>After you have selected a word or construct to learn, use the [bLearn[ button, followed by the [bStep[ button to run the steps of learning that word or construct.</p><p>Learning works by generalisation of learning examples. Each learning example is a feature structure consisting of sounds heard by a child, and the meaning that she infers the speaker is referring to. Generalisation combines two feature structures to make a simpler one.</p><p>After the single word stage, the child uses previously learned words to learn more complex word feature structures, such as those for verbs. This requires the child to learn the subsumption links (curved lines in the model) of those feature structures. Generalisation of feature structures infers the subsumption links from the learning examples.</p></topic><topic name=\"Model\"><p>This menu describes the nodes and slots in the  feature structure model of meanings.</p><p>The Nodes sub-menu describes all the node types in feature structures - how they are used, and what node types they can have as children.</p><p>Slots are grouped alphabetically. The item for each slot describes what the slot means, and what are its possible values.</p><p>You can also see help about each node type of slot by hovering the mouse over it, when any feature structure is shown. This is sufficient for most slots except the most fine-grained slots like 't_type', which have many possible values in a tree structure of general and more special values. For those slots, this menu item shows all possible values in the tree. </p></topic></topic><topic name=\"Buttons\"><topic name=\"Auto-Learn\"><p>A run of the automatic learning program can be replayed by repeatedly pressing the [bAuto-Learn[ button. The same recorded run is replayed each time; to see different runs, download the learning program and re-run it.</p><p>When you first press the Auto-Learn button, the demonstration will show the 44 words used to generate all the learning examples - which are the words that the learner can learn. The words are grouped by their [bProductivity[, which has four values depending on the number of input meanings required before each word and after it. These productivities are: (0,0) for nouns, which require no constructions before them or after them; (0,1) for adjectives and possessives which require a construction describing a thing to follow them; (1,0) for intransitive verbs, which require an agent before them; and (1,1) for transitive verbs, which require both an agent and a patient.</p><p>Each subsequent press of the Auto-Learn button replays a [bcycle[ of 100 learning examples. After each cycle, the demonstration first shows the 100 learning examples in the cycle, and then displays the names and the productivities of all the words learnt so far. The learnt word feature structures can be inspected using the '[bLearning[ menu. You can visually compare each learnt word feature structure with the (hand-made) word feature structure which was used to make the learning examples, selected from the [bWords[ menu. You can use the [bLearn[ button to see how the word was learnt, by generalising a small set of the learning examples containing it.</p><p>Any word is initially learnt in its unproductive (0,0) form, because this learning does not require any knowledge of any other words. Later, when some other words are known, each word can be [bpromoted[ to its most productive form. You will see this happening in later learning cycles.</p><p>Because learning is a statistical process, it makes a few errors, which will be  ironed out over time. After 8 cycles of 100 learning examples, the learner has learnt about 40 of the 44 words used to make the learning examples - many of them  in their most productive form.</p></topic><topic name=\"Generate\"><p>The [bGenerate[ button is enabled after you have selected a sentence from the Sentences menu,  showing the feature structure tree for its sounds (yellow nodes) and meaning (single orange 'scene' node and its subtree).</p><p>Pressing the Generate button starts the process of generating the sounds of the sentence (to be spoken)  from its meaning. You carry on the process by successive presses of the [bStep[ button.</p><p>The  process starts with only the meaning of the sentence, beneath a single orange 'scene' node. At each step, the model unifies the current feature structure with the feature structure for a word. Orange scene nodes are progressively converted to yellow sound nodes, until only sounds are left - sounds to be said.</p><p>(the model does not yet represent the process of choosing the most appropriate words. In each step of generation, a word should be chosen by finding the best match between the meaning part of a known word, and some remaining meaning scene . This is not yet modelled, but could be.)</p><p>Unification is really an additive process; under successive unifications with words, the feature structure for the sentence grows. Sound and meaning nodes are never really removed by unification - they are just used up, and not available for later unifications. This is only shown if you use the [bShow/Hide[ button, to reveal all the nodes in the feature structure which have been used in previous unifications, and are not available for later unifications. Until you press the Show button, those nodes are hidden for simplicity. This gives a picture in which sound or meaning nodes appear to be  'consumed' by unification. They are not really consumed.</p></topic><topic name=\"Understand\"><p>The [bUnderstand[ button is enabled after you have selected a sentence or fragment from the Sentences menu,  showing the feature structure tree for its sounds (yellow nodes) and meaning (single orange 'scene' node and subtree).</p><p>Pressing the Understand button starts the process of generating the meaning of the sentence from the syllables heard. You carry on the process by successive presses of the [bStep[ button.</p><p>The  process starts with only the sounds of the sentence, in yellow sound nodes. At each step, the model unifies the current feature structure with the feature structure for a word matching the sound. At each step,yellow sound nodes are converted to  orange scene nodes, until only one meaning scene is left. This is the understood meaning of the sentence.</p><p>(the model does not represent the process by which the symbolic meaning structure gives rise to a mental image, which can then be consciously experienced)</p><p>Unification is really an additive process; under successive unifications with words, the feature structure grows. Sound and meaning nodes are never really removed by unification - they are just used up and not available for later unification. This is only shown if you use the [bShow/Hide] button, to reveal all the nodes in the feature structure which have been used in previous unifications, and are not available for later unifications. Until you press the Show button, those nodes are hidden for simplicity. This gives a picture in which sound or meaning nodes appear to be 'consumed' by unification. They are not really consumed.</p></topic><topic name=\"Learn\"><p>The [bLearn[ button is enabled after you have selected a word to learn, from the 'Learn' menu.</p><p>Pressing the Learn button displays the word feature structure to be learned, and the first two learning examples, to start the learning process. Subsequent presses of the [bStep[ button generalise these example feature structures with each other, and then later steps generalise  the result with other learning examples.</p><p>Each learning example consists of a sentence or fragment of a sentence heard by the child, together with the meaning which the child infers that the speaker intends. Generalising these example feature structures together gives progressively better approximations to the word feature structure. The first approximations are usually over-specific, because of accidental similarities between the learning examples, which are not part of the word meaning. As the number of examples (and steps) increases, these accidental similarities fall away, rapidly giving a more accurate meaning for the word.</p><p>There may be 'bad' learning examples , where the child infers the wrong meaning, or the speaker is referring to something else. These bad examples are automatically rejected by the model - as you can see in some cases such as the word 'boy'.</p><p>After the earliest stage of learning , the child may already know some of the words in a learning example. In these cases, the child uses the known words to partially understand the example - giving a feature structure with more than one meaning scene. Generalising these feature structures enables the child to infer subsumption links in the word feature structure (curved lines in the diagrams). These links act as pipes to convey meaning from one part of a structure to another - allowing the child to assemble complex meanings (when understanding) or to break them apart into simpler meanings (when generating something to say). These links are the key to the productivity of language.</p></topic><topic name=\"Step\"><p>The [bStep[ button is enabled after any one of the 'Generate', 'Understand', or 'Learn' buttons is pressed. It should be pressed repeatedly to carry out the individual steps in any of these processes.</p><p>As further steps are taken, their results are shown as a new row of feature structures, below the previous rows. There are two steps per row - one step to display the inputs to a unify or generalise operation, and one step to compute and show the result of the operation.</p><p>After the step to compute any operation, there will be three feature structures showing in the  row. These are the two inputs to the operation, and the result of the operation on the right. You can click on nodes in the inputs or the result. Then, the node you click and nodes in other feature structures will be highlighted, to show how nodes in the result (right-hand feature structure) are derived from nodes in the input. Some things you can check by looking at the highlighted nodes:</p><p>- For [bUnify[ (to understand or generate) if you click on any node in the result, it should come from some node in either input, or in both inputs.</p><p>- For [bUnify[ (to understand or generate) if you click on any node in either input, it should appear soemehwere in the result.</p><p>- For [bGeneralise[ (to learn) if you click on any node in the result, it should come from both the inputs.</p><p>- For [bGeneralise[ (to learn) if you click on a node in either input, it will only appear in the result if there is a matching node in the other input.</p><p> It is always possible to scroll upwards and review the results of previous steps. You can also hover the mouse over the nodes or slots of any feature structure, to see a pop-up explanation of any node or slot.</p><p>After any step you can  use the Help menus, to help you undertand what has happened. This will not interrupt the stepping process. However, if you use any of the 'Words', 'Sentences' or 'Learn' menus, this will end any current stepping process.</p></topic><topic name=\"Show/Hide\"><p>Before the [bShow/Hide[ button is pressed , all feature structures are shown in a compact form, with the following two properties:</p><p>- Several sound nodes, for different syllables or phonemes, may be shown as one sound node, with the phonemes of one or more words, for ease of reading. Realistically ,we do not hear speech in this pre-segmented form; the expanded 'Show' form' shows the sequence of phonemes that we actually hear. Language understanding by unification picks out the words from this sequence.</p><p>- Partly though the process of unification (for generation or understanding), some of the nodes in a feature structure have already been used in unifications, and are not available for later unifications. In the compact form before any 'Show', these nodes are hidden.</p><p>After first pressing the 'Show/Hide'button, the full forms of feature structures are shown. By repeatedly pressing this button, you can switch between the compact and full forms of feature structures.</p><p>In the compact form, it appears as if successive unifications consume sounds, and add meanings (for understanding) or vice versa (for generation). The full 'show' form of feature structures shows how unification really just adds nodes to feature structures; nothing is lost, only used up.</p></topic><topic name=\"Compose\"><p>On pressing the 'Compose' button, the model shows a dialogue, with which you can enter any sentence or fragment of a sentence, and the model will attempt to understand it by unification.</p><p>The sentence you enter can only use words from the set of words known to the model. These words are shown below the dialogue box.</p><p>When you have composed a sentence or fragment, press 'Understand', followed by the 'Step' button to make the model try to understand the sentence by one unification  step for each word, in an order of unification computed automatically  by the model.</p><p>The results of attempting to understand a sentence or fragment are not guaranteed to be 'correct'. The intention is that if you enter a grammatical sentence or fragment, the model should understand it completely, giving only one meaning scene in the result. If an un-grammatical sentence or fragment is entered, one of two things should happen: either the process of unification should fail in some step, giving an error message saying why it failed; or the unifications might complete, resulting in more than one meaning scene (i.e not complete understanding). If the unification cannot reduce the sentence or fragment to a single meaning structure, you will be told.</p></topic></topic><topic name=\"How the model works\"><topic name=\"Core Assumptions\"><p>This model of language learning has four core assumptions:</p><p> (1)[bStatistical Learning[: If there is any statistical correlation between two events a and b ( if the probability P(a and b) is not equal to P(a)*P(b) ) then children can rapidly learn that correlation - even if a and b do not always occur together.</p><p> (2)[bFeature Structures[: humans have internal symbolic representations of their current situation, in tree-like feature structures.</p><p>(3)[bBayesian pattern-Matching[: feature structures are combined by the Bayesian pattern-matching operations of unification and generalisation.</p><p> (4)[bLearning Subsumption links[: If the feature structures for words have subsumption links (i.e. if one sub-tree of a feature structure constrains a different sub-tree), then we can learn those subsumption links, and they are the key to the limitless productivity of language.</p><p>The first assumption is uncontroversial, because we share this ability with all other mammals. Many experiments in Associative Conditioning, from Pavlov's dogs onwards, show that mammals and birds rapidly learn statistical correlations between events in their habitats.</p><p>The second and third assumptions are not unique to humans. Many observations of primate social behaviour show that primates form internal symbolic representations of their current situation - so feature structures are not unique to language, and evolved before language. It appears likely that primates use these feature structures by Bayesian inference.</p><p>The first three assumptions are needed for the model of language acquisition at the one-word stage. They enable children to segment the sound stream into words or phrases which are linked with a specific meaning, to understand the meanings of words and phrases.</p><p>A powerful semantic representation (of feature structures representing situations) enables a child to pick out words and learn their meanings from unreliable, inconsistent inputs - by using the same statistical learning mechanism as animals use in associative conditioning, to learn the regularities of their habitats. With this semantic learning mechanism, there is no need for the child to use other weaker cues to segment the sound stream into words and phrases.</p><p>The fourth assumption, the learning of subsumption links, is required to learn syntax. These links define how complex words such as verbs bind together the meanings of their arguments (such as the agent and patient) to form a meaning for a whole sentence, phrase or clause.</p><p>With these  assumptions, the model supports language learning and use up to adult-like complex  sentences and syntax. The demonstrations show how this happens.</p><p>A further assumption is that a a child can use various cues such as gaze to infer (not necessarily reliably) what a speaker is attending to, or referring to. This limited ability to mind-read, or to share a 'common ground' of understanding with the speaker (as Michael Tomasello proposes) assists in learning words, because it increases the probability of inferring the right referent for a word. This assumption  is not absolutely essential to the learning model, because the statistical learning process already allows the child to learn from an unreliable learning signal, in the presence of misleading or misunderstood learning examples - but the assumption helps the model work a lot better.</p><p>This last assumption is related to [bframe-based semantics[ - the idea that the meanings of some words and other constructions are defined in terms of frames (Fillmore 1982), which for a child will be scripts, or common sequences of joint activity and attention. There are some frames in the model (with names beginning 'f_'). Frames are feature structures, and they are learned by just the same mechanism (generalisation) as words and other constructions. </p></topic><topic name=\"Feature Structures\"><p>A Feature Structure is a logical information structure, which is a tree-like graph of connected nodes. Information is stored on the nodes as the values of slots. Feature structures have been used in language research for many years.</p><p>In this model of language, feature structures are used in the brain to store the information content of words and other constructions,  and of sentences. This information content includes both their sounds and their meanings. To see a typical feature structure for a word, use the menu option [bWords &gt; B &gt; Boys[. You will see nodes for parts of the sound boys, and for the meaning of the word.</p><p>You can see the feature structure a typical sentence, using the Sentences menu. In the model, words and sentences are really just the opposite ends of a spectrum, with all kinds of sentence fragments and phrases (called 'constructions' and  'constructs') in between. You can see these using the Words and Sentences menus.</p><p>Feature structures describe the logical information content of parts of language. Feature structures have a model-theoretic semantics (e.g Kay 2002), in that a feature structure represents a possible set of situations in the world, or a set of situations modelled in the mind. Feature structures are not consciously experienced, but the mental images we make from them are experienced.</p><p>We do not know how feature structures are physically represented by neurons in the brain -  that is outside the scope of this computational model of language.</p></topic><topic name=\"Operations on Feature Structures\"><p>There are three key operations on feature structures - subsumption, unification, and generalisation.</p><p>[bSubsumption[ is a test on two feature structures, which gives a result true or false. Denoting whole feature structures by single capital letters, a feature structure A subsumes a feature structure B (written as 'A &gt; B') if B has all the nodes and slots of A in the same tree structure, and may have more. B has more information than A.</p><p>Feature structures have a [bmodel-theoretic semantics[. This means that A represents a set of situations in the world, or a set of models of the world in the mind. So does B. Then if A &gt; B, any situation or model described by B is also described by A. The set of situations that A represents contains the set represented by B. (The more information  content a feature structure has, the smaller the probability of  the set of situations it represents. This is the link between feature structures and Bayesian inference)</p><p>We can use the concept of subsumption to understand the other two operations,  unification and generalisation.</p><p>[bUnification[ is an operation that takes two feature structures as input, and gives a third feature structure as its result. The unification of A and B is written as C = (A U B). Then, C is the simplest possible feature structure for which the subsumption relations, A &gt; C and B &gt;C, are both true. C holds all the information content of A, and all the information content of B; it does so in the simplest possible way. This means that if some slot value appears in both A and B at the same place, it also appears in C; but it is not repeated in C.Other information in either A or B also appears in C. If A and B are not consistent (if they contradict each other, having incompatible slot values such as 'male' and 'female' in the same place) then the unification C does not exist. Since C has minimum information content, it is the Bayesian maximum likelihood combination of A and B.</p><p>[bGeneralisation[ is another operation that takes two feature structures as input, and delivers a third feature structure as its result. The generalisation of A and B is written as D = (A ^ B). Then, D is the most complex possible feature structure (the one with the largest information content) for which the subsumption relations, D &gt; A and D &gt; B, are both true. D is got by taking whatever A and B have in common, and keeping it - but throwing away all the rest. D always exists, for any A and B.</p><p>Because unification and generalisation are both based on subsumption, in a way using set theory, you may see that there are some simple algebraic relations between unification and generalisation. These relations can be used to prove a fundamental theorem about language learning - that it is a faithful process, like  replication of DNA. That theorem is described in one of three papers about the model that you can download.</p></topic><topic name=\"Bayesian inference and learning\"><p>There is a fundamental link between feature structures and their operations, and Bayesan inference in the brain. The following results can be shown mathematically:</p><p>If feature structures represent situations in some domain, with a model-theoretic semantics, then:</p><p>(1) The information content of a feature structure is the negative log of the probability of the set of situations that it represents.</p><p>(2) Unification of feature structures, by minimising the information content of the unified result, is a form of Bayesian maximum-likelihood inference</p><p>(3) Generalisation of feature structures to learn a rule, by maximising the information content of the rule, implements fast Bayesian learning in the domain.</p><p>This theory of language, being based on feature structures and  the operations of unification and generalisation, is a Bayesian theory of language and language learning. This links  the theory to the many successful applications of the [lhttps://en.wikipedia.org/wiki/Bayesian_approaches_to_brain_function&amp;Bayesian Brain[ approach to cognition.</p><p>This link is important when applying  the  Bayesian theory of Learning to the rapid learning of words, from only a few examples of their use. This is what the automated learning program does, and how it does do is described in the papers you can [ldownloads.html&amp;download[ from this site. </p><p>The core result of Bayesian Learning Theory is that you can learn a correlation as soon as the evidence for it is statistically significant. Amongst many other predictions of the Bayesian Brain theory of cognition, this prediction is confirmed in animal learning experiments (Anderson 1990). It is not surprising that animals can learn as fast as is possible in principle - because fast learning is essental for their survival.</p></topic><topic name=\"Generating sounds to say\"><p>The feature structures used in language can be regarded as functions that convert meanings to sounds, or convert sounds to meanings. The same feature structure can act in either direction; it does so by the operation of unification. There are two kinds of feature structures. First, there are simple functions which just convert meanings to sounds (to generate things to say) or convert sounds to meanings (to understand):</p><p>centre.900.250.SimpleFunction.jpg</p><p>These simple functions are  nouns, or phrases with a fixed meaning. They are not in themselves productive; they require other feature structure functions in order to be productive. These productive feature structures (for verbs and other parts of speech) act as more complex functions, converting a single complex meaning into a sequence of sounds and simpler meanings (to generate words to say) or in the reverse direction (to understand what we hear):</p><p>centre.900.250.ComplexFunction.jpg</p><p>In the demonstrations, language meanings are the orange 'scene' nodes and their subtrees. Language sounds are the yellow 'sound' boxes. </p><p>When we say some fixed phrase such as 'how do you do?' or 'get a move on', we start with only its meaning (one orange 'scene' subtree') in our head. Then we unify one feature structure with it. This matches the meaning, and adds the sounds - which we can then speak. You can see this in the model, by generating the  phrase 'go to bed'.</p><p>When we say something productive, like 'John ate a banana', the process is more complex, as we have no pre-learnt phrase for just this circumstance. Again, we start with only the meaning (one orange scene tree) in our heads; but in order to express this meaning, we first have to pull it apart into separate smaller meanings, such as 'John' or 'banana' which we can express in words. We do this by unifying with the appropriate feature structures, in several steps. Each unify step converts a meaning into a sound, possibly with other smaller meanings, until there are only sounds to be said. You can see this in the model, by generating any of the sentences.</p></topic><topic name=\"Understanding sounds you hear\"><p>See the previous help section, on generating sounds, for a description of how feature structures act as functions, converting sounds to meanings, or vice versa.</p><p>Language understanding is like language generation running in the reverse direction - to convert a sequence of sounds (yellow sound nodes) into a single 'scene' meaning subtree.</p><p>When we hear some canned phrase such as 'how do you do?' or 'get a move on', we start with only its sounds (yellow sound nodes, for the sequence of phonemes). Then we unify one feature structure, which matches all the sounds of the whole canned phrase. This creates the meaning scene feature structure, which we can then experience as a mental image. You can see this in the model, by understanding the canned phrase 'go to bed'.</p><p>When we hear something productive, like 'John ate a banana', the process is more complex, as we have never heard this sequence of sounds before. Again, we start with only the sounds; but in order to understand the full meaning, we first have to understand individual words, such as 'John' or 'banana', converting them into meanings. We do this by unifying with the feature structures for the words, in several steps. Each unify step converts a word sound (and possibly some meanings, from previous unification steps) into a meaning, until there is only one meaning scene left - which our minds then convert to a mental image which we experience. You can see this in the model, by understanding any of the sentences.</p></topic><topic name=\"Learning words and other constructs\"><p>The previous sections, on generation and understanding, have begged a huge question - how do we acquire the feature structures that we need to do this?</p><p>For the canned phrases of language, the answer is fairly straightforward.  When a child (or an adult) hears some canned phrase, and can infer its meaning non-linguistically  from the context, this experience is an association between the sound and the meaning. In the model, it is called a 'learning example', and is represented as a feature structure. Each learning example feature structure may contain extra sounds (not part of the canned phrase) and extra pieces of meaning present in the situation (not part of the meaning of the canned phrase). How are these extra parts removed, to learn just the sound and the meaning of the canned phrase?</p><p>The answer is by generalising together the feature structures for the  learning examples. Generalisation picks out only what they have in common, and throws away the rest. After a very small number of learning examples, this process distils out just the sounds and meaning which are part of the canned phrase. You can see this in the model, by learning the canned phrase 'go to bed'. Once the child has learned this feature structure he or she can understand this phrase - or even use it - as is also shown in the model.</p><p>For learning and using canned phrases, there is nothing uniquely human about the learning process. Most mammals and birds can learn similar associations between stimuli in their environment. For instance, it is known that dogs can learn to understand a hundred or more canned phrases.</p><p>Language learnng starts to be uniquely human as we learn to use language productively. For this, we need to learn the feature structures for complex words, notably verbs. While simple feature structures, for canned phrases and nouns, simply convert a whole sequence of sounds into one meaning (or vice versa), the more complex feature structures convert a sequence of sounds and some small meaning structures into one  larger meaning structure. They enable us to combine small meanings into larger meanings, productively.</p><p>Complex feature structures like verbs can be seen in the 'words' menu of the model. The subsumpton links can be easily seen in the curved lines. They are learnt, like canned phrases and nouns, by generalising learning examples together  - where a child hears sounds, and can infer their meaning from the context. But there are a number of differences from the simple learning of nouns or canned phrases.</p><p>(1) Verbs are able to combine smaller meanings into larger meanings, through subsumption links (the curved lines in verb feature structures). These have to be learned from the learning examples, which do not have any subsumption links.</p><p>(2) The process of generalisation of learning examples can infer the existence of subsumption links between meaning 'scene' parts.</p><p>(3) In order for it to do so, there must be more than just the inferred final meaning structure in each learning example; there must be more than one meanings scene, to find a link between therm This means the child needs to already know some other words (such as nouns), and use their feature structures to convert their sounds into their meanings.</p><p>You can see this in action by running some of the word learning cases for verbs and other parts of speech.</p><p>Learning of subsumption links in feature structures may be a uniquely human ability. These subsumption links are the key to the productivity of language - without it, language would just be a  set of canned phrases.</p></topic><topic name=\"Scope of the model\"><p>What  you can see in the demonstrations is clearly not a complete model of language learning and use. This section briefly notes some of its main limitations , and how they could be removed, both in theory and in practice:</p><p>(1) [bParallel multiple unifications:[ In the model, sentence understanding is done by one sequence of unification steps - one per word. However, when understanding what we hear, we  may need to try out several different senses of a word, or different parses of a sentence - and pick the most likely one. There appears to be parallel processing. Because unification is a computationally cheap symbolic operation, it appears likely that we can carry out several unifications in parallel, without conscious awareness. Parallel unification could be modelled, with Bayesian choice of the most likely result.</p><p>(2) [bChoice of the best words to express a meaning[: The model appears to assume that a speaker knows exactly the right words to express a meaning - which is clearly not the case. More realistically, at each step of unification in language generation, the speaker would choose that word in their vocabulary which gave the best match to the meaning they had left to express. Best match can be defined in information theoretic terms - the word which has the largest amount of the meaning to be expressed. For instance, if the speaker has the word for 'cake' he uses it. Otherwise he might fall back to 'thing'. </p><p>(3) [bThe organisation of learned words in memory[: We know many thousands of words, and when speaking or understanding , we manage to find the most appropriate word in fractions of a second. This  raises questions about how the words are arranged in memory for fast retrieval - questions which the model does not address. It might be addressed by various kinds of associative memory , or by arranging words in a subsumption graph.</p><p>(4) [bSimple semantic representation:[ We know very little about what kinds of symbolic representation (feature structures) are used in the brain to hold language meanings. The model makes some simple choices, which are probably much simpler than what goes on in the brain. A typical word has many different associations, as well as any 'core meaning'. The main point is that the operations of unification and generalisation are so powerful, that they will work (in the sense of  modelling language use and understanding) with a very wide range of tree structures for feature structures. The computational model is semantically agnostic.  Since there are probably many different feature structures involved in representing the meaning of any one word, it is probably not possible to find any one 'correct' representation. We do not need to.</p><p>(5) [bConscious awareness of meanings:[ When we hear something, we have a conscious mental image of its meaning. The model  does not address this. It seems likely that we are not consciously aware of any symbol structure such as a feature structure; we are only aware of mental models which have a more analogue character, like images. I believe that feature structures act as a kind of recipe for constructing these mental models. How they do so is complex , and is outside the scope of the language model.</p></topic></topic></guide></model>";
	private static String modelData = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?><model><nodes><node children=\"\" dsc=\"Describes the manner of an action within a scene\" name=\"manner\"/><node children=\"thing scene \" dsc=\"In the spatial domain, this denoted a place, which maye be defined relative to a thing or a scene.&#10;&#10;In other domains, place nodes may have a variety of analogous meanings. For instance, in the domain of possession, there is the place defined by somebody's ownership.\" name=\"place\"/><node children=\"sound scene \" dsc=\"the top node for all feature structures. Has no information of its own (except constraints on the order of its hild nodes, which are not shown).\" name=\"script\"/><node children=\"thing prop scene place \" dsc=\"a thing in a scene. For the spatial domain, this is a material thing.\" name=\"thing\"/><node children=\"thing path place prop scene manner \" dsc=\"a mental representation of a situation, in which something may change, or not change. There are several main types of scene - Go, Cause, Stay, Be, Orient, ext. Scene includes both the Event and State nodes of Jackendoff's semantic analysis, and includes scenes with several unrelated individuals - scenes which are not simply carved apart by language.\" name=\"scene\"/><node children=\"none \" dsc=\"a small unit of spoken sound, equivalent to a phoneme\" name=\"sound\"/><node children=\"thing place \" dsc=\"a path, typically of movement, defined relative to a place or thing\" name=\"path\"/><node children=\"thing scene \" dsc=\"an attribute of a thing, or the manner of an scene. Since attributes and manners are often defined comparatively, there may be a subordinate thing or event or state which denotes the comparison set. (i.e 'big' compared to what?)\" name=\"prop\"/></nodes><slots><slot dsc=\"describes the relationship of a path to a thing or place\" name=\"pathType\" nodes=\"path \"><value val=\"@to\"/><value val=\"@from\"/><value val=\"@via\"/><value val=\"@toward\"/></slot><slot dsc=\"t_type denotes the type, or classification, of a thing - in the spatial  domain, this is a material thing. Values of this slot rely largely on the classification of things into types done by the visual system. These language meanings act like pointers to other parts of the brain, which may consciously create or compare with visual images.\" name=\"t_type\" nodes=\"thing \"><value val=\"@inanimate\"><value val=\"@food\"><value val=\"@iceCream\"/><value val=\"@fruit\"><value val=\"@banana\"/><value val=\"@apple\"/><value val=\"@cherry\"/></value><value val=\"@pie\"/><value val=\"@drink\"><value val=\"@milk\"/><value val=\"@juice\"/><value val=\"@water\"/></value><value val=\"@sweet\"/><value val=\"@biscuit\"/><value val=\"@egg\"/></value><value val=\"@toy\"><value val=\"@ball\"/><value val=\"@doll\"/><value val=\"@lego\"/><value val=\"@bat\"/><value val=\"@train\"/><value val=\"@rubberduck\"/></value><value val=\"@clothes\"><value val=\"@shoe\"/><value val=\"@coat\"/><value val=\"@sock\"/><value val=\"@hat\"/><value val=\"@glove\"/><value val=\"@pyjamas\"/></value><value dsc=\"a location where people can be\" val=\"@space\"><value val=\"@room\"><value val=\"@kitchen\"/><value val=\"@bathroom\"/><value val=\"@bedroom\"/></value><value val=\"@house\"><value val=\"@school\"/><value val=\"@shop\"/><value val=\"@home\"/></value><value val=\"@outside\"><value val=\"@garden\"/><value val=\"@street\"/><value val=\"@field\"/><value val=\"@park\"/></value></value><value val=\"@furniture\"><value val=\"@bed\"/><value val=\"@chair\"/><value val=\"@table\"/><value val=\"@floor\"/><value val=\"@fridge\"/><value val=\"@bath\"/></value><value val=\"@bodyPart\"><value val=\"@hand\"/><value val=\"@foot\"/><value val=\"@head\"/><value val=\"@leg\"/><value val=\"@arm\"/></value><value val=\"@usefulThing\"><value val=\"@soap\"/><value val=\"@sponge\"/><value val=\"@towel\"/><value val=\"@book\"/><value val=\"@picture\"/></value></value><value val=\"@animate\"><value val=\"@animal\"><value val=\"@cat\"/><value val=\"@dog\"/><value val=\"@fish\"/></value><value val=\"@person\"/></value></slot><slot dsc=\"corresponds to grammatical singular or plural\" name=\"number\" nodes=\"thing \"><value val=\"@one\"/><value val=\"@many\"/></slot><slot name=\"actMode\" nodes=\"scene \"><value val=\"@does\"/><value val=\"@can\"/><value val=\"@should\"/><value val=\"@might\"/><value val=\"@intend\"/></slot><slot dsc=\"the time of an action, relative to the time when it is described - roughly corresponds to grammatical tense.\" name=\"time\" nodes=\"scene \"><value val=\"@past\"/><value val=\"@now\"/><value val=\"@future\"/></slot><slot dsc=\"how the listener is to infer what thing is being referred to - whether or not it is expected to be unique. Corresponds to the definite and indefinite articles.\" name=\"choice\" nodes=\"thing \"><value val=\"@defined\"/><value val=\"@any\"/></slot><slot dsc=\"the visible colour of anything\" name=\"colour\" nodes=\"prop \"><value val=\"@red\"/><value val=\"@blue\"/><value val=\"@green\"/><value val=\"@yellow\"/><value val=\"@white\"/><value val=\"@black\"/></slot><slot name=\"cooking\" nodes=\"prop \"><value val=\"@raw\"/><value val=\"@boiled\"/><value val=\"@fried\"/><value val=\"@toasted\"/></slot><slot name=\"sound\" nodes=\"sound \"><value val=\"consonant\"><value dsc=\"as in 'join'\" val=\"j\"/><value dsc=\"as in 'bet'\" val=\"b\"/><value dsc=\"as in 'kit'\" val=\"k\"/><value dsc=\"as in 'sat'\" val=\"s\"/><value dsc=\"as in 'she'\" val=\"sh\"/><value dsc=\"as in 'do'\" val=\"d\"/><value dsc=\"as in 'fan'\" val=\"f\"/><value dsc=\"as in 'doing'\" val=\"ng\"/><value dsc=\"as in 'gone'\" val=\"g\"/><value dsc=\"as in 'hat'\" val=\"h\"/><value dsc=\"as in 'love'\" val=\"l\"/><value dsc=\"as in 'met'\" val=\"m\"/><value dsc=\"as in 'men'\" val=\"n\"/><value dsc=\"as in 'pen'\" val=\"p\"/><value dsc=\"as in 'run'\" val=\"r\"/><value dsc=\"as in 'tap'\" val=\"t\"/><value dsc=\"as in 'thing'\" val=\"th\"/><value dsc=\"as in 'of'\" val=\"v\"/><value dsc=\"as in 'wipe'\" val=\"w\"/><value dsc=\"as in 'yes'\" val=\"y\"/><value dsc=\"as in 'dogs'\" val=\"z\"/><value dsc=\"as in 'cherry'\" val=\"ch\"/></value><value val=\"vowel\"><value dsc=\"as in 'bat'\" val=\"a\"/><value dsc=\"as in 'fate'\" val=\"ai\"/><value dsc=\"as in 'met'\" val=\"e\"/><value dsc=\"as in 'meet'\" val=\"ee\"/><value dsc=\"as in 'hit'\" val=\"i\"/><value dsc=\"as in 'ripe'\" val=\"ie\"/><value dsc=\"as in 'hot'\" val=\"o\"/><value dsc=\"as in 'all'\" val=\"or\"/><value dsc=\"as in 'foot'\" val=\"oo\"/><value dsc=\"as in 'goat'\" val=\"oe\"/><value dsc=\"as in 'mouth'\" val=\"ou\"/><value dsc=\"as in 'grunt'\" val=\"u\"/><value dsc=\"as in 'fuse'\" val=\"uu\"/><value dsc=\"as in 'burn'\" val=\"ur\"/><value dsc=\"as in 'path'\" val=\"ar\"/></value></slot><slot dsc=\"A reference to the frame (i.e. the learned situation) in which some element of a language, such as a thing, an action or a role, is defined.\" name=\"frame\" nodes=\"thing scene \"><value val=\"f_bathtime\"/><value val=\"f_storytime\"/></slot><slot dsc=\"An approximate age for a person\" name=\"age\" nodes=\"prop \"><value val=\"@young\"/><value val=\"@mature\"/><value val=\"@old\"/></slot><slot dsc=\"biological sex and grammatical gender\" name=\"gender\" nodes=\"prop \"><value val=\"@male\"/><value val=\"@female\"/></slot><slot dsc=\"a rough charactersation of the size of a thing or person, relative to the expected size for that type of thing\" name=\"size\" nodes=\"prop \"><value val=\"@small\"/><value val=\"@middle\"/><value val=\"@big\"/></slot><slot dsc=\"c_role is conversational role, the role that some person plays in a conversation.\" name=\"c_role\" nodes=\"thing \"><value dsc=\"the person speaking\" val=\"@speaker\"/><value dsc=\"the person being addressed\" val=\"@listener\"/><value dsc=\"neither the speaker or the listener\" val=\"@other\"/></slot><slot dsc=\"possible types of property\" name=\"propType\" nodes=\"prop \"><value dsc=\"an attribute of a thing\" val=\"@attribute\"/><value dsc=\"the manner of an event\" val=\"@manner\"/></slot><slot dsc=\"the speed at which some action (typically motion) takes place\" name=\"speed\" nodes=\"manner \"><value val=\"@slow\"/><value val=\"@fast\"/></slot><slot dsc=\"a fine-grained characterisation  of the action going on in a scene\" name=\"actType\" nodes=\"scene \"><value val=\"@spatial\"><value val=\"@move\"/><value val=\"@sit\"/><value val=\"@stand\"/><value val=\"@lieDown\"/><value val=\"@eat\"/><value val=\"@hit\"/><value val=\"@force\"/><value val=\"@cause\"/><value val=\"@drink\"/><value val=\"@remove\"/><value val=\"@rub\"/><value val=\"@hold\"/></value><value val=\"@mental\"><value val=\"@think\"/><value val=\"@intend\"/><value val=\"@hear\"/><value val=\"@see\"/><value val=\"@feel\"/><value val=\"@want\"/><value val=\"@tell\"/></value><value val=\"@identity\"><value val=\"@become\"/><value val=\"@remain\"/><value val=\"@be\"/></value><value val=\"@social\"><value val=\"@cause\"/><value val=\"@greet\"/><value val=\"@hug\"/><value val=\"@meet\"/></value></slot><slot dsc=\"temperature\" name=\"temp\" nodes=\"prop \"><value val=\"@cold\"/><value val=\"@warm\"/><value val=\"@hot\"/></slot><slot dsc=\"describes the relationship of a place to a thing\" name=\"placeType\" nodes=\"place \"><value val=\"@in\"/><value val=\"@on\"/><value val=\"@above\"/><value val=\"@below\"/><value val=\"@beside\"/><value val=\"@near\"/><value val=\"@farFrom\"/><value val=\"@under\"/><value val=\"@touching\"/><value dsc=\"possession, modelled as a place: 'in the possession of'\" val=\"@of\"/><value val=\"@at\"/></slot><slot dsc=\"all scene nodes have an act slot. Scenes describing only a thing or things have act = 'false'. Scenes describing some event or state have act='true'.\" name=\"act\" nodes=\"scene \"><value val=\"true\"/><value val=\"false\"/><value val=\"blah\"/></slot><slot dsc=\"the physical direction of a path\" name=\"direction\" nodes=\"path \"><value val=\"@up\"/><value val=\"@down\"/></slot><slot dsc=\"a high-level classification of different possible types of scene\" name=\"s_type\" nodes=\"scene \"><value val=\"@go\"/><value val=\"@cause\"/><value val=\"@stay\"/><value val=\"@be\"/><value val=\"@orient\"/><value val=\"@ext\"/><value dsc=\"this scene has a child thing, and a child scene which describes the thing, and helps to define it.\" val=\"@describes\"/></slot><slot dsc=\"m_role stands for 'meaning role' , which is the role played by some object in the scene which is the meaning. m-role has a few common vaues such as '@agent', and an open-ended set of values which are defined in particular frames (learned situations).&#10;&#10;m_role is different from c_role, the role of a person in the conversation.\" name=\"m_role\" nodes=\"thing \"><value val=\"@agent\"/><value val=\"@patient\"/><value val=\"@tool\"/><value val=\"@thought\"/><value val=\"@bathtime_role\"><value val=\"@bathgiver\"/><value val=\"@bather\"/><value val=\"@scrubber\"/><value val=\"@dryer\"/></value><value val=\"@storytime_role\"><value val=\"@teller\"/><value val=\"@hearer\"/><value val=\"@story_source\"/></value></slot><slot dsc=\"the identiy of a person known to the speaker or the listener\" name=\"identity\" nodes=\"thing \"><value dsc=\"the speaker or listener\" val=\"@me\"/><value dsc=\"the spealer or listener\" val=\"@you\"/><value val=\"@sally\"/><value val=\"@ben\"/><value val=\"@zack\"/><value val=\"@josh\"/><value val=\"@tim\"/><value val=\"@mummy\"/><value val=\"@daddy\"/><value val=\"@anna\"/><value val=\"@phoebe\"/><value val=\"@john\"/><value val=\"@al\"/><value dsc=\"an unknown identity, used for saying that two things are the same thing\" val=\"@x\"/><value val=\"@story_id\"><value val=\"@cinderella\"/><value val=\"@humptydumpty\"/><value val=\"@redridinghood\"/></value></slot><slot dsc=\"There are a small number of domains of cognition, sometimes called 'semantic fields'. The primary domain is spatial, concerning physical things, space and motion. Meanings in the other domains are usually defined by analogy to spatial meanings, using the same meaning structures. This allows economy of description of many meanings, ahd underpins the wide use of spatial metaphors in language.  This model includes only a few major domains - there may be many minor ones.\" name=\"domain\" nodes=\"scene path place thing prop \"><value dsc=\"the domain of physical things, space and motion. Symbolic meanings in this domain are links to other mental representations of space, things and motion - representations which are the basis of our conscious experience. A feature structure in the spatial domain is a prescription for building a spatial mental model, which can be consciously experienced.\" val=\"spatial\"/><value dsc=\"concerning identity and classification of things\" val=\"identity\"/><value dsc=\"concerning possession and control\" val=\"possession\"/><value dsc=\"concerning mental activities such as seeing, knowing, wanting, etc.\" val=\"mental\"/><value dsc=\"concerning social relationships and activities\" val=\"social\"/><value dsc=\"about times\" val=\"temporal\"/></slot></slots></model>";
	private static String wordData = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?><model><words><word name=\"bed\"><script description=\"The meaning of 'bed' is a single thing of type @bed.\" segments=\"b,e,d,|\"><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"d\"/><scene result=\"yes\"><thing number=\"@one\" t_type=\"@bed\"/></scene></script></word><word name=\"s(poss)\"><script description=\"the -s suffix meaning possession. When words describing an animate thing (top scene) are followed by 's', and are then followed by words describing another thing (middle scene), the meaning (bottom scene) is the second thing in a place which is in the possession of the animate thing.\" segments=\"s,|\"><scene act=\"false\"><thing subsumes=\"x_1\" t_type=\"@animate\"/></scene><sound sound=\"s\"/><scene act=\"false\"><thing subsumes=\"x_2\"/></scene><scene act=\"false\" result=\"yes\"><thing id=\"x_2\"><place domain=\"possession\" placeType=\"@of\"><thing id=\"x_1\"/></place></thing></scene></script></word><word name=\"see(thing)\"><script description=\"When words describing some person (top scene) are followed by 'see', followed by words describing any thing (middle scene), the meaning (bottom scene) is an action scene at time @now, in which the person sees the thing.\" segments=\"s,ee,|\"><scene act=\"false\"><thing subsumes=\"x_1\" t_type=\"@person\"/></scene><sound sound=\"s\"/><sound sound=\"ee\"/><scene act=\"false\" subsumes=\"x_2\"/><scene act=\"true\" actType=\"@see\" domain=\"mental\" result=\"yes\" time=\"@now\"><thing id=\"x_1\" t_type=\"@person\"/><scene act=\"false\" id=\"x_2\"/></scene></script></word><word name=\"sponge\"><script description=\"The meaning of 'sponge' is a single thing of type @sponge. It  is understood in the 'bathtime' frame.\" segments=\"s,p,u,n,j,|\"><sound sound=\"s\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"j\"/><scene act=\"false\" result=\"yes\"><thing frame=\"f_bathtime\" number=\"@one\" t_type=\"@sponge\"/></scene></script></word><word name=\"push\"><script description=\"when words describing an animate thing (top scene) are followed by 'push', and then followed by words describing a thing (middle scene), the meaning (bottom scene) is an action scene in which the animate thing as agent (doing the action) causes the second thing to move on some unspecified path.\" segments=\"p,oo,sh,|\"><scene act=\"false\"><thing subsumes=\"x1\" t_type=\"@inanimate\"/></scene><sound sound=\"p\"/><sound sound=\"oo\"/><sound sound=\"sh\"/><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing id=\"x1\" m_role=\"@agent\" t_type=\"@inanimate\"/><scene act=\"true\" s_type=\"@go\"><thing id=\"x_1\" m_role=\"@agent\"/><path/></scene></scene></script></word><word name=\"cold\"><script description=\"when 'cold' is followed by words describing a thing (top scene), the meaning (bottom scene) is the thing with property temperature (temp) = @cold.\" segments=\"k,oe,l,d,|\"><sound sound=\"k\"/><sound sound=\"oe\"/><sound sound=\"l\"/><sound sound=\"d\"/><scene><thing subsumes=\"x_1\"/></scene><scene result=\"yes\"><thing id=\"x_1\"><prop temp=\"@cold\"/></thing></scene></script></word><word name=\"her(poss)\"><script description=\"When her (possessive) is followed by words describing a thing (top scene), the meaning (bottom scene) is the thing in a 'place' which is the possession of a single female person, with c_role @other (i.e not the speaker or the listener)\" segments=\"h,ur,|\"><sound sound=\"h\"/><sound sound=\"ur\"/><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"false\" result=\"yes\"><thing id=\"x_1\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@other\" choice=\"@defined\" number=\"@one\"><prop gender=\"@female\"/></thing></place></thing></scene></script></word><word name=\"apple\"><script description=\"The meaning of 'apple' is a single thing of type @apple\" segments=\"a,p,u,l,|\"><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene result=\"yes\"><thing number=\"@one\" t_type=\"@apple\"/></scene></script></word><word name=\"his\"><script description=\"When 'his' is followed by words describing a thing (top scene), the meaning (bottom scene) is the thing in a 'place' which is the possession of a single male person, which the listener can identify (choise = @defined) with c_role @other (i.e not the speaker or the listener)\" segments=\"h,i,z,|\"><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"z\"/><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"false\" result=\"yes\"><thing id=\"x_1\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@other\" choice=\"@defined\" number=\"@one\"><prop gender=\"@male\"/></thing></place></thing></scene></script></word><word name=\"your\"><script description=\"When 'your' is followed by words describing some thing (top scene), then the meaning (bottom scene) is the thing in a place which is in the possession of the listener.\" segments=\"y,or,|\"><sound sound=\"y\"/><sound sound=\"or\"/><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"false\" result=\"yes\"><thing id=\"x_1\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@listener\"/></place></thing></scene></script></word><word name=\"ran\"><script description=\"when words describing an animate thing (top scene) are followed by 'ran', the meaning (bottom scene) is an action scene of going, at time = @past with manner = @fast and the animate thing as agent (doing the action)\" segments=\"r,a,n,|\"><scene act=\"false\"><thing subsumes=\"x24\" t_type=\"@animate\"/></scene><sound sound=\"r\"/><sound sound=\"a\"/><sound sound=\"n\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@past\"><thing id=\"x24\" m_role=\"@agent\" t_type=\"@animate\"/><manner speed=\"@fast\"/></scene></script></word><word name=\"hot\"><script description=\"when 'hot' is followed by words describing a thing (top scene), the meaning (bottom scene) is the thing with property temperature (temp) = @hot.\" segments=\"h,o,t,|\"><sound sound=\"h\"/><sound sound=\"o\"/><sound sound=\"t\"/><scene><thing subsumes=\"x_1\"/></scene><scene result=\"yes\"><thing id=\"x_1\"><prop temp=\"@hot\"/></thing></scene></script></word><word name=\"him\"><script description=\"The meaning of 'him' is a single person in a patient role in some action scene, who the listener can identify (choice @defined) and who is not the speaker or the listener (c_role @other)\" segments=\"h,i,m,|\"><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"m\"/><scene result=\"yes\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@patient\" number=\"@one\" t_type=\"@person\"><prop gender=\"@male\"/></thing></scene></script></word><word name=\"on(thing)\"><script description=\"When words describing some thing (top scene) are followed by 'on' and then  followed by words describing some other thing (middle scene), the meaning (bottom scene) is the first thing in a place which is on the second thing.\" segments=\"o,n,|\"><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><sound sound=\"o\"/><sound sound=\"n\"/><scene act=\"false\"><thing subsumes=\"x_2\"/></scene><scene act=\"false\" result=\"yes\"><thing id=\"x_1\"><place placeType=\"@on\"><thing id=\"x_2\"/></place></thing></scene></script></word><word name=\"think\"><script description=\"When words describing a person (top scene) are followed by 'think', and then followed by words describing any action (middle scene) , then the meaning (bottom scene) is a scene in the mental domain, describing the person at time @now thinking about the act.\" segments=\"th,i,n,k,|\"><scene act=\"false\"><thing subsumes=\"x_1\" t_type=\"@person\"/></scene><sound sound=\"th\"/><sound sound=\"i\"/><sound sound=\"n\"/><sound sound=\"k\"/><scene act=\"true\" subsumes=\"x_2\"/><scene act=\"true\" actType=\"@think\" domain=\"mental\" result=\"yes\" time=\"@now\"><thing id=\"x_1\" t_type=\"@person\"/><scene act=\"true\" id=\"x_2\"/></scene></script></word><word name=\"bath\"><script description=\"The meaning of 'bath' is a single thing of type @bath. It  is understood in the 'bathtime' frame.\" segments=\"b,ar,th,|\"><sound sound=\"b\"/><sound sound=\"ar\"/><sound sound=\"th\"/><scene act=\"false\" result=\"yes\"><thing frame=\"f_bathtime\" number=\"@one\" t_type=\"@bath\"/></scene></script></word><word name=\"eats\"><script description=\"when words describing a single person (top scene) are followed by 'eats', and then followed by words describing food (middle scene), the meaning (bottom scene) is an action scene of eating, at time = @now with the person as agent (doing the action) and the food as patient.\" segments=\"ee,t,s,|\"><scene act=\"false\"><thing c_role=\"@other\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"/></scene><sound sound=\"ee\"/><sound sound=\"t\"/><sound sound=\"s\"/><scene act=\"false\"><thing subsumes=\"x2\" t_type=\"@food\"/></scene><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing c_role=\"@other\" id=\"x1\" m_role=\"@agent\" number=\"@one\" t_type=\"@person\"/><thing id=\"x2\" m_role=\"@patient\" t_type=\"@food\"/></scene></script></word><word name=\"phoebe\"><script description=\"The meaning of 'phoebe' is a single  female person with identity = @phoebe . This is like a pointer to other representations of Phoebe in the brain\" segments=\"f,ee,b,i,|\"><sound sound=\"f\"/><sound sound=\"ee\"/><sound sound=\"b\"/><sound sound=\"i\"/><scene act=\"false\" result=\"yes\"><thing identity=\"@phoebe\" number=\"@one\" t_type=\"@person\"><prop gender=\"@female\"/></thing></scene></script></word><word name=\"on(act)\"><script description=\"When words describing some act (top scene) are followed by 'on' and then  followed by words describing some thing (middle scene), the meaning (bottom scene) is the act  happening in a place which is on the thing.\" segments=\"o,n,|\"><scene act=\"true\" subsumes=\"x_2\"/><sound sound=\"o\"/><sound sound=\"n\"/><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"true\" id=\"x_2\" result=\"yes\"><place placeType=\"@on\"><thing id=\"x_1\"/></place></scene></script></word><word name=\"soap\"><script description=\"The meaning of 'soap' is a single thing of type @soap. It  is understood in the 'bathtime' frame.\" segments=\"s,oe,p,|\"><sound sound=\"s\"/><sound sound=\"oe\"/><sound sound=\"p\"/><scene act=\"false\" result=\"yes\"><thing frame=\"f_bathtime\" number=\"@one\" t_type=\"@soap\"/></scene></script></word><word name=\"shoe\"><script description=\"the meaning of 'shoe' is a single thing of type @shoe.\" segments=\"sh,oo,|\"><sound sound=\"sh\"/><sound sound=\"oo\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" t_type=\"@shoe\"/></scene></script></word><word name=\"in(thing)\"><script description=\"When words describing some thing (top scene) are followed by 'in' and then  followed by words describing some other thing (middle scene), the meaning (bottom scene) is the first thing in a place which is inside the second thing.\" segments=\"i,n,|\"><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><sound sound=\"i\"/><sound sound=\"n\"/><scene act=\"false\"><thing subsumes=\"x_2\"/></scene><scene act=\"false\" result=\"yes\"><thing id=\"x_1\"><place placeType=\"@in\"><thing id=\"x_2\"/></place></thing></scene></script></word><word name=\"hear\"><script description=\"When words describing some person (top scene) are followed by 'hear', followed by words describing any scene (middle scene), the meaning (bottom scene) is an action scene at time @now, in which the person hears the middle scene\" segments=\"h,ee,r,|\"><scene act=\"false\"><thing subsumes=\"x_1\" t_type=\"@person\"/></scene><sound sound=\"h\"/><sound sound=\"ee\"/><sound sound=\"r\"/><scene act=\"true\" subsumes=\"x_2\"/><scene act=\"true\" actType=\"@hear\" domain=\"mental\" result=\"yes\" time=\"@now\"><thing id=\"x_1\" t_type=\"@person\"/><scene act=\"true\" id=\"x_2\"/></scene></script></word><word name=\"goes\"><script description=\"when words describing a single animate thing (top scene) are followed by 'goes', the meaning (bottom scene) is an action scene of going, at time = @now, with an unspecified path and the thing as agent (doing the action)\" segments=\"g,oe,z,|\"><scene act=\"false\"><thing number=\"@one\" subsumes=\"x26\" t_type=\"@animate\"/></scene><sound sound=\"g\"/><sound sound=\"oe\"/><sound sound=\"z\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing id=\"x26\" m_role=\"@agent\" number=\"@one\" t_type=\"@animate\"/><path/></scene></script></word><word name=\"howjado\"><script description=\"The meaning of 'howjado' is a social scene at time @now, in which the speaker greets the listener.\" segments=\"h,ou,j,u,d,oo,|\"><sound sound=\"h\"/><sound sound=\"ou\"/><sound sound=\"j\"/><sound sound=\"u\"/><sound sound=\"d\"/><sound sound=\"oo\"/><scene actType=\"@greet\" domain=\"social\" result=\"yes\" time=\"@now\"><thing c_role=\"@speaker\" m_role=\"@agent\"/><thing c_role=\"@listener\" m_role=\"@patient\"/></scene></script></word><word name=\"f_storytime\"><script description=\"This is a frame, or learned situation. Some frames are learned before language, and are used to define roles (such as story teller and hearer) and to understand things and actions. The frame has the following scenes: (1) The story teller holds a book, which is the source of the story; (2) the story teller tells the story to the hearer; (3) the teller and the hearer look at pictures in the book\"><scene actType=\"@hold\"><thing m_role=\"@teller\"/><thing m_role=\"@story_source\" t_type=\"@book\"/></scene><scene actType=\"@tell\"><thing m_role=\"@teller\"/><thing m_role=\"@hearer\"/><scene s_type=\"@describes\"/></scene><scene actType=\"@see\" result=\"yes\"><thing m_role=\"@agent\"><thing m_role=\"@teller\"/><thing m_role=\"@hearer\"/></thing><thing t_type=\"@picture\"><place placeType=\"@in\"><thing m_role=\"@story_source\" t_type=\"@book\"/></place><scene s_type=\"@describes\"/></thing></scene></script></word><word name=\"boy\"><script description=\"the meaning of 'boy' (bottom scene) is a single thing of type 'person' with properties age = @young and gender = @male\" segments=\"b,o,y,|\"><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><scene result=\"yes\"><thing number=\"@one\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing></scene></script></word><word name=\"head\"><script description=\"the meaning of 'head' is a single thing of type @head.\" segments=\"h,e,d,|\"><sound sound=\"h\"/><sound sound=\"e\"/><sound sound=\"d\"/><scene result=\"yes\"><thing number=\"@one\" t_type=\"@head\"/></scene></script></word><word name=\"hand\"><script description=\"the meaning of 'hand' is a single thing of type @hand.\" segments=\"h,a,n,d,|\"><sound sound=\"h\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"d\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" t_type=\"@hand\"/></scene></script></word><word name=\"in(act)\"><script description=\"When words describing some act (top scene) are followed by 'in' and then  followed by words describing some thing (middle scene), the meaning (bottom scene) is the act happening in a place which is inside the thing\" segments=\"i,n,|\"><scene act=\"true\" subsumes=\"x_2\"/><sound sound=\"i\"/><sound sound=\"n\"/><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"true\" id=\"x_2\" result=\"yes\"><place placeType=\"@in\"><thing id=\"x_1\"/></place></scene></script></word><word name=\"girl\"><script description=\"the meaning of 'girl' is a single person with propertes age = @young and gender= @female\" segments=\"g,ur,l,|\"><sound sound=\"g\"/><sound sound=\"ur\"/><sound sound=\"l\"/><scene result=\"yes\"><thing number=\"@one\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@female\"/></thing></scene></script></word><word name=\"big\"><script description=\"when 'big' is followed by words describing a thing (top scene), the meaning (bottom scene) is the thing with property size=@big\" segments=\"b,i,g,|\"><sound sound=\"b\"/><sound sound=\"i\"/><sound sound=\"g\"/><scene><thing subsumes=\"x_1\"/></scene><scene result=\"yes\"><thing id=\"x_1\"><prop size=\"@big\"/></thing></scene></script></word><word name=\"towel\"><script description=\"The meaning of 'towel' is a single thing of type @towel. It  is understood in the 'bathtime' frame.\" segments=\"t,a,w,u,l,|\"><sound sound=\"t\"/><sound sound=\"a\"/><sound sound=\"w\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene result=\"yes\"><thing frame=\"f_bathtime\" number=\"@one\" t_type=\"@towel\"/></scene></script></word><word name=\"chair\"><script description=\"the meaning of 'chair' is a single thing of type @chair.\" segments=\"ch,ai,r,|\"><sound sound=\"ch\"/><sound sound=\"ai\"/><sound sound=\"r\"/><scene result=\"yes\"><thing number=\"@one\" t_type=\"@chair\"/></scene></script></word><word name=\"hat\"><script description=\"the meaning of 'hat' is a single thing of type @hat.\" segments=\"h,a,t,|\"><sound sound=\"h\"/><sound sound=\"a\"/><sound sound=\"t\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" t_type=\"@hat\"/></scene></script></word><word name=\"little\"><script description=\"when 'little' is followed by words describing a thing (top scene), the meaning (bottom scene) is the thing with property size=@small\" segments=\"l,i,t,l,|\"><sound sound=\"l\"/><sound sound=\"i\"/><sound sound=\"t\"/><sound sound=\"l\"/><scene><thing subsumes=\"x_1\"/></scene><scene result=\"yes\"><thing id=\"x_1\"><prop size=\"@small\"/></thing></scene></script></word><word name=\"fell\"><script description=\"when words describing a thing (top scene) are followed by 'fell', the meaning (bottom scene) is an action scene of going, at time = @past, with a path of direction @down and the thing as agent (doing the action)\" segments=\"f,e,l,|\"><scene act=\"false\"><thing subsumes=\"x26\"/></scene><sound sound=\"f\"/><sound sound=\"e\"/><sound sound=\"l\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@past\"><thing id=\"x26\" m_role=\"@agent\"/><path direction=\"@down\"/></scene></script></word><word name=\"that\"><script description=\"When 'that' is followed by words describing any action (middle scene) then the result (bottom scene) is the same action.\" segments=\"th,a,t,|\"><sound sound=\"th\"/><sound sound=\"a\"/><sound sound=\"t\"/><scene act=\"true\" subsumes=\"x_1\"/><scene act=\"true\" id=\"x_1\" result=\"yes\"/></script></word><word name=\"ball\"><script description=\"The meaning of 'ball' is a single thing of type @ball.\" segments=\"b,or,l,|\"><sound sound=\"b\"/><sound sound=\"or\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" t_type=\"@ball\"/></scene></script></word><word name=\"green\"><script description=\"when 'green' is followed by words describing a thing (top scene), the meaning (bottom scene) is the thing with property colour= @green\" segments=\"g,r,ee,n,|\"><sound sound=\"g\"/><sound sound=\"r\"/><sound sound=\"ee\"/><sound sound=\"n\"/><scene><thing subsumes=\"x_1\" t_type=\"@inanimate\"/></scene><scene result=\"yes\"><thing id=\"x_1\" t_type=\"@inanimate\"><prop colour=\"@green\"/></thing></scene></script></word><word name=\"drinks\"><script description=\"when words describing a single person (top scene) are followed by 'drinks', and then followed by words describing a drink (middle scene), the meaning (bottom scene) is an action scene of eating, at time = @now with the person as agent (doing the action) and the drink as patient\" segments=\"d,r,i,n,k,s,|\"><scene act=\"false\"><thing number=\"@one\" subsumes=\"x1\" t_type=\"@person\"/></scene><sound sound=\"d\"/><sound sound=\"r\"/><sound sound=\"i\"/><sound sound=\"n\"/><sound sound=\"k\"/><sound sound=\"s\"/><scene act=\"false\"><thing subsumes=\"x2\" t_type=\"@drink\"/></scene><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing id=\"x1\" m_role=\"@agent\" number=\"@one\" t_type=\"@person\"/><thing id=\"x2\" m_role=\"@patient\" t_type=\"@drink\"/></scene></script></word><word name=\"drop\"><script segments=\"d,r,o,p,|\"><scene act=\"false\"><thing m_role=\"@agent\" number=\"@many\" subsumes=\"x1\" t_type=\"@animate\"/></scene><sound sound=\"d\"/><sound sound=\"r\"/><sound sound=\"o\"/><sound sound=\"p\"/><scene act=\"false\"><thing m_role=\"@patient\" subsumes=\"x_1\" t_type=\"@inanimate\"/></scene><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing id=\"x1\" m_role=\"@agent\" number=\"@many\" t_type=\"@animate\"/><scene act=\"true\" s_type=\"@go\"><thing id=\"x_1\" m_role=\"@patient\" t_type=\"@inanimate\"/><path direction=\"@down\"/></scene></scene></script></word><word name=\"of\"><script description=\"When words describing some thing (top scene) are followed by 'of' and then  followed by words describing some other thing (middle scene), the meaning (bottom scene) is the first thing in a place which is in the possessiion of the second thing.\" segments=\"o,v,|\"><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><sound sound=\"o\"/><sound sound=\"v\"/><scene act=\"false\"><thing subsumes=\"x_2\"/></scene><scene act=\"false\" result=\"yes\"><thing id=\"x_1\"><place domain=\"possession\" placeType=\"@of\"><thing id=\"x_2\"/></place></thing></scene></script></word><word name=\"to(act)\"><script description=\"When words  describing any action (top scene) are followed by 'to', and then followed by words describing any thing (middle scene), then the meaning (bottom scene) is that the action takes place on a path which leads to a place at the thing.\" segments=\"t,uu,|\"><scene act=\"true\" subsumes=\"x_2\"/><sound sound=\"t\"/><sound sound=\"uu\"/><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"true\" id=\"x_2\" result=\"yes\"><path pathType=\"@to\"><place placeType=\"@at\"><thing id=\"x_1\"/></place></path></scene></script></word><word name=\"milk\"><script description=\"the meaning of 'milk' is a  thing of type @milk - a sub-type of @drink.\" segments=\"m,i,l,k,|\"><sound sound=\"m\"/><sound sound=\"i\"/><sound sound=\"l\"/><sound sound=\"k\"/><scene act=\"false\" result=\"yes\"><thing t_type=\"@milk\"/></scene></script></word><word name=\"banana\"><script description=\"The meaning of 'banana' is a single thing of type @banana.\" segments=\"b,u,n,ar,n,u,|\"><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"ar\"/><sound sound=\"n\"/><sound sound=\"u\"/><scene result=\"yes\"><thing number=\"@one\" t_type=\"@banana\"/></scene></script></word><word name=\"went\"><script description=\"when words describing an animate thing (top scene) are followed by 'went', the meaning (bottom scene) is an action scene of going, at time = @past, along some unspecified  path, and the animate thing as agent (doing the action)\" segments=\"w,e,n,t,|\"><scene act=\"false\"><thing subsumes=\"x26\" t_type=\"@animate\"/></scene><sound sound=\"w\"/><sound sound=\"e\"/><sound sound=\"n\"/><sound sound=\"t\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing id=\"x26\" m_role=\"@agent\" t_type=\"@animate\"/><path/></scene></script></word><word name=\"a\"><script description=\"The indefinite article leaves it open to choose any of the described things in the conversational context - there may be several things to choose from.\" segments=\"u,|\"><sound sound=\"u\"/><scene act=\"false\"><thing choice=\"@any\" number=\"@one\" subsumes=\"x2\"/></scene><scene act=\"false\" result=\"yes\"><thing choice=\"@any\" id=\"x2\" number=\"@one\"/></scene></script></word><word name=\"told\"><script description=\"When words describing a person (top scene) are followed by 'told', then followed by words describing another person (second scene), and then followed by words describing any action (third scene), then the meaning (bottom scene) is a scene in the mental domain, describing the first person at time @past causing the second person to hear about the act.\" segments=\"t,oe,l,d,|\"><scene act=\"false\"><thing subsumes=\"x1\" t_type=\"@person\"/></scene><sound sound=\"t\"/><sound sound=\"oe\"/><sound sound=\"l\"/><sound sound=\"d\"/><scene act=\"false\"><thing subsumes=\"x_3\" t_type=\"@person\"/></scene><scene act=\"true\" subsumes=\"x_1\"/><scene act=\"true\" actType=\"@tell\" domain=\"mental\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing id=\"x1\" m_role=\"@agent\" t_type=\"@person\"/><scene act=\"true\" actType=\"@hear\" domain=\"mental\" result=\"yes\" time=\"@past\"><thing id=\"x_3\" m_role=\"@agent\" t_type=\"@person\"/><scene act=\"true\" id=\"x_1\"/></scene></scene></script></word><word name=\"red\"><script description=\"when 'red' is followed by words describing a thing (top scene), the meaning (bottom scene) is the thing with property colour= @red.\" segments=\"r,e,d,|\"><sound sound=\"r\"/><sound sound=\"e\"/><sound sound=\"d\"/><scene><thing subsumes=\"x_1\" t_type=\"@inanimate\"/></scene><scene result=\"yes\"><thing id=\"x_1\" t_type=\"@inanimate\"><prop colour=\"@red\"/></thing></scene></script></word><word name=\"zack\"><script description=\"The meaning of 'zack' is a single  male person with identity = @zack . The  identity slot is like a pointer to other representations of Zack in the brain.\" segments=\"z,a,k,|\"><sound sound=\"z\"/><sound sound=\"a\"/><sound sound=\"k\"/><scene result=\"yes\"><thing identity=\"@zack\" number=\"@one\" t_type=\"@person\"><prop gender=\"@male\"/></thing></scene></script></word><word name=\"fall\"><script description=\"when words describing a plural thing (top scene) are followed by 'fall', the meaning (bottom scene) is an action scene of going, at time = @now, with a path of direction @down and the thing as agent (doing the action)\" segments=\"f,or,l,|\"><scene act=\"false\"><thing number=\"@many\" subsumes=\"x26\"/></scene><sound sound=\"f\"/><sound sound=\"or\"/><sound sound=\"l\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing id=\"x26\" m_role=\"@agent\" number=\"@many\"/><path direction=\"@down\"/></scene></script></word><word name=\"biscuit\"><script description=\"The meaning of 'biscuit' is a single thing of type @biscuit.\" segments=\"b,i,s,k,i,t,|\"><sound sound=\"b\"/><sound sound=\"i\"/><sound sound=\"s\"/><sound sound=\"k\"/><sound sound=\"i\"/><sound sound=\"t\"/><scene result=\"yes\"><thing number=\"@one\" t_type=\"@biscuit\"/></scene></script></word><word name=\"table\"><script description=\"the meaning of 'table' is a single thing of type @table.\" segments=\"t,ai,b,u,l,|\"><sound sound=\"t\"/><sound sound=\"ai\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene result=\"yes\"><thing number=\"@one\" t_type=\"@table\"/></scene></script></word><word name=\"saw(thing)\"><script description=\"When words describing some person (top scene) are followed by 'saw', followed by words describing any thing (middle scene), the meaning (bottom scene) is an action scene at time @past, in which the person sees the thing.\" segments=\"s,or,|\"><scene act=\"false\"><thing m_role=\"@agent\" subsumes=\"x_1\" t_type=\"@person\"/></scene><sound sound=\"s\"/><sound sound=\"or\"/><scene act=\"false\"><thing m_role=\"@patient\" subsumes=\"x_2\"/></scene><scene act=\"true\" actType=\"@see\" domain=\"mental\" result=\"yes\" time=\"@past\"><thing id=\"x_1\" m_role=\"@agent\" t_type=\"@person\"/><thing id=\"x_2\" m_role=\"@patient\"/></scene></script></word><word name=\"foot\"><script segments=\"f,oo,t,|\"><sound sound=\"f\"/><sound sound=\"oo\"/><sound sound=\"t\"/><scene result=\"yes\"><thing number=\"@one\" t_type=\"@foot\"/></scene></script></word><word name=\"doggie\"><script segments=\"d,o,g,i,|\"><sound sound=\"d\"/><sound sound=\"o\"/><sound sound=\"g\"/><sound sound=\"i\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" t_type=\"@dog\"/></scene></script></word><word name=\"shoes\"><script description=\"the meaning of 'shoes' is a plural thing of type @shoe.\" segments=\"sh,oo,s,|\"><sound sound=\"sh\"/><sound sound=\"oo\"/><sound sound=\"s\"/><scene result=\"yes\"><thing number=\"@many\" t_type=\"@shoe\"/></scene></script></word><word name=\"bat\"><script description=\"The meaning of 'bat' is a single thing of type @bat.\" segments=\"b,a,t,|\"><sound sound=\"b\"/><sound sound=\"a\"/><sound sound=\"t\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" t_type=\"@bat\"/></scene></script></word><word name=\"egg\"><script segments=\"e,g,|\"><sound sound=\"e\"/><sound sound=\"g\"/><scene act=\"false\" result=\"yes\"><thing t_type=\"@egg\"/></scene></script></word><word name=\"you\"><script description=\"The meaning of 'you' is a person in the conversational role (c_role) of listener.\" segments=\"y,oo,|\"><sound sound=\"y\"/><sound sound=\"oo\"/><scene act=\"false\" result=\"yes\"><thing c_role=\"@listener\" t_type=\"@person\"/></scene></script></word><word name=\"and\"><script description=\"When words describing a first thing or things  (top scene) are followed by 'and', and then followed by words describing a second thing or things (middle scene), the meaning (bottom scene) is a composite plural thing consisting of all the previous things.\" segments=\"a,n,d,|\"><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"d\"/><scene act=\"false\"><thing subsumes=\"x_2\"/></scene><scene act=\"false\" result=\"yes\"><thing number=\"@many\"><thing id=\"x_1\"/><thing id=\"x_2\"/></thing></scene></script></word><word name=\"he\"><script description=\"The meaning of 'he' is a single male person in an agent role in some action scene, who the listener can identify (choice @defined) and who is not the speaker or the listener (c_role @other)\" segments=\"h,ee,|\"><sound sound=\"h\"/><sound sound=\"ee\"/><scene result=\"yes\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" t_type=\"@person\"><prop gender=\"@male\"/></thing></scene></script></word><word name=\"ate\"><script description=\"when words describing a person (top scene) are followed by 'ate', and then followed by words describing food (middle scene), the meaning (bottom scene) is an action scene of eating, at time = @past with the person as agent (doing the action) and the food as patient.\" segments=\"ai,t,|\"><scene act=\"false\"><thing subsumes=\"x1\" t_type=\"@person\"/></scene><sound sound=\"ai\"/><sound sound=\"t\"/><scene act=\"false\"><thing subsumes=\"x2\" t_type=\"@food\"/></scene><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing id=\"x1\" m_role=\"@agent\" t_type=\"@person\"/><thing id=\"x2\" m_role=\"@patient\" t_type=\"@food\"/></scene></script></word><word name=\"sees(thing)\"><script description=\"When words describing some person (top scene) are followed by 'see', followed by words describing any thing (middle scene), the meaning (bottom scene) is an action scene at time @now, in which the person sees the thing.\" segments=\"s,ee,z,|\"><scene act=\"false\"><thing c_role=\"@other\" m_role=\"@agent\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"/></scene><sound sound=\"s\"/><sound sound=\"ee\"/><sound sound=\"z\"/><scene act=\"false\"><thing m_role=\"@patient\" subsumes=\"x_2\"/></scene><scene act=\"true\" actType=\"@see\" domain=\"mental\" result=\"yes\" time=\"@now\"><thing c_role=\"@other\" id=\"x_1\" m_role=\"@agent\" number=\"@one\" t_type=\"@person\"/><thing id=\"x_2\" m_role=\"@patient\"/></scene></script></word><word name=\"I\"><script description=\"'I' means the speaker in an agent role in some act scene.\" segments=\"ie,|\"><sound sound=\"ie\"/><scene result=\"yes\"><thing c_role=\"@speaker\" m_role=\"@agent\" t_type=\"@person\"/></scene></script></word><word name=\"her(pat)\"><script description=\"The meaning of 'her'(patient) is a single female person in a patient role in some action, who the listener can identify (choice @defined) and who is not the speaker or the listener (c_role @other)\" segments=\"h,ur,|\"><sound sound=\"h\"/><sound sound=\"ur\"/><scene act=\"false\" result=\"yes\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@patient\" number=\"@one\" t_type=\"@person\"><prop gender=\"@female\"/></thing></scene></script></word><word name=\"girls\"><script description=\"the meaning of 'girls' is a plural thing of type person with properties age = @young and gender= @female&#10;&#10;\" segments=\"g,ur,l,z,|\"><sound sound=\"g\"/><sound sound=\"ur\"/><sound sound=\"l\"/><sound sound=\"z\"/><scene act=\"false\" result=\"yes\"><thing number=\"@many\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@female\"/></thing></scene></script></word><word name=\"gives\"><script description=\"when words describing a person (top scene) are followed by 'give' , and then followed by words describing a person (second scene - the recipient), and followed by words describing the thing (third scene - the gift), the meaning (bottom action scene) is that at time @now, the first person or people causes the gift to go along a path which ends in a 'place' which is the possession of the recipient.\" segments=\"g,i,v,z,|\"><scene act=\"false\"><thing number=\"@one\" subsumes=\"x1\" t_type=\"@person\"/></scene><sound sound=\"g\"/><sound sound=\"i\"/><sound sound=\"v\"/><sound sound=\"z\"/><scene act=\"false\"><thing subsumes=\"x_2\" t_type=\"@person\"/></scene><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing id=\"x1\" m_role=\"@agent\" number=\"@one\" t_type=\"@person\"/><scene act=\"true\" s_type=\"@go\"><thing id=\"x_1\" m_role=\"@agent\"/><path><place domain=\"possession\" placeType=\"@of\"><thing id=\"x_2\" t_type=\"@person\"/></place></path></scene></scene></script></word><word name=\"blue\"><script description=\"when 'blue' is followed by words describing a thing (top scene), the meaning (bottom scene) is the thing with property colour= @blue.\" segments=\"b,l,oo,|\"><sound sound=\"b\"/><sound sound=\"l\"/><sound sound=\"oo\"/><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"false\" result=\"yes\"><thing id=\"x_1\"><prop colour=\"@blue\"/></thing></scene></script></word><word name=\"my\"><script description=\"When 'my' is followed by words describing a thing (top scene), the meaning (bottom scene) is the thing in a 'place' which is the possession of the speaker.&#10;&#10;\" segments=\"m,ie,|\"><sound sound=\"m\"/><sound sound=\"ie\"/><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"false\" result=\"yes\"><thing id=\"x_1\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@speaker\"/></place></thing></scene></script></word><word name=\"drank\"><script description=\"when words describing a person (top scene) are followed by 'drank', and then followed by words describing a drink (middle scene), the meaning (bottom scene) is an action scene of eating, at time = @past with the person as agent (doing the action) and the drink as patient\" segments=\"d,r,a,n,k,|\"><scene act=\"false\"><thing m_role=\"@agent\" subsumes=\"x1\" t_type=\"@person\"/></scene><sound sound=\"d\"/><sound sound=\"r\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"k\"/><scene act=\"false\"><thing m_role=\"@patient\" subsumes=\"x2\" t_type=\"@drink\"/></scene><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing id=\"x1\" m_role=\"@agent\" t_type=\"@person\"/><thing id=\"x2\" m_role=\"@patient\" t_type=\"@drink\"/></scene></script></word><word name=\"meet\"><script description=\"when words describing a  person (top scene) are followed by 'meet', and then followed by words describing another person (middle scene), the meaning (bottom scene) is a social scene of meeting, at time = @now with the first person as agent (doing the action) and the second person as patient\" segments=\"m,ee,t,|\"><scene act=\"false\"><thing subsumes=\"x1\" t_type=\"@person\"/></scene><sound sound=\"m\"/><sound sound=\"ee\"/><sound sound=\"t\"/><scene act=\"false\"><thing m_role=\"@patient\" subsumes=\"x2\"/></scene><scene act=\"true\" actType=\"@meet\" domain=\"social\" result=\"yes\" time=\"@now\"><thing id=\"x1\" m_role=\"@agent\" t_type=\"@person\"/><thing id=\"x2\" m_role=\"@patient\"/></scene></script></word><word name=\"an\"><script description=\"The indefinite article leaves it open to choose any of the described things in the conversational context - there may be several things to choose from.\" segments=\"u,n,|\"><sound sound=\"u\"/><sound sound=\"n\"/><scene act=\"false\"><thing choice=\"@any\" subsumes=\"x2\"/></scene><scene act=\"false\" result=\"yes\"><thing choice=\"@any\" id=\"x2\"/></scene></script></word><word name=\"al\"><script segments=\"a,l,|\"><sound sound=\"a\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\"><thing identity=\"@al\" number=\"@one\" t_type=\"@person\"><prop gender=\"@male\"/></thing></scene></script></word><word name=\"bananas\"><script segments=\"b,u,n,ar,n,u,z,|\"><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"ar\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"z\"/><scene act=\"false\" result=\"yes\"><thing number=\"@many\" t_type=\"@banana\"/></scene></script></word><word name=\"go\"><script segments=\"g,oe,|\"><scene act=\"false\"><thing number=\"@many\" subsumes=\"x26\" t_type=\"@animate\"/></scene><sound sound=\"g\"/><sound sound=\"oe\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing id=\"x26\" m_role=\"@agent\" number=\"@many\" t_type=\"@animate\"/><path/></scene></script></word><word name=\"give\"><script description=\"when words describing a person (top scene) are followed by 'give' , and then followed by words describing a person (second scene - the recipient), and followed by words describing the thing (third scene - the gift), the meaning (bottom action scene) is that at time @now, the first person or people causes the gift to go along a path which ends in a 'place' which is the possession of the recipient.\" segments=\"g,i,v,|\"><scene act=\"false\"><thing subsumes=\"x1\" t_type=\"@person\"/></scene><sound sound=\"g\"/><sound sound=\"i\"/><sound sound=\"v\"/><scene act=\"false\"><thing subsumes=\"x_2\" t_type=\"@person\"/></scene><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing id=\"x1\" m_role=\"@agent\" t_type=\"@person\"/><scene act=\"true\" s_type=\"@go\"><thing id=\"x_1\" m_role=\"@agent\"/><path><place domain=\"possession\" placeType=\"@of\"><thing id=\"x_2\" t_type=\"@person\"/></place></path></scene></scene></script></word><word name=\"anna\"><script description=\"The meaning of 'anna' is a single  female person with identity = @anna. This is like a pointer to other representations of Anna in the brain.\" segments=\"a,n,u,|\"><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><scene result=\"yes\"><thing identity=\"@anna\" number=\"@one\" t_type=\"@person\"><prop gender=\"@female\"/></thing></scene></script></word><word name=\"hugs\"><script description=\"when words describing a single person (top scene) are followed by 'hugs', and then followed by words describing another person (middle scene), the meaning (bottom scene) is an action scene of hugging, at time = @now with the first person as agent (doing the action) and the second person as patient.\" segments=\"h,u,g,s,|\"><scene act=\"false\"><thing c_role=\"@other\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"/></scene><sound sound=\"h\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"s\"/><scene act=\"false\"><thing m_role=\"@patient\" subsumes=\"x2\" t_type=\"@animate\"/></scene><scene act=\"true\" actType=\"@hug\" domain=\"social\" result=\"yes\" time=\"@now\"><thing c_role=\"@other\" id=\"x1\" m_role=\"@agent\" number=\"@one\" t_type=\"@person\"/><thing id=\"x2\" m_role=\"@patient\" t_type=\"@animate\"/></scene></script></word><word name=\"they\"><script description=\"The meaning of 'they' is a scene describing more than one person, who can be identified by the listener (choice @defined), who are not either the speaker or the listener (c_role @other) in an agent role.\" segments=\"th,ai,|\"><sound sound=\"th\"/><sound sound=\"ai\"/><scene act=\"false\" result=\"yes\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@many\"/></scene></script></word><word name=\"tim\"><script description=\"The meaning of 'tim' is a single  male person with identity = @tim . This is like a pointer to other representations of Tim in the brain.\" segments=\"t,i,m,|\"><sound sound=\"t\"/><sound sound=\"i\"/><sound sound=\"m\"/><scene result=\"yes\"><thing identity=\"@tim\" number=\"@one\" t_type=\"@person\"><prop gender=\"@male\"/></thing></scene></script></word><word name=\"cherry\"><script description=\"the meaning of 'cherry' is a single thing of type @cherry.\" segments=\"ch,e,r,i,|\"><sound sound=\"ch\"/><sound sound=\"e\"/><sound sound=\"r\"/><sound sound=\"i\"/><scene result=\"yes\"><thing number=\"@one\" t_type=\"@cherry\"/></scene></script></word><word name=\"tell\"><script description=\"When words describing a person (top scene) are followed by 'tell', then followed by words describing another person (second scene), and then followed by words describing any action (third scene) , then the meaning (bottom scene) is a scene in the mental domain, describing the first person at time @now  causing the second person to hear about the act.&#10;&#10;\" segments=\"t,e,l,|\"><scene act=\"false\"><thing subsumes=\"x1\" t_type=\"@person\"/></scene><sound sound=\"t\"/><sound sound=\"e\"/><sound sound=\"l\"/><scene act=\"false\"><thing subsumes=\"x_3\" t_type=\"@person\"/></scene><scene act=\"true\" subsumes=\"x_1\"/><scene act=\"true\" actType=\"@tell\" domain=\"mental\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing id=\"x1\" m_role=\"@agent\" t_type=\"@person\"/><scene act=\"true\" actType=\"@hear\" domain=\"mental\" result=\"yes\" time=\"@now\"><thing id=\"x_3\" m_role=\"@agent\" t_type=\"@person\"/><scene act=\"true\" id=\"x_1\"/></scene></scene></script></word><word name=\"fridge\"><script segments=\"f,r,i,j,|\"><sound sound=\"f\"/><sound sound=\"r\"/><sound sound=\"i\"/><sound sound=\"j\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" t_type=\"@fridge\"/></scene></script></word><word name=\"me\"><script description=\"The meaning of 'me' is the speaker in a patient role in some action\" segments=\"m,ee,|\"><sound sound=\"m\"/><sound sound=\"ee\"/><scene act=\"false\" result=\"yes\"><thing c_role=\"@speaker\" m_role=\"@patient\" t_type=\"@person\"/></scene></script></word><word name=\"falls\"><script description=\"when words describing a single thing (top scene) are followed by 'falls', the meaning (bottom scene) is an action scene of going, at time = @now, with a path of direction @down and the thing as agent (doing the action)\" segments=\"f,or,l,z,|\"><scene act=\"false\"><thing c_role=\"@other\" number=\"@one\" subsumes=\"x26\"/></scene><sound sound=\"f\"/><sound sound=\"or\"/><sound sound=\"l\"/><sound sound=\"z\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing c_role=\"@other\" id=\"x26\" m_role=\"@agent\" number=\"@one\"/><path direction=\"@down\"/></scene></script></word><word name=\"boiled\"><script description=\"when 'boiled' is followed by words describing a thing of type @food (top scene), the meaning (bottom scene) is the thing with property cooking = @boiled.\" segments=\"b,o,y,l,d,|\"><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"l\"/><sound sound=\"d\"/><scene><thing subsumes=\"x_1\" t_type=\"@food\"/></scene><scene result=\"yes\"><thing id=\"x_1\" t_type=\"@food\"><prop cooking=\"@boiled\"/></thing></scene></script></word><word name=\"kitchen\"><script description=\"the meaning of 'kitchen' is a single  thing of type @kitchen.\" segments=\"k,i,ch,i,n,|\"><sound sound=\"k\"/><sound sound=\"i\"/><sound sound=\"ch\"/><sound sound=\"i\"/><sound sound=\"n\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" t_type=\"@kitchen\"/></scene></script></word><word name=\"who\"><script description=\"when words describing some person (top scene) are followed by 'who' and then followed by words describing an action involving some person (middle scene), then the meaning (bottom scene) is that the first person has the same identity as the person in involved the action scene.\" segments=\"h,oo,|\"><scene act=\"false\"><thing identity=\"@x\" subsumes=\"x_1\" t_type=\"@person\"/></scene><sound sound=\"h\"/><sound sound=\"oo\"/><scene act=\"true\" subsumes=\"x_2\"><thing identity=\"@x\" t_type=\"@person\"/></scene><scene act=\"false\" result=\"yes\" s_type=\"@describes\"><thing id=\"x_1\" identity=\"@x\" t_type=\"@person\"/><scene act=\"true\" id=\"x_2\"><thing identity=\"@x\" t_type=\"@person\"/></scene></scene></script></word><word name=\"them\"><script description=\"The meaning of 'them' is a scene describing more than one person, who can be identified by the listener (choice @defined), who are not either the speaker or the listener (c_role @other) in a patient role.\" segments=\"th,e,m,|\"><sound sound=\"th\"/><sound sound=\"e\"/><sound sound=\"m\"/><scene act=\"false\" result=\"yes\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@patient\" number=\"@many\"/></scene></script></word><word name=\"thinks\"><script description=\"When words describing a single person (top scene), who is not the speaker or the listener (c_role= @other)  are followed by 'thinks', and then followed by words describing any action (middle scene) , then the meaning (bottom scene) is a scene in the mental domain, describing the person at time @now thinking about the act.\" segments=\"th,i,n,k,s,|\"><scene act=\"false\"><thing c_role=\"@other\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"/></scene><sound sound=\"th\"/><sound sound=\"i\"/><sound sound=\"n\"/><sound sound=\"k\"/><sound sound=\"s\"/><scene act=\"true\" subsumes=\"x_2\"/><scene act=\"true\" actType=\"@think\" domain=\"mental\" result=\"yes\" time=\"@now\"><thing c_role=\"@other\" id=\"x_1\" number=\"@one\" t_type=\"@person\"/><scene act=\"true\" id=\"x_2\"/></scene></script></word><word name=\"john\"><script description=\"The meaning of 'john' is a single  male person with identity = @john . This is like a pointer to other representations of John in the brain.\" segments=\"j,o,n,|\"><sound sound=\"j\"/><sound sound=\"o\"/><sound sound=\"n\"/><scene result=\"yes\"><thing identity=\"@john\" number=\"@one\" t_type=\"@person\"><prop gender=\"@male\"/></thing></scene></script></word><word name=\"boys\"><script segments=\"b,o,y,z,|\"><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"z\"/><scene act=\"false\" result=\"yes\"><thing number=\"@many\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing></scene></script></word><word name=\"runs\"><script description=\"when words describing an animate thing (top scene) are followed by 'runs', the meaning (bottom scene) is an action scene of going,at time = @now with manner = @fast and the animate thing as the agent (doing the action)\" segments=\"r,u,n,z,|\"><scene act=\"false\"><thing c_role=\"@other\" m_role=\"@agent\" number=\"@one\" subsumes=\"x24\" t_type=\"@animate\"/></scene><sound sound=\"r\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"z\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing c_role=\"@other\" id=\"x24\" m_role=\"@agent\" number=\"@one\" t_type=\"@animate\"/><manner speed=\"@fast\"/></scene></script></word><word name=\"run\"><script description=\"when words describing an animate thing (top scene) are followed by 'run', the meaning (bottom scene) is an action scene of going, at time = @now with manner = @fast and the animate thing as agent (doing the action)\" segments=\"r,u,n,|\"><scene act=\"false\"><thing number=\"@many\" subsumes=\"x26\" t_type=\"@animate\"/></scene><sound sound=\"r\"/><sound sound=\"u\"/><sound sound=\"n\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing id=\"x26\" m_role=\"@agent\" number=\"@many\" t_type=\"@animate\"/><manner speed=\"@fast\"/></scene></script></word><word name=\"drops\"><script segments=\"d,r,o,p,s,|\"><scene act=\"false\"><thing c_role=\"@other\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@animate\"/></scene><sound sound=\"d\"/><sound sound=\"r\"/><sound sound=\"o\"/><sound sound=\"p\"/><sound sound=\"s\"/><scene act=\"false\"><thing m_role=\"@patient\" subsumes=\"x_1\" t_type=\"@inanimate\"/></scene><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing c_role=\"@other\" id=\"x1\" m_role=\"@agent\" number=\"@one\" t_type=\"@animate\"/><scene act=\"true\" s_type=\"@go\"><thing id=\"x_1\" m_role=\"@patient\" t_type=\"@inanimate\"/><path direction=\"@down\"/></scene></scene></script></word><word name=\"pie\"><script description=\"the meaning of 'pie' is a single thing of type @pie, which is a sub-type pf @food.\" segments=\"p,ie,|\"><sound sound=\"p\"/><sound sound=\"ie\"/><scene result=\"yes\"><thing t_type=\"@pie\"/></scene></script></word><word name=\"thought\"><script description=\"When words describing a person (top scene) are followed by 'thought', and then followed by words describing any action (middle scene) , then the meaning (bottom scene) is a scene in the mental domain, describing the person at time @past thinking about the act.\" segments=\"th,or,t,|\"><scene act=\"false\"><thing subsumes=\"x_1\" t_type=\"@person\"/></scene><sound sound=\"th\"/><sound sound=\"or\"/><sound sound=\"t\"/><scene act=\"true\" subsumes=\"x_2\"/><scene act=\"true\" actType=\"@think\" domain=\"mental\" result=\"yes\" time=\"@past\"><thing id=\"x_1\" t_type=\"@person\"/><scene act=\"true\" id=\"x_2\"/></scene></script></word><word name=\"icecream\"><script description=\"the meaning of 'icecream' is a  thing of type @icecream.\" segments=\"ie,s,k,r,ee,m,|\"><sound sound=\"ie\"/><sound sound=\"s\"/><sound sound=\"k\"/><sound sound=\"r\"/><sound sound=\"ee\"/><sound sound=\"m\"/><scene act=\"false\" result=\"yes\"><thing t_type=\"@iceCream\"/></scene></script></word><word name=\"school\"><script description=\"the meaning of 'school' is a single thing of type @school.\" segments=\"s,k,uu,l,|\"><sound sound=\"s\"/><sound sound=\"k\"/><sound sound=\"uu\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" t_type=\"@school\"/></scene></script></word><word name=\"the\"><script description=\"The definite article preceding the description of a single thing indicates that the speaker is referring to one thing that the listener can identify, even if there are several such things in context. \" segments=\"th,u,|\"><sound sound=\"th\"/><sound sound=\"u\"/><scene act=\"false\"><thing subsumes=\"x1\"/></scene><scene act=\"false\" result=\"yes\"><thing choice=\"@defined\" id=\"x1\"/></scene></script></word><word name=\"ben\"><script description=\"The meaning of 'ben' is a single  male person with identity = @ben. This is like a pointer to other representations of Ben in the brain.\" segments=\"b,e,n,|\"><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"n\"/><scene result=\"yes\"><thing identity=\"@ben\" number=\"@one\" t_type=\"@person\"><prop gender=\"@male\"/></thing></scene></script></word><word name=\"f_bathtime\"><script description=\"This is a frame, or learned situation. It is learned before language, and is used to define roles (such as bathgiver and bather) and to understand things and actions. It has the following scenes, in sequence: (1) the bathgiver and the bather go to the bathroom; (2) the bathgiver removes the bathers' clothes; (3) the bathgiver causes  warm water to go into the bath; (4) the bather goes into the bath; (5) the bathgiver rubs the bather with soap or a sponge; (6) the bather goes out of the bath; (7) the bathgiver rubs the bather with a towel; (8) the bathgiver puts pyjamas on the bather. Not all slots have been filled in.\"><scene s_type=\"@go\"><thing><thing m_role=\"@bathgiver\"/><thing m_role=\"@bather\"/></thing><path pathType=\"@to\"><place placeType=\"@in\"><thing t_type=\"@bathroom\"/></place></path></scene><scene actType=\"@remove\"><thing m_role=\"@bathgiver\"/><thing t_type=\"@clothes\"/><path pathType=\"@from\"><place placeType=\"@on\"><thing m_role=\"@bather\"/></place></path></scene><scene s_type=\"@cause\"><thing m_role=\"@bathgiver\"/><scene s_type=\"@go\"><thing t_type=\"@water\"><prop temp=\"@warm\"/></thing><path pathType=\"@to\"><place placeType=\"@in\"><thing t_type=\"@bath\"/></place></path></scene></scene><scene s_type=\"@go\"><thing m_role=\"@bather\"/><path pathType=\"@to\"><place placeType=\"@in\"><thing t_type=\"@bath\"/></place></path></scene><scene actType=\"@rub\"><thing m_role=\"@bathgiver\"/><thing m_role=\"@bather\"/><thing m_role=\"@scrubber\" t_type=\"@usefulThing\"/></scene><scene s_type=\"@go\"><thing m_role=\"@bather\"/><path pathType=\"@from\"><place placeType=\"@in\"><thing t_type=\"@bath\"/></place></path></scene><scene actType=\"@rub\"><thing m_role=\"@bathgiver\"/><thing m_role=\"@bather\"/><thing m_role=\"@dryer\" t_type=\"@towel\"/></scene><scene actType=\"@move\" result=\"yes\"><thing m_role=\"@bathgiver\"/><thing t_type=\"@pyjamas\"/><path pathType=\"@to\"><place placeType=\"@on\"><thing m_role=\"@bather\"/></place></path></scene></script></word><word name=\"gave\"><script description=\"when words describing a person (top scene) are followed by 'gave' , and then followed by words describing a person (second scene - the recipient), and followed by words describing the thing (third scene - the gift), the meaning (bottom action scene) is that at time @past, the first person or people causes the gift to go along a path which ends in a 'place' which is the possession of the recipient.\" segments=\"g,ai,v,|\"><scene act=\"false\"><thing subsumes=\"x1\" t_type=\"@person\"/></scene><sound sound=\"g\"/><sound sound=\"ai\"/><sound sound=\"v\"/><scene act=\"false\"><thing subsumes=\"x_2\" t_type=\"@person\"/></scene><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing id=\"x1\" m_role=\"@agent\" t_type=\"@person\"/><scene act=\"true\" s_type=\"@go\"><thing id=\"x_1\" m_role=\"@agent\"/><path><place domain=\"possession\" placeType=\"@of\"><thing id=\"x_2\" t_type=\"@person\"/></place></path></scene></scene></script></word><word name=\"heard\"><script description=\"When words describing some person (top scene) are followed by 'heard', followed by words describing any scene (middle scene), the meaning (bottom scene) is an action scene at time @past, in which the person hears the middle scene\" segments=\"h,ur,d,|\"><scene act=\"false\"><thing subsumes=\"x_1\" t_type=\"@person\"/></scene><sound sound=\"h\"/><sound sound=\"ur\"/><sound sound=\"d\"/><scene act=\"true\" subsumes=\"x_2\"/><scene act=\"true\" actType=\"@hear\" domain=\"mental\" result=\"yes\" time=\"@past\"><thing id=\"x_1\" t_type=\"@person\"/><scene act=\"true\" id=\"x_2\"/></scene></script></word><word name=\"goToBed\"><script description=\"The meaning is a scene in the mental domain, in which the speaker causes the listener to intend to go along a path which ends in bed,&#10;&#10;More elaborate semantic analyses are possible.\" segments=\"g,oe,t,u,b,e,d,|\"><sound sound=\"g\"/><sound sound=\"oe\"/><sound sound=\"t\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"d\"/><scene act=\"true\" actMode=\"@does\" domain=\"mental\" result=\"yes\" s_type=\"@cause\"><thing c_role=\"@speaker\" t_type=\"@person\"/><scene act=\"true\" actMode=\"@intend\" domain=\"spatial\" s_type=\"@go\"><thing c_role=\"@listener\" t_type=\"@person\"/><path pathType=\"@to\"><place placeType=\"@in\"><thing t_type=\"@bed\"/></place></path></scene></scene></script></word><word name=\"she\"><script description=\"The meaning of 'she' is a single female person in an agent role in some action, who the listener can identify (choice @defined) and who is not the speaker or the listener (c_role @other)\" segments=\"sh,ee,|\"><sound sound=\"sh\"/><sound sound=\"ee\"/><scene result=\"yes\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\"><prop gender=\"@female\"/></thing></scene></script></word><word name=\"hits\"><script description=\"when words describing a single person (top scene) are followed by 'hits', and then followed by words describing another person (middle scene), the meaning (bottom scene) is an action scene of hittingng, at time = @now with the first person as agent (doing the action) and the second person as patient\" segments=\"h,i,t,s,|\"><scene act=\"false\"><thing c_role=\"@other\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"/></scene><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"t\"/><sound sound=\"s\"/><scene act=\"false\"><thing m_role=\"@patient\" subsumes=\"x2\"/></scene><scene act=\"true\" actType=\"@hit\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing c_role=\"@other\" id=\"x1\" m_role=\"@agent\" number=\"@one\" t_type=\"@person\"/><thing id=\"x2\" m_role=\"@patient\"/></scene></script></word><word name=\"warm\"><script description=\"when 'warm' is followed by words describing a thing (top scene), the meaning (bottom scene) is the thing with property temperature (temp) = @warm.\" segments=\"w,or,m,|\"><sound sound=\"w\"/><sound sound=\"or\"/><sound sound=\"m\"/><scene><thing subsumes=\"x_1\"/></scene><scene result=\"yes\"><thing id=\"x_1\"><prop temp=\"@warm\"/></thing></scene></script></word></words></model>";
	private static String sentenceData = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?><model><sentences><sentence name=\"anna hugs john\"><script description=\"Meaning: an action scene of hugging at time =  @now, with Anna as the agent and John as the patient\" segments=\"a,n,u,|j,o,n,|h,u,g,s,|\" unifyOrder=\"anna john hugs \"><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"h\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"s\"/><sound sound=\"j\"/><sound sound=\"o\"/><sound sound=\"n\"/><scene act=\"true\" actType=\"@hug\" domain=\"social\" result=\"yes\" time=\"@now\"><thing c_role=\"@other\" identity=\"@anna\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@female\"/></thing><thing identity=\"@john\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@person\"><prop gender=\"@male\"/></thing></scene></script></sentence><sentence name=\"my banana\"><script description=\"meaning: a scene with no action, describing a single banana at a place which is the possession of the speaker\" segments=\"b,u,n,ar,n,u,|m,ie,|\" unifyOrder=\"banana my \"><sound sound=\"m\"/><sound sound=\"ie\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"ar\"/><sound sound=\"n\"/><sound sound=\"u\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@banana\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@speaker\"/></place></thing></scene></script></sentence><sentence name=\"boy in bed\"><script segments=\"b,o,y,|b,e,d,|i,n,|\" unifyOrder=\"boy bed in(thing) \"><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"i\"/><sound sound=\"n\"/><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"d\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" t_type=\"@person\"><place placeType=\"@in\"><thing number=\"@one\" t_type=\"@bed\"/></place><prop age=\"@young\"/><prop gender=\"@male\"/></thing></scene></script></sentence><sentence name=\"ben runs\"><script description=\"meaning: an action scene of going at time = @now, with Ben as the agent and with manner speed = @fast\" segments=\"b,e,n,|r,u,n,z,|\" unifyOrder=\"ben runs \"><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"n\"/><sound sound=\"r\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"z\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing c_role=\"@other\" identity=\"@ben\" m_role=\"@agent\" number=\"@one\" subsumes=\"x24\" t_type=\"@person\"><prop gender=\"@male\"/></thing><manner speed=\"@fast\"/></scene></script></sentence><sentence name=\"I saw him\"><script description=\"meaning: an action scene in the mental domain, in which the speaker is the agent and a single male defined person (not the listener - c_role = @other) is the patient.\" segments=\"ie,|h,i,m,|s,or,|\" unifyOrder=\"I him saw(thing) \"><sound sound=\"ie\"/><sound sound=\"s\"/><sound sound=\"or\"/><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"m\"/><scene act=\"true\" actType=\"@see\" domain=\"mental\" result=\"yes\" time=\"@past\"><thing c_role=\"@speaker\" m_role=\"@agent\" subsumes=\"x_1\" t_type=\"@person\"/><scene act=\"false\" subsumes=\"x_2\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@patient\" number=\"@one\"><prop gender=\"@male\"/></thing></scene></scene></script></sentence><sentence name=\"john ate the pie\"><script description=\"Meaning: an action scene of eating at time =  @past, with John as the agent and a defined pie as the patient\" segments=\"j,o,n,|p,ie,|th,u,|ai,t,|\" unifyOrder=\"john pie the ate \"><sound sound=\"j\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"ai\"/><sound sound=\"t\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"p\"/><sound sound=\"ie\"/><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing identity=\"@john\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><thing choice=\"@defined\" m_role=\"@patient\" subsumes=\"x2\" t_type=\"@pie\"/></scene></script></sentence><sentence name=\"phoebe ate a red apple\"><script description=\"Meaning: an action scene of eating at time =  @past, with Phoebe as the agent and a single undefined (@any) apple with property colour = @red as the patient\" segments=\"a,p,u,l,|r,e,d,|u,|f,ee,b,i,|ai,t,|\" unifyOrder=\" apple red a phoebe ate\"><sound sound=\"f\"/><sound sound=\"ee\"/><sound sound=\"b\"/><sound sound=\"i\"/><sound sound=\"ai\"/><sound sound=\"t\"/><sound sound=\"u\"/><sound sound=\"r\"/><sound sound=\"e\"/><sound sound=\"d\"/><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing identity=\"@phoebe\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@female\"/></thing><thing choice=\"@any\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@apple\"><prop colour=\"@red\"/></thing></scene></script></sentence><sentence name=\"bananas on the bed\"><script description=\"meaning: a scene with no action, describing plural things of type banana at a place which is on a defined bed\" segments=\"b,u,n,ar,n,u,z,|b,e,d,|th,u,|o,n,|\" unifyOrder=\"bananas bed the on(thing) \"><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"ar\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"z\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"d\"/><scene act=\"false\" result=\"yes\"><thing number=\"@many\" subsumes=\"x_1\" t_type=\"@banana\"><place placeType=\"@on\"><thing choice=\"@defined\" number=\"@one\" subsumes=\"x_2\" t_type=\"@bed\"/></place></thing></scene></script></sentence><sentence name=\"'doggie runs'\"><script description=\"meaning: an action scene of going at time = @now in which a dog is the agent and the manner is fast.\" segments=\"d,o,g,i,|r,u,n,z,|\" unifyOrder=\"doggie runs\"><sound sound=\"d\"/><sound sound=\"o\"/><sound sound=\"g\"/><sound sound=\"i\"/><sound sound=\"r\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"z\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing c_role=\"@other\" m_role=\"@agent\" number=\"@one\" subsumes=\"x24\" t_type=\"@dog\"/><manner speed=\"@fast\"/></scene></script></sentence><sentence name=\"tim and zack ate a red banana\"><script description=\"Meaning: an action scene of eating at time =  @past, with a composite plural thing composed of Tim and Zack  as the agent, and a single undefined (@any) banana with colour @red as the patient&#10;&#10;\" segments=\"t,i,m,|z,a,k,|b,u,n,ar,n,u,|a,n,d,|r,e,d,|u,|ai,t,|\" unifyOrder=\"tim zack banana and red a ate \"><sound sound=\"t\"/><sound sound=\"i\"/><sound sound=\"m\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"d\"/><sound sound=\"z\"/><sound sound=\"a\"/><sound sound=\"k\"/><sound sound=\"ai\"/><sound sound=\"t\"/><sound sound=\"u\"/><sound sound=\"r\"/><sound sound=\"e\"/><sound sound=\"d\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"ar\"/><sound sound=\"n\"/><sound sound=\"u\"/><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing m_role=\"@agent\" number=\"@many\" subsumes=\"x1\" t_type=\"@person\"><thing identity=\"@tim\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><thing identity=\"@zack\" number=\"@one\" subsumes=\"x_2\" t_type=\"@person\"><prop gender=\"@male\"/></thing></thing><thing choice=\"@any\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@banana\"><prop colour=\"@red\"/></thing></scene></script></sentence><sentence name=\"I gave him my bat\"><script description=\"meaning: a scene at time = @past in which the speaker as agent caused a single bat, which had previously been in the speaker's possession, to move along a path which ended in a place which was the possession of a defined male person, who is neither the speaker nor the listener (c_role = @other).\" segments=\"ie,|h,i,m,|b,a,t,|m,ie,|g,ai,v,|\" unifyOrder=\"I him bat my gave \"><sound sound=\"ie\"/><sound sound=\"g\"/><sound sound=\"ai\"/><sound sound=\"v\"/><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"m\"/><sound sound=\"m\"/><sound sound=\"ie\"/><sound sound=\"b\"/><sound sound=\"a\"/><sound sound=\"t\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing c_role=\"@speaker\" m_role=\"@agent\" subsumes=\"x1\" t_type=\"@person\"/><scene act=\"true\" s_type=\"@go\"><thing m_role=\"@agent\" number=\"@one\" subsumes=\"x_1\" t_type=\"@bat\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@speaker\"/></place></thing><path><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@patient\" number=\"@one\" subsumes=\"x_2\" t_type=\"@person\"><prop gender=\"@male\"/></thing></place></path></scene></scene></script></sentence><sentence name=\"anna eats the pie\"><script description=\"Meaning: an action scene of eating at time =  @now, with Anna as the agent and a defined pie as the patient\" segments=\"a,n,u,|p,ie,|th,u,|ee,t,s,|\" unifyOrder=\"anna pie the eats \"><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"ee\"/><sound sound=\"t\"/><sound sound=\"s\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"p\"/><sound sound=\"ie\"/><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing c_role=\"@other\" identity=\"@anna\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@female\"/></thing><thing choice=\"@defined\" m_role=\"@patient\" subsumes=\"x2\" t_type=\"@pie\"/></scene></script></sentence><sentence name=\"the boys meet him\"><script description=\"Meaning: a social action scene of meeting at time @now, with defined plural young male persons as agents, and a single defined male person (not the speaker or listener) as patient.\" segments=\"b,o,y,z,|h,i,m,|th,u,|m,ee,t,|\" unifyOrder=\"boys him the meet \"><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"z\"/><sound sound=\"m\"/><sound sound=\"ee\"/><sound sound=\"t\"/><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"m\"/><scene act=\"true\" actType=\"@meet\" domain=\"social\" result=\"yes\" time=\"@now\"><thing choice=\"@defined\" m_role=\"@agent\" number=\"@many\" subsumes=\"x1\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\"><prop gender=\"@male\"/></thing></scene></script></sentence><sentence name=\"anna gave the boys a green apple\"><script description=\"Meaning: an action scene of causing at time =  @past, with Anna as the agent, causing an apple to move into the possession of a plural thing, composed of young male people.\" segments=\"a,n,u,|b,o,y,z,|a,p,u,l,|th,u,|g,r,ee,n,|u,|g,ai,v,|\" unifyOrder=\"anna boys apple the green a gave \"><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"ai\"/><sound sound=\"v\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"z\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"r\"/><sound sound=\"ee\"/><sound sound=\"n\"/><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing identity=\"@anna\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@female\"/></thing><scene act=\"true\" s_type=\"@go\"><thing choice=\"@any\" m_role=\"@agent\" number=\"@one\" subsumes=\"x_1\" t_type=\"@apple\"><prop colour=\"@green\"/></thing><path><place domain=\"possession\" placeType=\"@of\"><thing choice=\"@defined\" number=\"@many\" subsumes=\"x_2\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing></place></path></scene></scene></script></sentence><sentence name=\"his chair\"><script description=\"meaning: a scene with no action, describing a chair which is in a place which is the possession of a defined male person, who is neither the speaker nor the listener (c_role = @other)\" segments=\"ch,ai,r,|h,i,z,|\" unifyOrder=\"chair his \"><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"z\"/><sound sound=\"ch\"/><sound sound=\"ai\"/><sound sound=\"r\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@chair\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@other\" choice=\"@defined\" number=\"@one\" t_type=\"@person\"><prop gender=\"@male\"/></thing></place></thing></scene></script></sentence><sentence name=\"zack s foot\"><script description=\"meaning: a scene with no action, describing a foot in a place which is the possession of Zack\" segments=\"z,a,k,|f,oo,t,|s,|\" unifyOrder=\"zack foot s(poss) \"><sound sound=\"z\"/><sound sound=\"a\"/><sound sound=\"k\"/><sound sound=\"s\"/><sound sound=\"f\"/><sound sound=\"oo\"/><sound sound=\"t\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_2\" t_type=\"@foot\"><place domain=\"possession\" placeType=\"@of\"><thing identity=\"@zack\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop gender=\"@male\"/></thing></place></thing></scene></script></sentence><sentence name=\"I see my bat\"><script description=\"meaning: an action scene at time = @now in the mental domain, in which the speaker is the agent and a a bat which is in the 'place' of the speaker's possession is the patient.\" segments=\"ie,|b,a,t,|m,ie,|s,ee,|\" unifyOrder=\"I bat my see(thing) \"><sound sound=\"ie\"/><sound sound=\"s\"/><sound sound=\"ee\"/><sound sound=\"m\"/><sound sound=\"ie\"/><sound sound=\"b\"/><sound sound=\"a\"/><sound sound=\"t\"/><scene act=\"true\" actType=\"@see\" domain=\"mental\" result=\"yes\" time=\"@now\"><thing c_role=\"@speaker\" m_role=\"@agent\" subsumes=\"x_1\" t_type=\"@person\"/><scene act=\"false\" subsumes=\"x_2\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@bat\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@speaker\"/></place></thing></scene></scene></script></sentence><sentence name=\"my biscuit\"><script description=\"meaning: a scene with no action, describing a single biscuit at a place which is the possession of the speaker\" segments=\"b,i,s,k,i,t,|m,ie,|\" unifyOrder=\"biscuit my \"><sound sound=\"m\"/><sound sound=\"ie\"/><sound sound=\"b\"/><sound sound=\"i\"/><sound sound=\"s\"/><sound sound=\"k\"/><sound sound=\"i\"/><sound sound=\"t\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@biscuit\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@speaker\"/></place></thing></scene></script></sentence><sentence name=\"he hugs anna\"><script description=\"Meaning: an action scene of hugging at time =  @now, with a defined male person (not the speaker or the listener) as the agent, and Anna as the patient\" segments=\"h,ee,|a,n,u,|h,u,g,s,|\" unifyOrder=\"he anna hugs \"><sound sound=\"h\"/><sound sound=\"ee\"/><sound sound=\"h\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"s\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><scene act=\"true\" actType=\"@hug\" domain=\"social\" result=\"yes\" time=\"@now\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><thing identity=\"@anna\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@person\"><prop gender=\"@female\"/></thing></scene></script></sentence><sentence name=\"green hat\"><script description=\"meaning: a scene with no action, describing one hat whose property colour is @green&#10;&#10;\" segments=\"h,a,t,|g,r,ee,n,|\" unifyOrder=\"hat green \"><sound sound=\"g\"/><sound sound=\"r\"/><sound sound=\"ee\"/><sound sound=\"n\"/><sound sound=\"h\"/><sound sound=\"a\"/><sound sound=\"t\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@hat\"><prop colour=\"@green\"/></thing></scene></script></sentence><sentence name=\"the boy runs\"><script description=\"Meaning: a physical action scene of going at time @now with a defined single young male person as agent, going at speed = @fast.\" segments=\"b,o,y,|th,u,|r,u,n,z,|\" unifyOrder=\"boy,the,runs\"><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"r\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"z\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing><manner speed=\"@fast\"/></scene></script></sentence><sentence name=\"tim ate a banana on the table\"><script description=\"Meaning: an action scene of eating at time =  @past, with Tim as the agent and a single undefined (@any) banana at a place on a defined table, as the patient\" segments=\"t,i,m,|b,u,n,ar,n,u,|t,ai,b,u,l,|u,|th,u,|o,n,|ai,t,|\" unifyOrder=\"tim banana table a the on(thing) ate \"><sound sound=\"t\"/><sound sound=\"i\"/><sound sound=\"m\"/><sound sound=\"ai\"/><sound sound=\"t\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"ar\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"t\"/><sound sound=\"ai\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing identity=\"@tim\" m_role=\"@agent\" number=\"@one\" t_type=\"@person\"><prop gender=\"@male\"/></thing><thing choice=\"@any\" m_role=\"@patient\" number=\"@one\" t_type=\"@banana\"><place placeType=\"@on\"><thing choice=\"@defined\" number=\"@one\" t_type=\"@table\"/></place></thing></scene></script></sentence><sentence name=\"the girls run\"><script description=\"Meaning: a physical action scene of going at time @now with defined plural young female persons as agents, going at speed = @fast.\" segments=\"g,ur,l,z,|th,u,|r,u,n,|\" unifyOrder=\"girls,the,run\"><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"ur\"/><sound sound=\"l\"/><sound sound=\"z\"/><sound sound=\"r\"/><sound sound=\"u\"/><sound sound=\"n\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing choice=\"@defined\" m_role=\"@agent\" number=\"@many\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@female\"/></thing><manner speed=\"@fast\"/></scene></script></sentence><sentence name=\"he eats a cherry\"><script description=\"Meaning: an action scene of eating at time =  @now, with a defined male person (not the speaker or the listener) as the agent, and a cherry as the patient\" segments=\"h,ee,|ch,e,r,i,|u,|ee,t,s,|\" unifyOrder=\"he cherry a eats \"><sound sound=\"h\"/><sound sound=\"ee\"/><sound sound=\"ee\"/><sound sound=\"t\"/><sound sound=\"s\"/><sound sound=\"u\"/><sound sound=\"ch\"/><sound sound=\"e\"/><sound sound=\"r\"/><sound sound=\"i\"/><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><thing choice=\"@any\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@cherry\"/></scene></script></sentence><sentence name=\"the boys ran to him\"><script description=\"Meaning: a physical action scene of going at time @past with defined plural young male persons as agents, going at speed = @fast along a path to a place at a single defined male person (not the speaker or listener).\" segments=\"b,o,y,z,|h,i,m,|th,u,|r,a,n,|t,uu,|\" unifyOrder=\"boys him the ran to(act) \"><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"z\"/><sound sound=\"r\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"t\"/><sound sound=\"uu\"/><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"m\"/><scene act=\"true\" domain=\"spatial\" s_type=\"@go\" subsumes=\"x_2\" time=\"@past\"><manner speed=\"@fast\"/><thing choice=\"@defined\" m_role=\"@agent\" number=\"@many\" subsumes=\"x24\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing><path pathType=\"@to\"><place placeType=\"@at\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@patient\" number=\"@one\" subsumes=\"x_1\"><prop gender=\"@male\"/></thing></place></path></scene></script></sentence><sentence name=\"an apple on the table\"><script description=\"meaning: a scene with no action, describing an (undefined) apple at a place which is on a defined table\" segments=\"a,p,u,l,|t,ai,b,u,l,|u,n,|th,u,|o,n,|\" unifyOrder=\"apple table an the on(thing) \"><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"t\"/><sound sound=\"ai\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\"><thing choice=\"@any\" number=\"@one\" subsumes=\"x_1\" t_type=\"@apple\"><place placeType=\"@on\"><thing choice=\"@defined\" number=\"@one\" subsumes=\"x_2\" t_type=\"@table\"/></place></thing></scene></script></sentence><sentence name=\"she fell\"><script description=\"Meaning: an action scene of going at time =  @now, with a defined female person (not the speaker or the listener) as the agent, along a path with direction = @down\" segments=\"sh,ee,|f,e,l,|\" unifyOrder=\"she fell \"><sound sound=\"sh\"/><sound sound=\"ee\"/><sound sound=\"f\"/><sound sound=\"e\"/><sound sound=\"l\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@past\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x26\"><prop gender=\"@female\"/></thing><path direction=\"@down\"/></scene></script></sentence><sentence name=\"apple and banana\"><script description=\"meaning: a scene with no action, describing a plural thing composed of an apple and a banana\" segments=\"a,p,u,l,|b,u,n,ar,n,u,|a,n,d,|\" unifyOrder=\"apple banana and \"><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"d\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"ar\"/><sound sound=\"n\"/><sound sound=\"u\"/><scene act=\"false\" result=\"yes\"><thing number=\"@many\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@apple\"/><thing number=\"@one\" subsumes=\"x_2\" t_type=\"@banana\"/></thing></scene></script></sentence><sentence name=\"shoes and hat\"><script description=\"meaning: a scene with no action, describing a plural thing composed of plural shoes and a single hat\" segments=\"sh,oo,s,|h,a,t,|a,n,d,|\" unifyOrder=\"shoes hat and \"><sound sound=\"sh\"/><sound sound=\"oo\"/><sound sound=\"s\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"d\"/><sound sound=\"h\"/><sound sound=\"a\"/><sound sound=\"t\"/><scene act=\"false\" result=\"yes\"><thing number=\"@many\"><thing number=\"@many\" subsumes=\"x_1\" t_type=\"@shoe\"/><thing number=\"@one\" subsumes=\"x_2\" t_type=\"@hat\"/></thing></scene></script></sentence><sentence name=\"his banana\"><script description=\"meaning: a scene with no action, describing on banana which is in a place which is the possession of a defined male person, who is neither the speaker nor the listener (c_role = @other)\" segments=\"b,u,n,ar,n,u,|h,i,z,|\" unifyOrder=\"banana his \"><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"z\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"ar\"/><sound sound=\"n\"/><sound sound=\"u\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@banana\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@other\" choice=\"@defined\" number=\"@one\"><prop gender=\"@male\"/></thing></place></thing></scene></script></sentence><sentence name=\"cold fridge\"><script description=\"meaning: a scene with no action, describing a fridge whose property temperature is @cold\" segments=\"f,r,i,j,|k,oe,l,d,|\" unifyOrder=\"fridge cold \"><sound sound=\"k\"/><sound sound=\"oe\"/><sound sound=\"l\"/><sound sound=\"d\"/><sound sound=\"f\"/><sound sound=\"r\"/><sound sound=\"i\"/><sound sound=\"j\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@fridge\"><prop temp=\"@cold\"/></thing></scene></script></sentence><sentence name=\"green bananas\"><script description=\"meaning: a scene with no action, describing more than one banana, whose property colour is @green\" segments=\"b,u,n,ar,n,u,z,|g,r,ee,n,|\" unifyOrder=\"bananas green \"><sound sound=\"g\"/><sound sound=\"r\"/><sound sound=\"ee\"/><sound sound=\"n\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"ar\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"z\"/><scene act=\"false\" result=\"yes\"><thing number=\"@many\" subsumes=\"x_1\" t_type=\"@banana\"><prop colour=\"@green\"/></thing></scene></script></sentence><sentence name=\"ben gave anna the shoes\"><script description=\"meaning: a scene at time = @past in which Ben, the agent, caused some plural defined shoes to move along a path which ended in a place which was the possession of Anna.\" segments=\"b,e,n,|a,n,u,|sh,oo,s,|th,u,|g,ai,v,|\" unifyOrder=\"ben anna shoes the gave \"><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"n\"/><sound sound=\"g\"/><sound sound=\"ai\"/><sound sound=\"v\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"sh\"/><sound sound=\"oo\"/><sound sound=\"s\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing identity=\"@ben\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><scene act=\"true\" s_type=\"@go\"><thing choice=\"@defined\" m_role=\"@agent\" number=\"@many\" subsumes=\"x_1\" t_type=\"@shoe\"/><path><place domain=\"possession\" placeType=\"@of\"><thing identity=\"@anna\" number=\"@one\" subsumes=\"x_2\" t_type=\"@person\"><prop gender=\"@female\"/></thing></place></path></scene></scene></script></sentence><sentence name=\"john s apple\"><script description=\"meaning: a scene with no action, describing an apple at the place of John's possession.\" segments=\"j,o,n,|a,p,u,l,|s,|\" unifyOrder=\"john apple s(poss) \"><sound sound=\"j\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"s\"/><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_2\" t_type=\"@apple\"><place domain=\"possession\" placeType=\"@of\"><thing identity=\"@john\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop gender=\"@male\"/></thing></place></thing></scene></script></sentence><sentence name=\"girl who fell\"><script description=\"meaning: a scene with no action describing a young female person, saying that she has the same identity as a person who at time = @past was the agent of an action scene of going , along a path whose direction was @down&#10;&#10;\" segments=\"g,ur,l,|f,e,l,|h,oo,|\" unifyOrder=\"girl fell who \"><sound sound=\"g\"/><sound sound=\"ur\"/><sound sound=\"l\"/><sound sound=\"h\"/><sound sound=\"oo\"/><sound sound=\"f\"/><sound sound=\"e\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\" s_type=\"@describes\"><thing identity=\"@x\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@female\"/></thing><scene act=\"true\" domain=\"spatial\" s_type=\"@go\" subsumes=\"x_2\" time=\"@past\"><thing identity=\"@x\" m_role=\"@agent\" t_type=\"@person\"/><path direction=\"@down\"/></scene></scene></script></sentence><sentence name=\"green apple\"><script description=\"meaning: a scene with no action, describing one apple whose property colour is @green\" segments=\"a,p,u,l,|g,r,ee,n,|\" unifyOrder=\"apple green \"><sound sound=\"g\"/><sound sound=\"r\"/><sound sound=\"ee\"/><sound sound=\"n\"/><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@apple\"><prop colour=\"@green\"/></thing></scene></script></sentence><sentence name=\"my foot\"><script description=\"meaning: a scene with no action, describing a single foot at a place which is the possession of the speaker\" segments=\"f,oo,t,|m,ie,|\" unifyOrder=\"foot my \"><sound sound=\"m\"/><sound sound=\"ie\"/><sound sound=\"f\"/><sound sound=\"oo\"/><sound sound=\"t\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@foot\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@speaker\"/></place></thing></scene></script></sentence><sentence name=\"boy who saw me\"><script description=\"meaning: a scene with no action describing a young male person, saying that he has the same identity as a person who at time = @past saw the speaker\" segments=\"b,o,y,|m,ee,|s,or,|h,oo,|\" unifyOrder=\"boy me saw(thing) who \"><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"h\"/><sound sound=\"oo\"/><sound sound=\"s\"/><sound sound=\"or\"/><sound sound=\"m\"/><sound sound=\"ee\"/><scene act=\"false\" result=\"yes\" s_type=\"@describes\"><thing identity=\"@x\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing><scene act=\"true\" actType=\"@see\" domain=\"mental\" subsumes=\"x_2\" time=\"@past\"><thing identity=\"@x\" t_type=\"@person\"/><scene act=\"false\" subsumes=\"x_2\"><thing c_role=\"@speaker\" m_role=\"@patient\"/></scene></scene></scene></script></sentence><sentence name=\"al eats a banana\"><script description=\"Meaning: an action scene of eating at time =  @now, with Al as the agent and an undefined banana as the patient\" segments=\"a,l,|b,u,n,ar,n,u,|u,|ee,t,s,|\" unifyOrder=\"al banana a eats \"><sound sound=\"a\"/><sound sound=\"l\"/><sound sound=\"ee\"/><sound sound=\"t\"/><sound sound=\"s\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"ar\"/><sound sound=\"n\"/><sound sound=\"u\"/><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing c_role=\"@other\" identity=\"@al\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><thing choice=\"@any\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@banana\"/></scene></script></sentence><sentence name=\"she sees zack\"><script segments=\"sh,ee,|z,a,k,|s,ee,z,|\" unifyOrder=\"she zack sees(thing) \"><sound sound=\"sh\"/><sound sound=\"ee\"/><sound sound=\"s\"/><sound sound=\"ee\"/><sound sound=\"z\"/><sound sound=\"z\"/><sound sound=\"a\"/><sound sound=\"k\"/><scene act=\"true\" actType=\"@see\" domain=\"mental\" result=\"yes\" time=\"@now\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" t_type=\"@person\"><prop gender=\"@female\"/></thing><thing identity=\"@zack\" m_role=\"@patient\" number=\"@one\" t_type=\"@person\"><prop gender=\"@male\"/></thing></scene></script></sentence><sentence name=\"cold icecream\"><script description=\"meaning: a scene with no action, describing an Ice cream whose property temperature is @cold\" segments=\"ie,s,k,r,ee,m,|k,oe,l,d,|\" unifyOrder=\"icecream cold \"><sound sound=\"k\"/><sound sound=\"oe\"/><sound sound=\"l\"/><sound sound=\"d\"/><sound sound=\"ie\"/><sound sound=\"s\"/><sound sound=\"k\"/><sound sound=\"r\"/><sound sound=\"ee\"/><sound sound=\"m\"/><scene act=\"false\" result=\"yes\"><thing subsumes=\"x_1\" t_type=\"@iceCream\"><prop temp=\"@cold\"/></thing></scene></script></sentence><sentence name=\"I meet ben\"><script description=\"meaning: an action scene of meeting in the social domain at time = @now, in which the speaker is the agent and Ben is the patient.\" segments=\"ie,|b,e,n,|m,ee,t,|\" unifyOrder=\"I ben meet \"><sound sound=\"ie\"/><sound sound=\"m\"/><sound sound=\"ee\"/><sound sound=\"t\"/><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"n\"/><scene act=\"true\" actType=\"@meet\" domain=\"social\" result=\"yes\" time=\"@now\"><thing c_role=\"@speaker\" m_role=\"@agent\" subsumes=\"x1\" t_type=\"@person\"/><thing identity=\"@ben\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@person\"><prop gender=\"@male\"/></thing></scene></script></sentence><sentence name=\"boiled egg\"><script segments=\"e,g,|b,o,y,l,d,|\" unifyOrder=\"egg boiled \"><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"l\"/><sound sound=\"d\"/><sound sound=\"e\"/><sound sound=\"g\"/><scene act=\"false\" result=\"yes\"><thing t_type=\"@egg\"><prop cooking=\"@boiled\"/></thing></scene></script></sentence><sentence name=\"ben goes to the kitchen\"><script description=\"meaning: an action scene of going at time = @now in which Ben, the agent, goes in a path to a place which is at a defined kitchen\" segments=\"b,e,n,|k,i,ch,i,n,|th,u,|g,oe,z,|t,uu,|\" unifyOrder=\"ben kitchen the goes to(act) \"><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"n\"/><sound sound=\"g\"/><sound sound=\"oe\"/><sound sound=\"z\"/><sound sound=\"t\"/><sound sound=\"uu\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"k\"/><sound sound=\"i\"/><sound sound=\"ch\"/><sound sound=\"i\"/><sound sound=\"n\"/><scene act=\"true\" domain=\"spatial\" s_type=\"@go\" subsumes=\"x_2\" time=\"@now\"><thing c_role=\"@other\" identity=\"@ben\" m_role=\"@agent\" number=\"@one\" subsumes=\"x26\" t_type=\"@person\"><prop gender=\"@male\"/></thing><path pathType=\"@to\"><place placeType=\"@at\"><thing choice=\"@defined\" number=\"@one\" subsumes=\"x_1\" t_type=\"@kitchen\"/></place></path></scene></script></sentence><sentence name=\"anna s chair\"><script description=\"meaning: a scene with no action, describing a chair at a place which the possession of Anna\" segments=\"a,n,u,|ch,ai,r,|s,|\" unifyOrder=\"anna chair s(poss) \"><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"s\"/><sound sound=\"ch\"/><sound sound=\"ai\"/><sound sound=\"r\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_2\" t_type=\"@chair\"><place domain=\"possession\" placeType=\"@of\"><thing identity=\"@anna\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop gender=\"@female\"/></thing></place></thing></scene></script></sentence><sentence name=\"cold boy\"><script description=\"meaning: a scene with no action, describing one young male person whose property temperature is @cold\" segments=\"b,o,y,|k,oe,l,d,|\" unifyOrder=\"boy cold \"><sound sound=\"k\"/><sound sound=\"oe\"/><sound sound=\"l\"/><sound sound=\"d\"/><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop age=\"@young\" temp=\"@cold\"/><prop gender=\"@male\"/></thing></scene></script></sentence><sentence name=\"girl who ate an apple\"><script description=\"meaning: a scene with no action describing a young female person, saying that she has the same identity as a person who at time = @past was the agent in a scene of eating, where the patient was an undefined apple\" segments=\"g,ur,l,|a,p,u,l,|u,n,|ai,t,|h,oo,|\" unifyOrder=\"girl apple an ate who \"><sound sound=\"g\"/><sound sound=\"ur\"/><sound sound=\"l\"/><sound sound=\"h\"/><sound sound=\"oo\"/><sound sound=\"ai\"/><sound sound=\"t\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\" s_type=\"@describes\"><thing identity=\"@x\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@female\"/></thing><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" s_type=\"@cause\" subsumes=\"x_2\" time=\"@past\"><thing identity=\"@x\" m_role=\"@agent\" t_type=\"@person\"/><thing choice=\"@any\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@apple\"/></scene></scene></script></sentence><sentence name=\"boys on a chair\"><script description=\"meaning: a scene with no action describing plural young male persons at a place which is on an undefined (@any) chair.\" segments=\"b,o,y,z,|ch,ai,r,|u,|o,n,|\" unifyOrder=\"boys chair a on(thing) \"><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"z\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"ch\"/><sound sound=\"ai\"/><sound sound=\"r\"/><scene act=\"false\" result=\"yes\"><thing number=\"@many\" subsumes=\"x_1\" t_type=\"@person\"><place placeType=\"@on\"><thing choice=\"@any\" number=\"@one\" subsumes=\"x_2\" t_type=\"@chair\"/></place><prop age=\"@young\"/><prop gender=\"@male\"/></thing></scene></script></sentence><sentence name=\"john gave tim the biscuit\"><script description=\"meaning: a scene at time = @past in which John as agent caused a single defined biscuit to move along a path which ended in a place which was the possession of Tim\" segments=\"j,o,n,|t,i,m,|b,i,s,k,i,t,|th,u,|g,ai,v,|\" unifyOrder=\"john tim biscuit the gave \"><sound sound=\"j\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"g\"/><sound sound=\"ai\"/><sound sound=\"v\"/><sound sound=\"t\"/><sound sound=\"i\"/><sound sound=\"m\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"i\"/><sound sound=\"s\"/><sound sound=\"k\"/><sound sound=\"i\"/><sound sound=\"t\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing identity=\"@john\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><scene act=\"true\" s_type=\"@go\"><thing choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x_1\" t_type=\"@biscuit\"/><path><place domain=\"possession\" placeType=\"@of\"><thing identity=\"@tim\" number=\"@one\" subsumes=\"x_2\" t_type=\"@person\"><prop gender=\"@male\"/></thing></place></path></scene></scene></script></sentence><sentence name=\"the hat on  her head\"><script description=\"Meaning: a scene without action describing a single defined hat at a place on a head which is in the place possession of a single defined female person (not the speaker or listener)\" segments=\"h,a,t,|h,e,d,|th,u,|h,ur,|o,n,|\" unifyOrder=\"hat head the her(poss) on(thing) \"><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"h\"/><sound sound=\"a\"/><sound sound=\"t\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"h\"/><sound sound=\"ur\"/><sound sound=\"h\"/><sound sound=\"e\"/><sound sound=\"d\"/><scene act=\"false\" result=\"yes\"><thing choice=\"@defined\" number=\"@one\" subsumes=\"x_1\" t_type=\"@hat\"><place placeType=\"@on\"><thing number=\"@one\" subsumes=\"x_2\" t_type=\"@head\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@other\" choice=\"@defined\" number=\"@one\"><prop gender=\"@female\"/></thing></place></thing></place></thing></scene></script></sentence><sentence name=\"she hugs him\"><script description=\"Meaning: an action scene of hugging at time =  @now, with a defined female person (not the speaker or the listener) as the agent and a defined male person (not the speaker or the listener) as the patient.\" segments=\"sh,ee,|h,i,m,|h,u,g,s,|\" unifyOrder=\"she him hugs \"><sound sound=\"sh\"/><sound sound=\"ee\"/><sound sound=\"h\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"s\"/><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"m\"/><scene act=\"true\" actType=\"@hug\" domain=\"social\" result=\"yes\" time=\"@now\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@female\"/></thing><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@person\"><prop gender=\"@male\"/></thing></scene></script></sentence><sentence name=\"boy runs\"><script description=\"meaning: an action scene of going at time = @now in which a young male person is the agent and the manner is fast. \" segments=\"b,o,y,|r,u,n,z,|\" unifyOrder=\"boy,runs\"><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"r\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"z\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing c_role=\"@other\" m_role=\"@agent\" number=\"@one\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing><manner speed=\"@fast\"/></scene></script></sentence><sentence name=\"he hugs him\"><script description=\"Meaning: an action scene of hugging at time =  @now, with a defined male person (not the speaker or the listener) as the agent, and a defined male person (not the speaker or the listener) as the patient\" segments=\"h,ee,|h,i,m,|h,u,g,s,|\" unifyOrder=\"he him hugs \"><sound sound=\"h\"/><sound sound=\"ee\"/><sound sound=\"h\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"s\"/><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"m\"/><scene act=\"true\" actType=\"@hug\" domain=\"social\" result=\"yes\" time=\"@now\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@person\"><prop gender=\"@male\"/></thing></scene></script></sentence><sentence name=\"boy who anna hits\"><script description=\"meaning: a scene with no action, describing a young male person, saying that he has the same identity as a person who at time = @now is the patient, in an action scene of hitting, where Anna is the agent.\" segments=\"b,o,y,|a,n,u,|h,i,t,s,|h,oo,|\" unifyOrder=\"boy anna hits who \"><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"h\"/><sound sound=\"oo\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"t\"/><sound sound=\"s\"/><scene act=\"false\" result=\"yes\" s_type=\"@describes\"><thing identity=\"@x\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing><scene act=\"true\" actType=\"@hit\" domain=\"spatial\" s_type=\"@cause\" subsumes=\"x_2\" time=\"@now\"><thing identity=\"@x\" m_role=\"@patient\" t_type=\"@person\"/><thing identity=\"@anna\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@female\"/></thing></scene></scene></script></sentence><sentence name=\"she ate a pie\"><script description=\"Meaning: an action scene of eating at time =  @past, with a defined female person (not the speaker or the listener) as the agent and an undefined pie as the patient.\" segments=\"sh,ee,|p,ie,|u,|ai,t,|\" unifyOrder=\"she pie a ate \"><sound sound=\"sh\"/><sound sound=\"ee\"/><sound sound=\"ai\"/><sound sound=\"t\"/><sound sound=\"u\"/><sound sound=\"p\"/><sound sound=\"ie\"/><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@female\"/></thing><thing choice=\"@any\" m_role=\"@patient\" subsumes=\"x2\" t_type=\"@pie\"/></scene></script></sentence><sentence name=\"john and anna\"><script description=\"meaning: a scene with no action, describing a plural thing composed of John and Anna\" segments=\"j,o,n,|a,n,u,|a,n,d,|\" unifyOrder=\"john anna and \"><sound sound=\"j\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"d\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><scene act=\"false\" result=\"yes\"><thing number=\"@many\"><thing identity=\"@john\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><thing identity=\"@anna\" number=\"@one\" subsumes=\"x_2\" t_type=\"@person\"><prop gender=\"@female\"/></thing></thing></scene></script></sentence><sentence name=\"zack hits the table\"><script description=\"meaning: an action scene of hitting at time @now, with Zack as the agent, and one defined table as the patient.\" segments=\"t,ai,b,u,l,|th,u,|z,a,k,|h,i,t,s,|\" unifyOrder=\" table  the zack hits\"><sound sound=\"z\"/><sound sound=\"a\"/><sound sound=\"k\"/><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"t\"/><sound sound=\"s\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"t\"/><sound sound=\"ai\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"true\" actType=\"@hit\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing c_role=\"@other\" identity=\"@zack\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><thing choice=\"@defined\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@table\"/></scene></script></sentence><sentence name=\"the apple fell\"><script description=\"Meaning: an action scene of going at time =  @past, with an apple as the agent, along a path with direction = @down&#10;&#10;\" segments=\"a,p,u,l,|th,u,|f,e,l,|\" unifyOrder=\"apple the fell \"><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><sound sound=\"f\"/><sound sound=\"e\"/><sound sound=\"l\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@past\"><thing choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x26\" t_type=\"@apple\"/><path direction=\"@down\"/></scene></script></sentence><sentence name=\"john drops a biscuit\"><script segments=\"j,o,n,|b,i,s,k,i,t,|u,|d,r,o,p,s,|\" unifyOrder=\"john biscuit a drops \"><sound sound=\"j\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"d\"/><sound sound=\"r\"/><sound sound=\"o\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"i\"/><sound sound=\"s\"/><sound sound=\"k\"/><sound sound=\"i\"/><sound sound=\"t\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing c_role=\"@other\" identity=\"@john\" m_role=\"@agent\" number=\"@one\" t_type=\"@person\"><prop gender=\"@male\"/></thing><scene act=\"true\" s_type=\"@go\"><thing choice=\"@any\" m_role=\"@patient\" number=\"@one\" t_type=\"@biscuit\"/><path direction=\"@down\"/></scene></scene></script></sentence></sentences></model>";
	private static String learningData = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?><model><learning><stage cycleNo=\"0\" name=\"One-word stage\"><learn word=\"boy\"><structure><script description=\"the meaning of 'boy' (bottom scene) is a single thing of type 'person' with properties age = @young and gender = @male\" segments=\"b,o,y,|\"><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><scene result=\"yes\"><thing number=\"@one\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing></scene></script></structure><example name=\"'small boy'\"><script segments=\"s,m,or,l,b,o,y,|\"><sound sound=\"s\"/><sound sound=\"m\"/><sound sound=\"or\"/><sound sound=\"l\"/><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><scene result=\"yes\"><thing id=\"x24\" number=\"@one\" t_type=\"@person\"><prop size=\"@small\"/><prop age=\"@young\"/><prop gender=\"@male\"/></thing></scene></script></example><example name=\"'boy runs'\"><script segments=\"b,o,y,r,u,n,z,|\"><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"r\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"z\"/><scene result=\"yes\" s_type=\"@go\" time=\"@now\"><thing id=\"x24\" m_role=\"@agent\" number=\"@one\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing><manner speed=\"@fast\"/></scene></script></example><example name=\"Ex: boiled egg\"><script segments=\"b,o,y,l,d,e,g,|\"><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"l\"/><sound sound=\"d\"/><sound sound=\"e\"/><sound sound=\"g\"/><scene act=\"false\" result=\"yes\"><thing t_type=\"@egg\"><prop cooking=\"@boiled\"/></thing></scene></script></example><example name=\"Ex: boy in bed\"><script segments=\"b,o,y,i,n,b,e,d,|\"><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"i\"/><sound sound=\"n\"/><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"d\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" t_type=\"@person\"><place placeType=\"@in\"><thing number=\"@one\" t_type=\"@bed\"/></place><prop age=\"@young\"/><prop gender=\"@male\"/></thing></scene></script></example></learn><learn word=\"runs (no syntax)\"><structure><script description=\"when words describing an animate thing (top scene - not shown, as the child knows no other words at this stage) are followed by 'runs', the meaning (bottom scene) is an action scene of going,at time = @now with manner = @fast and the animate thing as the agent (doing the action)\" segments=\"r,u,n,z,|\"><sound sound=\"r\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"z\"/><scene domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing id=\"x24\" m_role=\"@agent\" number=\"@one\" t_type=\"@animate\"/><manner speed=\"@fast\"/></scene></script></structure><example name=\"EX: doggie runs\"><script segments=\"d,o,g,i,r,u,n,z,|\"><sound sound=\"d\"/><sound sound=\"o\"/><sound sound=\"g\"/><sound sound=\"i\"/><sound sound=\"r\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"z\"/><scene domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing m_role=\"@agent\" number=\"@one\" subsumes=\"x24\" t_type=\"@dog\"/><manner speed=\"@fast\"/></scene></script></example><example name=\"Ex: boy runs\"><script segments=\"b,o,y,r,u,n,z,|\"><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"r\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"z\"/><scene domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing id=\"x24\" m_role=\"@agent\" number=\"@one\" t_type=\"@animate\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing><manner speed=\"@fast\"/></scene></script></example></learn><learn word=\"GoToBed\"><structure><script description=\"The meaning is a scene in the mental domain, in which the speaker causes the listener to intend to go along a path which ends in bed. This canned phrase can be learnt with no syntax, just like a word.\" segments=\"g,oe,t,u,b,e,d,|\"><sound sound=\"g\"/><sound sound=\"oe\"/><sound sound=\"t\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"d\"/><scene actMode=\"@does\" domain=\"mental\" s_type=\"@cause\"><thing c_role=\"@speaker\" t_type=\"@person\"/><scene actMode=\"@intend\" domain=\"spatial\" s_type=\"@go\"><thing c_role=\"@listener\" t_type=\"@person\"/><path pathType=\"@to\"><place placeType=\"@in\"><thing t_type=\"@bed\"/></place></path></scene></scene></script></structure><example name=\"Ex: gotobed\"><script description=\"an example in which somebody else is told to go to bed\" segments=\"z,a,k,g,oe,t,u,b,e,d,|\"><sound sound=\"z\"/><sound sound=\"a\"/><sound sound=\"k\"/><sound sound=\"g\"/><sound sound=\"oe\"/><sound sound=\"t\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"d\"/><scene actMode=\"@does\" domain=\"mental\" s_type=\"@cause\"><thing c_role=\"@speaker\" identity=\"@daddy\" t_type=\"@person\"/><scene actMode=\"@intend\" domain=\"spatial\" s_type=\"@go\"><thing c_role=\"@listener\" identity=\"@zack\" t_type=\"@person\"/><path pathType=\"@to\"><place placeType=\"@in\"><thing t_type=\"@bed\"/></place></path></scene></scene></script></example><example name=\"Ex: gotobed 2\"><script description=\"an example in which the subject is told to go to bed\" segments=\"g,oe,t,u,b,e,d,n,ou,|\"><sound sound=\"g\"/><sound sound=\"oe\"/><sound sound=\"t\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"d\"/><sound sound=\"n\"/><sound sound=\"ou\"/><scene actMode=\"@does\" domain=\"mental\" s_type=\"@cause\"><thing c_role=\"@speaker\" identity=\"@mummy\" t_type=\"@person\"/><scene actMode=\"@intend\" domain=\"spatial\" s_type=\"@go\"><thing c_role=\"@listener\" identity=\"@me\" t_type=\"@person\"/><path pathType=\"@to\"><place placeType=\"@in\"><thing t_type=\"@bed\"/></place></path></scene></scene></script></example></learn><learn word=\"howjado\"><structure><script description=\"The meaning of 'howjado' is a social scene at time @now, in which the speaker greets the listener.\" segments=\"h,ou,j,u,d,oo,|\"><sound sound=\"h\"/><sound sound=\"ou\"/><sound sound=\"j\"/><sound sound=\"u\"/><sound sound=\"d\"/><sound sound=\"oo\"/><scene actType=\"@greet\" domain=\"social\" time=\"@now\"><thing c_role=\"@speaker\" m_role=\"@agent\"/><thing c_role=\"@listener\" m_role=\"@patient\"/></scene></script></structure><example name=\"Ex: well howjado\"><script segments=\"w,e,l,h,ou,j,u,d,oo,|\"><sound sound=\"w\"/><sound sound=\"e\"/><sound sound=\"l\"/><sound sound=\"h\"/><sound sound=\"ou\"/><sound sound=\"j\"/><sound sound=\"u\"/><sound sound=\"d\"/><sound sound=\"oo\"/><scene actType=\"@greet\" domain=\"social\" time=\"@now\"><thing c_role=\"@speaker\" identity=\"@daddy\" m_role=\"@agent\"/><thing c_role=\"@listener\" identity=\"@al\" m_role=\"@patient\"/></scene></script></example><example name=\"Ex: howjado john\"><script segments=\"h,ou,j,u,d,oo,j,o,n,|\"><sound sound=\"h\"/><sound sound=\"ou\"/><sound sound=\"j\"/><sound sound=\"u\"/><sound sound=\"d\"/><sound sound=\"oo\"/><sound sound=\"j\"/><sound sound=\"o\"/><sound sound=\"n\"/><scene actType=\"@greet\" domain=\"social\" time=\"@now\"><thing c_role=\"@speaker\" identity=\"@sally\" m_role=\"@agent\"/><thing c_role=\"@listener\" identity=\"@john\" m_role=\"@patient\"/></scene></script></example></learn><learn word=\"him\"><structure><script description=\"The meaning of 'him' is a single person in a patient role in some action scene, who the listener can identify (choice @defined) and who is not the speaker or the listener (c_role @other)\" segments=\"h,i,m,|\"><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"m\"/><scene act=\"false\" result=\"yes\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@patient\" number=\"@one\"><prop gender=\"@male\"/></thing></scene></script></structure><example name=\"Ex: the girl hits him\"><script segments=\"th,u,g,ur,l,h,i,t,s,h,i,m,|\"><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"ur\"/><sound sound=\"l\"/><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"t\"/><sound sound=\"s\"/><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"m\"/><scene act=\"true\" actType=\"@hit\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@female\"/></thing><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\"><prop gender=\"@male\"/></thing></scene></script></example><example name=\"Ex: he hugs him\"><script segments=\"h,ee,h,u,g,s,h,i,m,|\"><sound sound=\"h\"/><sound sound=\"ee\"/><sound sound=\"h\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"s\"/><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"m\"/><scene act=\"true\" actType=\"@hug\" domain=\"social\" result=\"yes\" time=\"@now\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\"><prop gender=\"@male\"/></thing></scene></script></example><example name=\"Ex: the boys meet him\"><script segments=\"th,u,b,o,y,z,m,ee,t,h,i,m,|\"><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"z\"/><sound sound=\"m\"/><sound sound=\"ee\"/><sound sound=\"t\"/><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"m\"/><scene act=\"true\" actType=\"@meet\" domain=\"social\" result=\"yes\" time=\"@now\"><thing choice=\"@defined\" m_role=\"@agent\" number=\"@many\" subsumes=\"x1\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\"><prop gender=\"@male\"/></thing></scene></script></example></learn><learn word=\"she\"><structure><script description=\"The meaning of 'she' is a single female person in an agent role in some action, who the listener can identify (choice @defined) and who is not the speaker or the listener (c_role @other)\" segments=\"sh,ee,|\"><sound sound=\"sh\"/><sound sound=\"ee\"/><scene act=\"false\" result=\"yes\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\"><prop gender=\"@female\"/></thing></scene></script></structure><example name=\"Ex: she fell\"><script segments=\"sh,ee,f,e,l,|\"><sound sound=\"sh\"/><sound sound=\"ee\"/><sound sound=\"f\"/><sound sound=\"e\"/><sound sound=\"l\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@past\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x26\"><prop gender=\"@female\"/></thing><path direction=\"@down\"/></scene></script></example><example name=\"Ex: she ate a pie\"><script segments=\"sh,ee,ai,t,u,p,ie,|\"><sound sound=\"sh\"/><sound sound=\"ee\"/><sound sound=\"ai\"/><sound sound=\"t\"/><sound sound=\"u\"/><sound sound=\"p\"/><sound sound=\"ie\"/><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@female\"/></thing><thing choice=\"@any\" m_role=\"@patient\" subsumes=\"x2\" t_type=\"@pie\"/></scene></script></example><example name=\"Ex: she hugs him\"><script segments=\"sh,ee,h,u,g,s,h,i,m,|\"><sound sound=\"sh\"/><sound sound=\"ee\"/><sound sound=\"h\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"s\"/><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"m\"/><scene act=\"true\" actType=\"@hug\" domain=\"social\" result=\"yes\" time=\"@now\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@female\"/></thing><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\"><prop gender=\"@male\"/></thing></scene></script></example></learn><learn word=\"apple\"><structure><script description=\"The meaning of 'apple' is a single thing of type @apple\" segments=\"a,p,u,l,|\"><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" t_type=\"@apple\"/></scene></script></structure><example name=\"Ex: an apple on the table\"><script segments=\"u,n,a,p,u,l,o,n,th,u,t,ai,b,u,l,|\"><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"t\"/><sound sound=\"ai\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\"><thing choice=\"@any\" number=\"@one\" subsumes=\"x_1\" t_type=\"@apple\"><place placeType=\"@on\"><thing choice=\"@defined\" number=\"@one\" subsumes=\"x_2\" t_type=\"@table\"/></place></thing></scene></script></example><example name=\"Ex: green apple\"><script segments=\"g,r,ee,n,a,p,u,l,|\"><sound sound=\"g\"/><sound sound=\"r\"/><sound sound=\"ee\"/><sound sound=\"n\"/><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@apple\"><prop colour=\"@green\"/></thing></scene></script></example><example name=\"Ex: johns apple\"><script segments=\"j,o,n,s,a,p,u,l,|\"><sound sound=\"j\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"s\"/><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_2\" t_type=\"@apple\"><place domain=\"possession\" placeType=\"@of\"><thing identity=\"@john\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop gender=\"@male\"/></thing></place></thing></scene></script></example></learn><learn word=\"ben\"><structure><script description=\"The meaning of 'ben' is a single  male person with identity = @ben. This is like a pointer to other representations of Ben in the brain.\" segments=\"b,e,n,|\"><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"n\"/><scene act=\"false\" result=\"yes\"><thing identity=\"@ben\" number=\"@one\" t_type=\"@person\"><prop gender=\"@male\"/></thing></scene></script></structure><example name=\"Ex: I meet ben\"><script segments=\"ie,m,ee,t,b,e,n,|\"><sound sound=\"ie\"/><sound sound=\"m\"/><sound sound=\"ee\"/><sound sound=\"t\"/><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"n\"/><scene act=\"true\" actType=\"@meet\" domain=\"social\" result=\"yes\" time=\"@now\"><thing c_role=\"@speaker\" m_role=\"@agent\" subsumes=\"x1\" t_type=\"@person\"/><thing identity=\"@ben\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@person\"><prop gender=\"@male\"/></thing></scene></script></example><example name=\"Ex: ben runs\"><script segments=\"b,e,n,r,u,n,z,|\"><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"n\"/><sound sound=\"r\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"z\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing identity=\"@ben\" m_role=\"@agent\" number=\"@one\" subsumes=\"x24\" t_type=\"@person\"><prop gender=\"@male\"/></thing><manner speed=\"@fast\"/></scene></script></example><example name=\"Ex: ben gave anna the shoes\"><script segments=\"b,e,n,g,ai,v,a,n,u,th,u,sh,oo,s,|\"><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"n\"/><sound sound=\"g\"/><sound sound=\"ai\"/><sound sound=\"v\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"sh\"/><sound sound=\"oo\"/><sound sound=\"s\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing identity=\"@ben\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><scene act=\"true\" s_type=\"@go\"><thing choice=\"@defined\" m_role=\"@agent\" number=\"@many\" subsumes=\"x_1\" t_type=\"@shoe\"/><path><place domain=\"possession\" placeType=\"@of\"><thing identity=\"@anna\" number=\"@one\" subsumes=\"x_2\" t_type=\"@person\"><prop gender=\"@female\"/></thing></place></path></scene></scene></script></example></learn><learn word=\"f_storytime\"><structure><script description=\"This is a frame, or learned situation. Some frames are learned before language, and are used to define roles (such as story teller and hearer) and to understand things and actions. The frame has the following scenes: (1) The story teller holds a book, which is the source of the story; (2) the story teller tells the story to the hearer; (3) the teller and the hearer look at pictures in the book\"><scene actType=\"@hold\"><thing m_role=\"@teller\"/><thing m_role=\"@story_source\" t_type=\"@book\"/></scene><scene actType=\"@tell\"><thing m_role=\"@teller\"/><thing m_role=\"@hearer\"/><scene s_type=\"@describes\"/></scene><scene actType=\"@see\"><thing m_role=\"@agent\"><thing m_role=\"@teller\"/><thing m_role=\"@hearer\"/></thing><thing t_type=\"@picture\"><place placeType=\"@in\"><thing m_role=\"@story_source\" t_type=\"@book\"/></place><scene s_type=\"@describes\"/></thing></scene></script></structure><example name=\"Ex: story_1\"><script description=\"This is a frame, or learned situation. Some frames are learned before language, and are used to define roles (such as story teller and hearer) and to understand things and actions. The frame has the following scenes: (1) The story teller holds a book, which is the source of the story; (2) the story teller tells the story to the hearer; (3) the teller and the hearer look at pictures in the book\"><scene actType=\"@hold\"><thing identity=\"@mummy\" m_role=\"@teller\"/><thing identity=\"@humptydumpty\" m_role=\"@story_source\" t_type=\"@book\"/></scene><scene actType=\"@tell\"><thing identity=\"@mummy\" m_role=\"@teller\"/><thing identity=\"@me\" m_role=\"@hearer\"/><scene s_type=\"@describes\"><thing identity=\"@humptydumpty\"/></scene></scene><scene actType=\"@see\"><thing m_role=\"@agent\"><thing identity=\"@mummy\" m_role=\"@teller\"/><thing identity=\"@me\" m_role=\"@hearer\"/></thing><thing t_type=\"@picture\"><place placeType=\"@in\"><thing identity=\"@humptydumpty\" m_role=\"@story_source\" t_type=\"@book\"/></place><scene s_type=\"@describes\"><thing identity=\"@humptydumpty\"/></scene></thing></scene></script></example><example name=\"Ex: story_2\"><script description=\"This is a frame, or learned situation. Some frames are learned before language, and are used to define roles (such as story teller and hearer) and to understand things and actions. The frame has the following scenes: (1) The story teller holds a book, which is the source of the story; (2) the story teller tells the story to the hearer; (3) the teller and the hearer look at pictures in the book\"><scene actType=\"@hold\"><thing identity=\"@daddy\" m_role=\"@teller\"/><thing identity=\"@redridinghood\" m_role=\"@story_source\" t_type=\"@book\"/></scene><scene actType=\"@tell\"><thing identity=\"@daddy\" m_role=\"@teller\"/><thing identity=\"@me\" m_role=\"@hearer\"/><scene s_type=\"@describes\"><thing identity=\"@redridinghood\"/></scene></scene><scene actType=\"@see\"><thing m_role=\"@agent\"><thing identity=\"@daddy\" m_role=\"@teller\"/><thing identity=\"@me\" m_role=\"@hearer\"/></thing><thing t_type=\"@picture\"><place placeType=\"@in\"><thing identity=\"@redridinghood\" m_role=\"@story_source\" t_type=\"@book\"/></place><scene s_type=\"@describes\"/></thing></scene></script></example></learn></stage><stage cycleNo=\"0\" name=\"Two-to-three word stage\"><learn word=\"runs\"><structure><script description=\"when words describing an animate thing (top scene) are followed by 'runs', the meaning (bottom scene) is an action scene of going,at time = @now with manner = @fast and the animate thing as the agent (doing the action)\" segments=\"r,u,n,z,|\"><scene><thing number=\"@one\" subsumes=\"x24\" t_type=\"@animate\"/></scene><sound sound=\"r\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"z\"/><scene domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing id=\"x24\" m_role=\"@agent\" number=\"@one\" t_type=\"@animate\"/><manner speed=\"@fast\"/></scene></script></structure><example name=\"Ex: doggie runs\"><script segments=\"d,o,g,i,|\" unifyOrder=\"doggie\"><sound sound=\"d\"/><sound sound=\"o\"/><sound sound=\"g\"/><sound sound=\"i\"/><sound sound=\"r\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"z\"/><scene domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing m_role=\"@agent\" number=\"@one\" subsumes=\"x24\" t_type=\"@dog\"/><manner speed=\"@fast\"/></scene></script></example><example name=\"Ex: boy runs\"><script segments=\"b,o,y,|\" unifyOrder=\"boy\"><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"r\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"z\"/><scene domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@now\"><thing id=\"x24\" m_role=\"@agent\" number=\"@one\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing><manner speed=\"@fast\"/></scene></script></example></learn><learn word=\"eats\"><structure><script description=\"when words describing a single person (top scene) are followed by 'eats', and then followed by words describing food (middle scene), the meaning (bottom scene) is an action scene of eating, at time = @now with the person as agent (doing the action) and the food as patient.\" segments=\"ee,t,s,|\"><scene act=\"false\"><thing m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"/></scene><sound sound=\"ee\"/><sound sound=\"t\"/><sound sound=\"s\"/><scene act=\"false\"><thing m_role=\"@patient\" subsumes=\"x2\" t_type=\"@food\"/></scene><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing id=\"x1\" m_role=\"@agent\" number=\"@one\" t_type=\"@person\"/><thing id=\"x2\" m_role=\"@patient\" t_type=\"@food\"/></scene></script></structure><example name=\"Ex: al eating\"><script segments=\"a,l,|b,u,n,ar,n,u,|u,|\" unifyOrder=\"al banana a\"><sound sound=\"a\"/><sound sound=\"l\"/><sound sound=\"ee\"/><sound sound=\"t\"/><sound sound=\"s\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"ar\"/><sound sound=\"n\"/><sound sound=\"u\"/><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing identity=\"@al\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><thing choice=\"@any\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@banana\"/></scene></script></example><example name=\"Ex: he eats a cherry\"><script segments=\"h,ee,|ch,e,r,i,|u,|\" unifyOrder=\"he cherry a\"><sound sound=\"h\"/><sound sound=\"ee\"/><sound sound=\"ee\"/><sound sound=\"t\"/><sound sound=\"s\"/><sound sound=\"u\"/><sound sound=\"ch\"/><sound sound=\"e\"/><sound sound=\"r\"/><sound sound=\"i\"/><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><thing choice=\"@any\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@cherry\"/></scene></script></example><example name=\"Ex: anna eats the pie\"><script segments=\"a,n,u,|p,ie,|th,u,|\" unifyOrder=\"anna pie the\"><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"ee\"/><sound sound=\"t\"/><sound sound=\"s\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"p\"/><sound sound=\"ie\"/><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@now\"><thing identity=\"@anna\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@female\"/></thing><thing choice=\"@defined\" m_role=\"@patient\" subsumes=\"x2\" t_type=\"@pie\"/></scene></script></example></learn><learn word=\"gave\"><structure><script description=\"when words describing a person (top scene) are followed by 'gave' , and then followed by words describing a person (second scene - the recipient), and followed by words describing the thing (third scene - the gift), the meaning (bottom action scene) is that at time @past, the first person or people causes the gift to go along a path which ends in a 'place' which is the possession of the recipient.\" segments=\"g,ai,v,|\"><scene act=\"false\"><thing subsumes=\"x1\" t_type=\"@person\"/></scene><sound sound=\"g\"/><sound sound=\"ai\"/><sound sound=\"v\"/><scene act=\"false\"><thing subsumes=\"x_2\" t_type=\"@person\"/></scene><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing id=\"x1\" m_role=\"@agent\" t_type=\"@person\"/><scene act=\"true\" s_type=\"@go\"><thing id=\"x_1\" m_role=\"@agent\"/><path><place domain=\"possession\" placeType=\"@of\"><thing id=\"x_2\" t_type=\"@person\"/></place></path></scene></scene></script></structure><example name=\"Ex: john gave tim the biscuit\"><script segments=\"j,o,n,|t,i,m,|b,i,s,k,i,t,|th,u,|\" unifyOrder=\"john tim biscuit the\"><sound sound=\"j\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"g\"/><sound sound=\"ai\"/><sound sound=\"v\"/><sound sound=\"t\"/><sound sound=\"i\"/><sound sound=\"m\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"i\"/><sound sound=\"s\"/><sound sound=\"k\"/><sound sound=\"i\"/><sound sound=\"t\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing identity=\"@john\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><scene act=\"true\" s_type=\"@go\"><thing choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x_1\" t_type=\"@biscuit\"/><path><place domain=\"possession\" placeType=\"@of\"><thing identity=\"@tim\" number=\"@one\" subsumes=\"x_2\" t_type=\"@person\"><prop gender=\"@male\"/></thing></place></path></scene></scene></script></example><example name=\"Ex: anna gave the boys  a green apple\"><script segments=\"a,n,u,|b,o,y,z,|a,p,u,l,|g,r,ee,n,|th,u,|\" unifyOrder=\"anna boys apple green the\"><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"ai\"/><sound sound=\"v\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"z\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"r\"/><sound sound=\"ee\"/><sound sound=\"n\"/><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing identity=\"@anna\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@female\"/></thing><scene act=\"true\" s_type=\"@go\"><thing choice=\"@any\" m_role=\"@agent\" number=\"@one\" subsumes=\"x_1\" t_type=\"@apple\"><prop colour=\"@green\"/></thing><path><place domain=\"possession\" placeType=\"@of\"><thing choice=\"@defined\" number=\"@many\" subsumes=\"x_2\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing></place></path></scene></scene></script></example><example name=\"Ex: the girls gave ben a ball\"><script segments=\"g,ur,l,z,|b,e,n,|b,or,l,|th,u,|u,|\" unifyOrder=\"girls ben ball the a\"><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"ur\"/><sound sound=\"l\"/><sound sound=\"z\"/><sound sound=\"g\"/><sound sound=\"ai\"/><sound sound=\"v\"/><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"or\"/><sound sound=\"l\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing choice=\"@defined\" m_role=\"@agent\" number=\"@many\" subsumes=\"x1\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@female\"/></thing><scene act=\"true\" s_type=\"@go\"><thing choice=\"@any\" m_role=\"@agent\" number=\"@one\" subsumes=\"x_1\" t_type=\"@ball\"/><path><place domain=\"possession\" placeType=\"@of\"><thing identity=\"@ben\" number=\"@one\" subsumes=\"x_2\" t_type=\"@person\"><prop gender=\"@male\"/></thing></place></path></scene></scene></script></example><example name=\"Ex: ben gave anna the shoes\"><script segments=\"b,e,n,|a,n,u,|sh,oo,s,|th,u,|\" unifyOrder=\"ben anna shoes the\"><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"n\"/><sound sound=\"g\"/><sound sound=\"ai\"/><sound sound=\"v\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"sh\"/><sound sound=\"oo\"/><sound sound=\"s\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@cause\" time=\"@past\"><thing identity=\"@ben\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><scene act=\"true\" s_type=\"@go\"><thing choice=\"@defined\" m_role=\"@agent\" number=\"@many\" subsumes=\"x_1\" t_type=\"@shoe\"/><path><place domain=\"possession\" placeType=\"@of\"><thing identity=\"@anna\" number=\"@one\" subsumes=\"x_2\" t_type=\"@person\"><prop gender=\"@female\"/></thing></place></path></scene></scene></script></example></learn><learn word=\"green\"><structure><script description=\"when 'green' is followed by words describing a thing (top scene), the meaning (bottom scene) is the thing with property colour= @green\" segments=\"g,r,ee,n,|\"><sound sound=\"g\"/><sound sound=\"r\"/><sound sound=\"ee\"/><sound sound=\"n\"/><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"false\" result=\"yes\"><thing id=\"x_1\"><prop colour=\"@green\"/></thing></scene></script></structure><example name=\"Ex: green apple\"><script segments=\"a,p,u,l,|\" unifyOrder=\"apple\"><sound sound=\"g\"/><sound sound=\"r\"/><sound sound=\"ee\"/><sound sound=\"n\"/><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@apple\"><prop colour=\"@green\"/></thing></scene></script></example><example name=\"Ex: green hat\"><script segments=\"h,a,t,|\" unifyOrder=\"hat\"><sound sound=\"g\"/><sound sound=\"r\"/><sound sound=\"ee\"/><sound sound=\"n\"/><sound sound=\"h\"/><sound sound=\"a\"/><sound sound=\"t\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@hat\"><prop colour=\"@green\"/></thing></scene></script></example><example name=\"Ex: green bananas\"><script segments=\"b,u,n,ar,n,u,z,|\" unifyOrder=\"bananas\"><sound sound=\"g\"/><sound sound=\"r\"/><sound sound=\"ee\"/><sound sound=\"n\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"ar\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"z\"/><scene act=\"false\" result=\"yes\"><thing number=\"@many\" subsumes=\"x_1\" t_type=\"@banana\"><prop colour=\"@green\"/></thing></scene></script></example></learn><learn word=\"his\"><structure><script description=\"When 'his' is followed by words describing a thing (top scene), the meaning (bottom scene) is the thing in a 'place' which is the possession of a single male person, which the listener can identify (choise = @defined) with c_role @other (i.e not the speaker or the listener)\" segments=\"h,i,z,|\"><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"z\"/><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"false\" result=\"yes\"><thing id=\"x_1\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@other\" choice=\"@defined\" number=\"@one\"><prop gender=\"@male\"/></thing></place></thing></scene></script></structure><example name=\"Ex: his banana\"><script segments=\"b,u,n,ar,n,u,|\" unifyOrder=\"banana\"><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"z\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"ar\"/><sound sound=\"n\"/><sound sound=\"u\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@banana\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@other\" choice=\"@defined\" number=\"@one\"><prop gender=\"@male\"/></thing></place></thing></scene></script></example><example name=\"Ex: his chair\"><script segments=\"ch,ai,r,|\" unifyOrder=\"chair\"><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"z\"/><sound sound=\"ch\"/><sound sound=\"ai\"/><sound sound=\"r\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@chair\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@other\" choice=\"@defined\" number=\"@one\"><prop gender=\"@male\"/></thing></place></thing></scene></script></example></learn><learn word=\"fell\"><structure><script description=\"when words describing a thing (top scene) are followed by 'fell', the meaning (bottom scene) is an action scene of going, at time = @past, with a path of direction @down and the thing as agent (doing the action)\" segments=\"f,e,l,|\"><scene act=\"false\"><thing subsumes=\"x26\"/></scene><sound sound=\"f\"/><sound sound=\"e\"/><sound sound=\"l\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@past\"><thing id=\"x26\" m_role=\"@agent\"/><path direction=\"@down\"/></scene></script></structure><example name=\"Ex: the apple fell\"><script segments=\"a,p,u,l,|th,u,|\" unifyOrder=\"apple the\"><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><sound sound=\"f\"/><sound sound=\"e\"/><sound sound=\"l\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@past\"><thing choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x26\" t_type=\"@apple\"/><path direction=\"@down\"/></scene></script></example><example name=\"Ex: she fell\"><script segments=\"sh,ee,|\" unifyOrder=\"she\"><sound sound=\"sh\"/><sound sound=\"ee\"/><sound sound=\"f\"/><sound sound=\"e\"/><sound sound=\"l\"/><scene act=\"true\" domain=\"spatial\" result=\"yes\" s_type=\"@go\" time=\"@past\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x26\"><prop gender=\"@female\"/></thing><path direction=\"@down\"/></scene></script></example></learn><learn word=\"hugs\"><structure><script description=\"when words describing a single person (top scene) are followed by 'hugs', and then followed by words describing another person (middle scene), the meaning (bottom scene) is an action scene of hugging, at time = @now with the first person as agent (doing the action) and the second person as patient.\" segments=\"h,u,g,s,|\"><scene act=\"false\"><thing number=\"@one\" subsumes=\"x1\" t_type=\"@person\"/></scene><sound sound=\"h\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"s\"/><scene act=\"false\"><thing m_role=\"@patient\" subsumes=\"x2\"/></scene><scene act=\"true\" actType=\"@hug\" domain=\"social\" result=\"yes\" time=\"@now\"><thing id=\"x1\" m_role=\"@agent\" number=\"@one\" t_type=\"@person\"/><thing id=\"x2\" m_role=\"@patient\"/></scene></script></structure><example name=\"Ex: she hugs him\"><script segments=\"sh,ee,|h,i,m,|\" unifyOrder=\"she him\"><sound sound=\"sh\"/><sound sound=\"ee\"/><sound sound=\"h\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"s\"/><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"m\"/><scene act=\"true\" actType=\"@hug\" domain=\"social\" result=\"yes\" time=\"@now\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@female\"/></thing><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@person\"><prop gender=\"@male\"/></thing></scene></script></example><example name=\"Ex: anna hugs john\"><script segments=\"a,n,u,|j,o,n,|\" unifyOrder=\"anna john\"><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"h\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"s\"/><sound sound=\"j\"/><sound sound=\"o\"/><sound sound=\"n\"/><scene act=\"true\" actType=\"@hug\" domain=\"social\" result=\"yes\" time=\"@now\"><thing identity=\"@anna\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@female\"/></thing><thing identity=\"@john\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@person\"><prop gender=\"@male\"/></thing></scene></script></example><example name=\"Ex: he hugs anna\"><script segments=\"h,ee,|a,n,u,|\" unifyOrder=\"he anna\"><sound sound=\"h\"/><sound sound=\"ee\"/><sound sound=\"h\"/><sound sound=\"u\"/><sound sound=\"g\"/><sound sound=\"s\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><scene act=\"true\" actType=\"@hug\" domain=\"social\" result=\"yes\" time=\"@now\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@agent\" number=\"@one\" subsumes=\"x1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><thing identity=\"@anna\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@person\"><prop gender=\"@female\"/></thing></scene></script></example></learn><learn word=\"cold\"><structure><script description=\"when 'cold' is followed by words describing a thing (top scene), the meaning (bottom scene) is the thing with property temperature (temp) = @cold.\" segments=\"k,oe,l,d,|\"><sound sound=\"k\"/><sound sound=\"oe\"/><sound sound=\"l\"/><sound sound=\"d\"/><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"false\" result=\"yes\"><thing id=\"x_1\"><prop temp=\"@cold\"/></thing></scene></script></structure><example name=\"Ex: cold fridge\"><script segments=\"f,r,i,j,|\" unifyOrder=\"fridge\"><sound sound=\"k\"/><sound sound=\"oe\"/><sound sound=\"l\"/><sound sound=\"d\"/><sound sound=\"f\"/><sound sound=\"r\"/><sound sound=\"i\"/><sound sound=\"j\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@fridge\"><prop temp=\"@cold\"/></thing></scene></script></example><example name=\"Ex: cold icecream\"><script segments=\"ie,s,k,r,ee,m,|\" unifyOrder=\"icecream\"><sound sound=\"k\"/><sound sound=\"oe\"/><sound sound=\"l\"/><sound sound=\"d\"/><sound sound=\"ie\"/><sound sound=\"s\"/><sound sound=\"k\"/><sound sound=\"r\"/><sound sound=\"ee\"/><sound sound=\"m\"/><scene act=\"false\" result=\"yes\"><thing subsumes=\"x_1\" t_type=\"@iceCream\"><prop temp=\"@cold\"/></thing></scene></script></example><example name=\"Ex: cold boy\"><script segments=\"b,o,y,|\" unifyOrder=\"boy\"><sound sound=\"k\"/><sound sound=\"oe\"/><sound sound=\"l\"/><sound sound=\"d\"/><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop age=\"@young\" temp=\"@cold\"/><prop gender=\"@male\"/></thing></scene></script></example></learn></stage><stage cycleNo=\"0\" name=\"Small word stage\"><learn word=\"my\"><structure><script description=\"When 'my' is followed by words describing a thing (top scene), the meaning (bottom scene) is the thing in a 'place' which is the possession of the speaker.\" segments=\"m,ie,|\"><sound sound=\"m\"/><sound sound=\"ie\"/><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"false\" result=\"yes\"><thing id=\"x_1\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@speaker\"/></place></thing></scene></script></structure><example name=\"Ex: my foot\"><script segments=\"f,oo,t,|\" unifyOrder=\"foot\"><sound sound=\"m\"/><sound sound=\"ie\"/><sound sound=\"f\"/><sound sound=\"oo\"/><sound sound=\"t\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@foot\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@speaker\"/></place></thing></scene></script></example><example name=\"Ex: my banana\"><script segments=\"b,u,n,ar,n,u,|\" unifyOrder=\"banana\"><sound sound=\"m\"/><sound sound=\"ie\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"ar\"/><sound sound=\"n\"/><sound sound=\"u\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@banana\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@speaker\"/></place></thing></scene></script></example><example name=\"Ex: my biscuit\"><script segments=\"b,i,s,k,i,t,|\" unifyOrder=\"biscuit\"><sound sound=\"m\"/><sound sound=\"ie\"/><sound sound=\"b\"/><sound sound=\"i\"/><sound sound=\"s\"/><sound sound=\"k\"/><sound sound=\"i\"/><sound sound=\"t\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@biscuit\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@speaker\"/></place></thing></scene></script></example></learn><learn word=\"on(thing)\"><structure><script description=\"When words describing some thing (top scene) are followed by 'on' and then  followed by words describing some other thing (middle scene), the meaning (bottom scene) is the first thing in a place which is on the second thing.\" segments=\"o,n,|\"><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><sound sound=\"o\"/><sound sound=\"n\"/><scene act=\"false\"><thing subsumes=\"x_2\"/></scene><scene act=\"false\" result=\"yes\"><thing id=\"x_1\"><place placeType=\"@on\"><thing id=\"x_2\"/></place></thing></scene></script></structure><example name=\"Ex: an apple on the table\"><script segments=\"a,p,u,l,|t,ai,b,u,l,|u,n,|th,u,|\" unifyOrder=\"apple table an the\"><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"t\"/><sound sound=\"ai\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\"><thing choice=\"@any\" number=\"@one\" subsumes=\"x_1\" t_type=\"@apple\"><place placeType=\"@on\"><thing choice=\"@defined\" number=\"@one\" subsumes=\"x_2\" t_type=\"@table\"/></place></thing></scene></script></example><example name=\"Ex: the hat on her head\"><script segments=\"h,a,t,|h,e,d,|th,u,|h,ur,|\" unifyOrder=\"hat head the her(poss)\"><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"h\"/><sound sound=\"a\"/><sound sound=\"t\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"h\"/><sound sound=\"ur\"/><sound sound=\"h\"/><sound sound=\"e\"/><sound sound=\"d\"/><scene act=\"false\" result=\"yes\"><thing choice=\"@defined\" number=\"@one\" subsumes=\"x_1\" t_type=\"@hat\"><place placeType=\"@on\"><thing number=\"@one\" subsumes=\"x_2\" t_type=\"@head\"><place domain=\"possession\" placeType=\"@of\"><thing c_role=\"@other\" choice=\"@defined\" number=\"@one\"><prop gender=\"@female\"/></thing></place></thing></place></thing></scene></script></example><example name=\"Ex: bananas on the bed\"><script segments=\"b,u,n,ar,n,u,z,|b,e,d,|th,u,|\" unifyOrder=\"bananas bed the\"><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"ar\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"z\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"d\"/><scene act=\"false\" result=\"yes\"><thing number=\"@many\" subsumes=\"x_1\" t_type=\"@banana\"><place placeType=\"@on\"><thing choice=\"@defined\" number=\"@one\" subsumes=\"x_2\" t_type=\"@bed\"/></place></thing></scene></script></example></learn><learn word=\"and\"><structure><script description=\"When words describing a first thing or things  (top scene) are followed by 'and', and then followed by words describing a second thing or things (middle scene), the meaning (bottom scene) is a composite plural thing consisting of all the previous things.\" segments=\"a,n,d,|\"><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"d\"/><scene act=\"false\"><thing subsumes=\"x_2\"/></scene><scene act=\"false\" result=\"yes\"><thing number=\"@many\"><thing id=\"x_1\"/><thing id=\"x_2\"/></thing></scene></script></structure><example name=\"Ex: shoes and hat\"><script segments=\"sh,oo,s,|h,a,t,|\" unifyOrder=\"shoes hat\"><sound sound=\"sh\"/><sound sound=\"oo\"/><sound sound=\"s\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"d\"/><sound sound=\"h\"/><sound sound=\"a\"/><sound sound=\"t\"/><scene act=\"false\" result=\"yes\"><thing number=\"@many\"><thing number=\"@many\" subsumes=\"x_1\" t_type=\"@shoe\"/><thing number=\"@one\" subsumes=\"x_2\" t_type=\"@hat\"/></thing></scene></script></example><example name=\"Ex: john and anna\"><script segments=\"j,o,n,|a,n,u,|\" unifyOrder=\"john anna\"><sound sound=\"j\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"d\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><scene act=\"false\" result=\"yes\"><thing number=\"@many\"><thing identity=\"@john\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop gender=\"@male\"/></thing><thing identity=\"@anna\" number=\"@one\" subsumes=\"x_2\" t_type=\"@person\"><prop gender=\"@female\"/></thing></thing></scene></script></example><example name=\"Ex: apple and banana\"><script segments=\"a,p,u,l,|b,u,n,ar,n,u,|\" unifyOrder=\"apple banana\"><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"d\"/><sound sound=\"b\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"ar\"/><sound sound=\"n\"/><sound sound=\"u\"/><scene act=\"false\" result=\"yes\"><thing number=\"@many\"><thing number=\"@one\" subsumes=\"x_1\" t_type=\"@apple\"/><thing number=\"@one\" subsumes=\"x_2\" t_type=\"@banana\"/></thing></scene></script></example></learn><learn word=\"who\"><structure><script description=\"when words describing some person (top scene) are followed by 'who' and then followed by words describing an action involving some person (middle scene), then the meaning (bottom scene) is that the first person has the same identity as the person in involved the action scene.\" segments=\"h,oo,|\"><scene act=\"false\"><thing identity=\"@x\" subsumes=\"x_1\" t_type=\"@person\"/></scene><sound sound=\"h\"/><sound sound=\"oo\"/><scene act=\"true\" subsumes=\"x_2\"><thing identity=\"@x\" t_type=\"@person\"/></scene><scene act=\"false\" result=\"yes\" s_type=\"@describes\"><thing id=\"x_1\" identity=\"@x\" t_type=\"@person\"/><scene act=\"true\" id=\"x_2\"><thing identity=\"@x\" t_type=\"@person\"/></scene></scene></script></structure><example name=\"Ex: girl who fell\"><script segments=\"g,ur,l,|f,e,l,|\" unifyOrder=\"girl fell\"><sound sound=\"g\"/><sound sound=\"ur\"/><sound sound=\"l\"/><sound sound=\"h\"/><sound sound=\"oo\"/><sound sound=\"f\"/><sound sound=\"e\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\" s_type=\"@describes\"><thing identity=\"@x\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@female\"/></thing><scene act=\"true\" domain=\"spatial\" s_type=\"@go\" subsumes=\"x_2\" time=\"@past\"><thing identity=\"@x\" m_role=\"@agent\" t_type=\"@person\"/><path direction=\"@down\"/></scene></scene></script></example><example name=\"Ex: girl who ate an apple\"><script segments=\"g,ur,l,|a,p,u,l,|u,n,|ai,t,|\" unifyOrder=\"girl apple an ate\"><sound sound=\"g\"/><sound sound=\"ur\"/><sound sound=\"l\"/><sound sound=\"h\"/><sound sound=\"oo\"/><sound sound=\"ai\"/><sound sound=\"t\"/><sound sound=\"u\"/><sound sound=\"n\"/><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\" s_type=\"@describes\"><thing identity=\"@x\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@female\"/></thing><scene act=\"true\" actType=\"@eat\" domain=\"spatial\" s_type=\"@cause\" subsumes=\"x_2\" time=\"@past\"><thing identity=\"@x\" m_role=\"@agent\" t_type=\"@person\"/><thing choice=\"@any\" m_role=\"@patient\" number=\"@one\" subsumes=\"x2\" t_type=\"@apple\"/></scene></scene></script></example><example name=\"Ex: boy who saw me\"><script segments=\"b,o,y,|m,ee,|s,or,|\" unifyOrder=\"boy me saw(thing)\"><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"h\"/><sound sound=\"oo\"/><sound sound=\"s\"/><sound sound=\"or\"/><sound sound=\"m\"/><sound sound=\"ee\"/><scene act=\"false\" result=\"yes\" s_type=\"@describes\"><thing identity=\"@x\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing><scene act=\"true\" actType=\"@see\" domain=\"mental\" subsumes=\"x_2\" time=\"@past\"><thing identity=\"@x\" t_type=\"@person\"/><scene act=\"false\" subsumes=\"x_2\"><thing c_role=\"@speaker\" m_role=\"@patient\"/></scene></scene></scene></script></example></learn><learn word=\"to(act)\"><structure><script description=\"When words  describing any action (top scene) are followed by 'to', and then followed by words describing any thing (middle scene), then the meaning (bottom scene) is that the action takes place on a path which leads to a place at the thing.\" segments=\"t,uu,|\"><scene act=\"true\" subsumes=\"x_2\"/><sound sound=\"t\"/><sound sound=\"uu\"/><scene act=\"false\"><thing subsumes=\"x_1\"/></scene><scene act=\"true\" id=\"x_2\" result=\"yes\"><path pathType=\"@to\"><place placeType=\"@at\"><thing id=\"x_1\"/></place></path></scene></script></structure><example name=\"Ex: ben goes to the kitchen\"><script segments=\"b,e,n,|k,i,ch,i,n,|th,u,|g,oe,z,|\" unifyOrder=\"ben kitchen the goes\"><sound sound=\"b\"/><sound sound=\"e\"/><sound sound=\"n\"/><sound sound=\"g\"/><sound sound=\"oe\"/><sound sound=\"z\"/><sound sound=\"t\"/><sound sound=\"uu\"/><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"k\"/><sound sound=\"i\"/><sound sound=\"ch\"/><sound sound=\"i\"/><sound sound=\"n\"/><scene act=\"true\" domain=\"spatial\" s_type=\"@go\" subsumes=\"x_2\" time=\"@now\"><thing identity=\"@ben\" m_role=\"@agent\" number=\"@one\" subsumes=\"x26\" t_type=\"@person\"><prop gender=\"@male\"/></thing><path pathType=\"@to\"><place placeType=\"@at\"><thing choice=\"@defined\" number=\"@one\" subsumes=\"x_1\" t_type=\"@kitchen\"/></place></path></scene></script></example><example name=\"Ex: the boys ran to him\"><script segments=\"b,o,y,z,|h,i,m,|th,u,|r,a,n,|\" unifyOrder=\"boys him the ran\"><sound sound=\"th\"/><sound sound=\"u\"/><sound sound=\"b\"/><sound sound=\"o\"/><sound sound=\"y\"/><sound sound=\"z\"/><sound sound=\"r\"/><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"t\"/><sound sound=\"uu\"/><sound sound=\"h\"/><sound sound=\"i\"/><sound sound=\"m\"/><scene act=\"true\" domain=\"spatial\" s_type=\"@go\" subsumes=\"x_2\" time=\"@past\"><manner speed=\"@fast\"/><thing choice=\"@defined\" m_role=\"@agent\" number=\"@many\" subsumes=\"x24\" t_type=\"@person\"><prop age=\"@young\"/><prop gender=\"@male\"/></thing><path pathType=\"@to\"><place placeType=\"@at\"><thing c_role=\"@other\" choice=\"@defined\" m_role=\"@patient\" number=\"@one\" subsumes=\"x_1\"><prop gender=\"@male\"/></thing></place></path></scene></script></example></learn></stage><stage cycleNo=\"0\" name=\"Regular grammar\"><learn word=\"s (poss)\"><structure><script description=\"the -s suffix meaning possession. When words describing an animate thing (top scene) are followed by 's', and are then followed by words describing another thing (middle scene), the meaning (bottom scene) is the second thing in a place which is in the possession of the animate thing.\" segments=\"s,|\"><scene act=\"false\"><thing subsumes=\"x_1\" t_type=\"@animate\"/></scene><sound sound=\"s\"/><scene act=\"false\"><thing subsumes=\"x_2\"/></scene><scene act=\"false\" result=\"yes\"><thing id=\"x_2\"><place domain=\"possession\" placeType=\"@of\"><thing id=\"x_1\"/></place></thing></scene></script></structure><example name=\"Ex: annas chair\"><script segments=\"a,n,u,|ch,ai,r,|\" unifyOrder=\"anna chair\"><sound sound=\"a\"/><sound sound=\"n\"/><sound sound=\"u\"/><sound sound=\"s\"/><sound sound=\"ch\"/><sound sound=\"ai\"/><sound sound=\"r\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_2\" t_type=\"@chair\"><place domain=\"possession\" placeType=\"@of\"><thing identity=\"@anna\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop gender=\"@female\"/></thing></place></thing></scene></script></example><example name=\"Ex: johns apple\"><script segments=\"j,o,n,|a,p,u,l,|\" unifyOrder=\"john apple\"><sound sound=\"j\"/><sound sound=\"o\"/><sound sound=\"n\"/><sound sound=\"s\"/><sound sound=\"a\"/><sound sound=\"p\"/><sound sound=\"u\"/><sound sound=\"l\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_2\" t_type=\"@apple\"><place domain=\"possession\" placeType=\"@of\"><thing identity=\"@john\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop gender=\"@male\"/></thing></place></thing></scene></script></example><example name=\"Ex: zacks foot\"><script segments=\"z,a,k,|f,oo,t,|\" unifyOrder=\"zack foot\"><sound sound=\"z\"/><sound sound=\"a\"/><sound sound=\"k\"/><sound sound=\"s\"/><sound sound=\"f\"/><sound sound=\"oo\"/><sound sound=\"t\"/><scene act=\"false\" result=\"yes\"><thing number=\"@one\" subsumes=\"x_2\" t_type=\"@foot\"><place domain=\"possession\" placeType=\"@of\"><thing identity=\"@zack\" number=\"@one\" subsumes=\"x_1\" t_type=\"@person\"><prop gender=\"@male\"/></thing></place></thing></scene></script></example></learn></stage></learning></model>";
	private static String menuData = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?><menuItem_0 name=\"topMenu\"><menuItem_1 name=\"Help\"><menuItem_2 name=\"Getting Started\"><menuItem_3 name=\"How to Use this Model\"/><menuItem_3 name=\"The Automatic Learner\"/><menuItem_3 name=\"Looking at Feature Structures\"/><menuItem_3 name=\"First Example of Learning\"/><menuItem_3 name=\"First Example of Productive Language\"/></menuItem_2><menuItem_2 name=\"Menus\"><menuItem_3 name=\"Help\"/><menuItem_3 name=\"Words\"/><menuItem_3 name=\"Sentences\"/><menuItem_3 name=\"Learning\"/><menuItem_3 name=\"Model\"/></menuItem_2><menuItem_2 name=\"Buttons\"><menuItem_3 name=\"Auto-Learn\"/><menuItem_3 name=\"Generate\"/><menuItem_3 name=\"Understand\"/><menuItem_3 name=\"Learn\"/><menuItem_3 name=\"Step\"/><menuItem_3 name=\"Show/Hide\"/><menuItem_3 name=\"Compose\"/></menuItem_2><menuItem_2 name=\"How the model works\"><menuItem_3 name=\"Core Assumptions\"/><menuItem_3 name=\"Feature Structures\"/><menuItem_3 name=\"Operations on Feature Structures\"/><menuItem_3 name=\"Bayesian inference and learning\"/><menuItem_3 name=\"Generating sounds to say\"/><menuItem_3 name=\"Understanding sounds you hear\"/><menuItem_3 name=\"Learning words and other constructs\"/><menuItem_3 name=\"Scope of the model\"/></menuItem_2></menuItem_1><menuItem_1 name=\"Words\"><menuItem_2 name=\"A\"><menuItem_3 name=\"apple\"/><menuItem_3 name=\"a\"/><menuItem_3 name=\"and\"/><menuItem_3 name=\"ate\"/><menuItem_3 name=\"an\"/><menuItem_3 name=\"al\"/><menuItem_3 name=\"anna\"/></menuItem_2><menuItem_2 name=\"B\"><menuItem_3 name=\"bed\"/><menuItem_3 name=\"bath\"/><menuItem_3 name=\"boy\"/><menuItem_3 name=\"big\"/><menuItem_3 name=\"ball\"/><menuItem_3 name=\"banana\"/><menuItem_3 name=\"biscuit\"/><menuItem_3 name=\"bat\"/><menuItem_3 name=\"blue\"/><menuItem_3 name=\"bananas\"/><menuItem_3 name=\"boiled\"/><menuItem_3 name=\"boys\"/><menuItem_3 name=\"ben\"/></menuItem_2><menuItem_2 name=\"C\"><menuItem_3 name=\"cold\"/><menuItem_3 name=\"chair\"/><menuItem_3 name=\"cherry\"/></menuItem_2><menuItem_2 name=\"D\"><menuItem_3 name=\"drinks\"/><menuItem_3 name=\"drop\"/><menuItem_3 name=\"doggie\"/><menuItem_3 name=\"drank\"/><menuItem_3 name=\"drops\"/></menuItem_2><menuItem_2 name=\"E\"><menuItem_3 name=\"eats\"/><menuItem_3 name=\"egg\"/></menuItem_2><menuItem_2 name=\"F\"><menuItem_3 name=\"f_storytime\"/><menuItem_3 name=\"fell\"/><menuItem_3 name=\"fall\"/><menuItem_3 name=\"foot\"/><menuItem_3 name=\"fridge\"/><menuItem_3 name=\"falls\"/><menuItem_3 name=\"f_bathtime\"/></menuItem_2><menuItem_2 name=\"G\"><menuItem_3 name=\"goes\"/><menuItem_3 name=\"girl\"/><menuItem_3 name=\"green\"/><menuItem_3 name=\"girls\"/><menuItem_3 name=\"gives\"/><menuItem_3 name=\"go\"/><menuItem_3 name=\"give\"/><menuItem_3 name=\"gave\"/><menuItem_3 name=\"goToBed\"/></menuItem_2><menuItem_2 name=\"H\"><menuItem_3 name=\"her(poss)\"/><menuItem_3 name=\"his\"/><menuItem_3 name=\"hot\"/><menuItem_3 name=\"him\"/><menuItem_3 name=\"hear\"/><menuItem_3 name=\"howjado\"/><menuItem_3 name=\"head\"/><menuItem_3 name=\"hand\"/><menuItem_3 name=\"hat\"/><menuItem_3 name=\"he\"/><menuItem_3 name=\"her(pat)\"/><menuItem_3 name=\"hugs\"/><menuItem_3 name=\"heard\"/><menuItem_3 name=\"hits\"/></menuItem_2><menuItem_2 name=\"I\"><menuItem_3 name=\"in(thing)\"/><menuItem_3 name=\"in(act)\"/><menuItem_3 name=\"I\"/><menuItem_3 name=\"icecream\"/></menuItem_2><menuItem_2 name=\"J\"><menuItem_3 name=\"john\"/></menuItem_2><menuItem_2 name=\"K\"><menuItem_3 name=\"kitchen\"/></menuItem_2><menuItem_2 name=\"L\"><menuItem_3 name=\"little\"/></menuItem_2><menuItem_2 name=\"M\"><menuItem_3 name=\"milk\"/><menuItem_3 name=\"my\"/><menuItem_3 name=\"meet\"/><menuItem_3 name=\"me\"/></menuItem_2><menuItem_2 name=\"O\"><menuItem_3 name=\"on(thing)\"/><menuItem_3 name=\"on(act)\"/><menuItem_3 name=\"of\"/></menuItem_2><menuItem_2 name=\"P\"><menuItem_3 name=\"push\"/><menuItem_3 name=\"phoebe\"/><menuItem_3 name=\"pie\"/></menuItem_2><menuItem_2 name=\"R\"><menuItem_3 name=\"ran\"/><menuItem_3 name=\"red\"/><menuItem_3 name=\"runs\"/><menuItem_3 name=\"run\"/></menuItem_2><menuItem_2 name=\"S\"><menuItem_3 name=\"s(poss)\"/><menuItem_3 name=\"see(thing)\"/><menuItem_3 name=\"sponge\"/><menuItem_3 name=\"soap\"/><menuItem_3 name=\"shoe\"/><menuItem_3 name=\"saw(thing)\"/><menuItem_3 name=\"shoes\"/><menuItem_3 name=\"sees(thing)\"/><menuItem_3 name=\"school\"/><menuItem_3 name=\"she\"/></menuItem_2><menuItem_2 name=\"T\"><menuItem_3 name=\"think\"/><menuItem_3 name=\"towel\"/><menuItem_3 name=\"that\"/><menuItem_3 name=\"to(act)\"/><menuItem_3 name=\"told\"/><menuItem_3 name=\"table\"/><menuItem_3 name=\"they\"/><menuItem_3 name=\"tim\"/><menuItem_3 name=\"tell\"/><menuItem_3 name=\"them\"/><menuItem_3 name=\"thinks\"/><menuItem_3 name=\"thought\"/><menuItem_3 name=\"the\"/></menuItem_2><menuItem_2 name=\"W\"><menuItem_3 name=\"went\"/><menuItem_3 name=\"who\"/><menuItem_3 name=\"warm\"/></menuItem_2><menuItem_2 name=\"Y\"><menuItem_3 name=\"your\"/><menuItem_3 name=\"you\"/></menuItem_2><menuItem_2 name=\"Z\"><menuItem_3 name=\"zack\"/></menuItem_2></menuItem_1><menuItem_1 name=\"Sentences\"><menuItem_2 name=\"A\"><menuItem_3 name=\"anna hugs john\"/><menuItem_3 name=\"anna eats the pie\"/><menuItem_3 name=\"anna gave the boys a green apple\"/><menuItem_3 name=\"an apple on the table\"/><menuItem_3 name=\"apple and banana\"/><menuItem_3 name=\"al eats a banana\"/><menuItem_3 name=\"anna s chair\"/></menuItem_2><menuItem_2 name=\"B\"><menuItem_3 name=\"boy in bed\"/><menuItem_3 name=\"ben runs\"/><menuItem_3 name=\"bananas on the bed\"/><menuItem_3 name=\"ben gave anna the shoes\"/><menuItem_3 name=\"boy who saw me\"/><menuItem_3 name=\"boiled egg\"/><menuItem_3 name=\"ben goes to the kitchen\"/><menuItem_3 name=\"boys on a chair\"/><menuItem_3 name=\"boy runs\"/><menuItem_3 name=\"boy who anna hits\"/></menuItem_2><menuItem_2 name=\"C\"><menuItem_3 name=\"cold fridge\"/><menuItem_3 name=\"cold icecream\"/><menuItem_3 name=\"cold boy\"/></menuItem_2><menuItem_2 name=\"D\"><menuItem_3 name=\"'doggie runs'\"/></menuItem_2><menuItem_2 name=\"G\"><menuItem_3 name=\"green hat\"/><menuItem_3 name=\"green bananas\"/><menuItem_3 name=\"girl who fell\"/><menuItem_3 name=\"green apple\"/><menuItem_3 name=\"girl who ate an apple\"/></menuItem_2><menuItem_2 name=\"H\"><menuItem_3 name=\"his chair\"/><menuItem_3 name=\"he hugs anna\"/><menuItem_3 name=\"he eats a cherry\"/><menuItem_3 name=\"his banana\"/><menuItem_3 name=\"he hugs him\"/></menuItem_2><menuItem_2 name=\"I\"><menuItem_3 name=\"I saw him\"/><menuItem_3 name=\"I gave him my bat\"/><menuItem_3 name=\"I see my bat\"/><menuItem_3 name=\"I meet ben\"/></menuItem_2><menuItem_2 name=\"J\"><menuItem_3 name=\"john ate the pie\"/><menuItem_3 name=\"john s apple\"/><menuItem_3 name=\"john gave tim the biscuit\"/><menuItem_3 name=\"john and anna\"/><menuItem_3 name=\"john drops a biscuit\"/></menuItem_2><menuItem_2 name=\"M\"><menuItem_3 name=\"my banana\"/><menuItem_3 name=\"my biscuit\"/><menuItem_3 name=\"my foot\"/></menuItem_2><menuItem_2 name=\"P\"><menuItem_3 name=\"phoebe ate a red apple\"/></menuItem_2><menuItem_2 name=\"S\"><menuItem_3 name=\"she fell\"/><menuItem_3 name=\"shoes and hat\"/><menuItem_3 name=\"she sees zack\"/><menuItem_3 name=\"she hugs him\"/><menuItem_3 name=\"she ate a pie\"/></menuItem_2><menuItem_2 name=\"T\"><menuItem_3 name=\"tim and zack ate a red banana\"/><menuItem_3 name=\"the boys meet him\"/><menuItem_3 name=\"the boy runs\"/><menuItem_3 name=\"tim ate a banana on the table\"/><menuItem_3 name=\"the girls run\"/><menuItem_3 name=\"the boys ran to him\"/><menuItem_3 name=\"the hat on  her head\"/><menuItem_3 name=\"the apple fell\"/></menuItem_2><menuItem_2 name=\"Z\"><menuItem_3 name=\"zack s foot\"/><menuItem_3 name=\"zack hits the table\"/></menuItem_2></menuItem_1><menuItem_1 name=\"Learning\"><menuItem_2 name=\"One-word stage\"><menuItem_3 name=\"boy\"/><menuItem_3 name=\"runs (no syntax)\"/><menuItem_3 name=\"GoToBed\"/><menuItem_3 name=\"howjado\"/><menuItem_3 name=\"him\"/><menuItem_3 name=\"she\"/><menuItem_3 name=\"apple\"/><menuItem_3 name=\"ben\"/><menuItem_3 name=\"f_storytime\"/></menuItem_2><menuItem_2 name=\"Two-to-three word stage\"><menuItem_3 name=\"runs\"/><menuItem_3 name=\"eats\"/><menuItem_3 name=\"gave\"/><menuItem_3 name=\"green\"/><menuItem_3 name=\"his\"/><menuItem_3 name=\"fell\"/><menuItem_3 name=\"hugs\"/><menuItem_3 name=\"cold\"/></menuItem_2><menuItem_2 name=\"Small word stage\"><menuItem_3 name=\"my\"/><menuItem_3 name=\"on(thing)\"/><menuItem_3 name=\"and\"/><menuItem_3 name=\"who\"/><menuItem_3 name=\"to(act)\"/></menuItem_2><menuItem_2 name=\"Regular grammar\"><menuItem_3 name=\"s (poss)\"/></menuItem_2></menuItem_1><menuItem_1 name=\"Model\"><menuItem_2 name=\"Node Types\"><menuItem_3 name=\"manner\"/><menuItem_3 name=\"place\"/><menuItem_3 name=\"script\"/><menuItem_3 name=\"thing\"/><menuItem_3 name=\"scene\"/><menuItem_3 name=\"sound\"/><menuItem_3 name=\"path\"/><menuItem_3 name=\"prop\"/></menuItem_2><menuItem_2 name=\"A\"><menuItem_3 name=\"actMode\"/><menuItem_3 name=\"age\"/><menuItem_3 name=\"actType\"/><menuItem_3 name=\"act\"/></menuItem_2><menuItem_2 name=\"C\"><menuItem_3 name=\"choice\"/><menuItem_3 name=\"colour\"/><menuItem_3 name=\"cooking\"/><menuItem_3 name=\"c_role\"/></menuItem_2><menuItem_2 name=\"D\"><menuItem_3 name=\"direction\"/><menuItem_3 name=\"domain\"/></menuItem_2><menuItem_2 name=\"F\"><menuItem_3 name=\"frame\"/></menuItem_2><menuItem_2 name=\"G\"><menuItem_3 name=\"gender\"/></menuItem_2><menuItem_2 name=\"I\"><menuItem_3 name=\"identity\"/></menuItem_2><menuItem_2 name=\"M\"><menuItem_3 name=\"m_role\"/></menuItem_2><menuItem_2 name=\"N\"><menuItem_3 name=\"number\"/></menuItem_2><menuItem_2 name=\"P\"><menuItem_3 name=\"pathType\"/><menuItem_3 name=\"propType\"/><menuItem_3 name=\"placeType\"/></menuItem_2><menuItem_2 name=\"S\"><menuItem_3 name=\"sound\"/><menuItem_3 name=\"size\"/><menuItem_3 name=\"speed\"/><menuItem_3 name=\"s_type\"/></menuItem_2><menuItem_2 name=\"T\"><menuItem_3 name=\"t_type\"/><menuItem_3 name=\"time\"/><menuItem_3 name=\"temp\"/></menuItem_2></menuItem_1></menuItem_0>";
	
// true if this class can return real data
  public boolean isLoaded() {return loaded;}
  private boolean loaded = false;
  public void setLoaded(boolean loaded) {this.loaded = loaded;}

	public static InputStream getDataStream(int type) throws Exception
	{
		String data = getData(type);
		byte[] bytes = data.getBytes();
		return new ByteArrayInputStream(bytes);
	}

	private static String getData(int type)
	{
		if (type == 0) return modelData;
		if (type == 1) return wordData;
		if (type == 2) return sentenceData;
		if (type == 3) return learningData;
		if (type == 4) return guideData;
		if (type == 5) return menuData;
		return "";
	}

}
